<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2009-2010 Mads Sandberg Brun <msb@cs.au.dk>
 *  (c) 2009-2010 Peter Sandberg Brun <psb@cs.au.dk>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 *
 */

require_once(t3lib_extMgm::extPath($_EXTKEY).'class.tx_pure_rest.php');
require_once(t3lib_extMgm::extPath('pure').'class.tx_pure_cache.php');
require_once(PATH_t3lib.'class.t3lib_tceforms.php');
require_once(PATH_t3lib.'class.t3lib_tstemplate.php');
require_once(PATH_t3lib.'class.t3lib_div.php');
require_once(PATH_typo3.'sysext/lang/lang.php');

/**
 * Class that is used by "tx_pure_pichange" to add generated fields to the flexform.
 *
 * @author	Mads Sandberg Brun <msb@cs.au.dk>
 * @author	Peter Sandberg Brun <psb@cs.au.dk>
 * @package	TYPO3
 * @subpackage	tx_pure
 */
class tx_pure_addFieldsToFlexForm {

    public static $CacheTime = 86400;

	
	/**
	 * [Describe function...]
	 *
	 * @param	[type]		$$PA: ...
	 * @param	[type]		$fobj: ...
	 * @return	[type]		...
	 */
	function user_TemplateSelector(&$PA, &$fobj)
	{
		$pid = $PA['row']['pid'];
		$rootPath = '';
		$tmpl = $this->getTSTemplate($pid);
		if ($tmpl->setup['plugin.']['tx_pure_pi.']['templatesImagesFolder'] )
		{
			$rootPath = $tmpl->setup['plugin.']['tx_pure_pi.']['templatesImagesFolder'];
			$rootPath = $this->relativePath($rootPath);
		}

		$id = $PA['itemFormElName'] . '[templateImage]';

		$PA['fieldChangeFunc'][] = 'document.images["'.$id.'"].src = "' . $rootPath . '/" + this.value + ".png";';

		$forms = t3lib_div::makeInstance('t3lib_TCEforms');
		$items = $forms->initItemArray($PA['fieldConf']); //Localize
		$html = $forms->getSingleField_typeSelect(NULL, NULL,$PA['row'],$PA,$PA['fieldConf']['config'], $items,'[ INVALID VALUE ("%s") ]');
		$html = $forms->printNeededJSFunctions_top().$html.$forms->printNeededJSFunctions();

		$template = $PA['itemFormElValue'];
		if (!$template)
			$template = $this->defaultTemplateItem($PA, $forms);

		$currentImage =  $rootPath . '/'.$template.'.png';
		//add image element add below the selector. Update to selected value.
		$image = '<img id="'.$id.'" src="'.$currentImage.'" style="border:2px solid #D7DBE2;" />';
		return $html.'<br />Preview of template:<br />'.$image;
	}

    /**
	 * [Describe function...]
	 *
	 * @param	[type]		$$PA: ...
	 * @param	[type]		$forms: ...
	 * @return	[type]		...
	 */
	function defaultTemplateItem(&$PA, $forms)
	{
			// Getting the selector box items from the system
		$selItems = $forms->addSelectOptionsToItemArray($forms->initItemArray($PA['fieldConf']),$PA['fieldConf'],$forms->setTSconfig(NULL,$PA['row']),NULL);
		$selItems = $forms->addItems($selItems,$PA['fieldTSConfig']['addItems.']);
		if ($PA['fieldConf']['config']['itemsProcFunc'])
			$selItems = $forms->procItems($selItems,$PA['fieldTSConfig']['itemsProcFunc.'],$PA['fieldConf']['config'],NULL,$PA['row'],NULL);

		if ($selItems[0])
			return $selItems[0][1];
		return '';
	}

	/**
	 * [Describe function...]
	 *
	 * @param	[type]		$path: ...
	 * @return	[type]		...
	 */
	function relativePath($path)
	{
		//Used '../' because we are in typo3-backend. TODO: Is there a funtion to this in typo3?
		if (substr($path,0,4)=='EXT:')	{
			$file = t3lib_div::getFileAbsFileName($path);
			if ($file)	{
				return '../'.substr($file,strlen(PATH_site));
			}
			return '../'.$path;
		}
		else
			return '../'.$path;
	}


    function user_ActivityTypesSelector(&$PA, &$fobj)
	{
        return $this->createHiearchySelector($PA, "Activity Types (Click to open/close)", "tx_pure_pi::getActivityTypesHiearchy", TRUE);
    }

    function user_PublicationTypesSelector(&$PA, &$fobj)
	{
        return $this->createHiearchySelector($PA, "Publication Types (Click to open/close)", "tx_pure_pi::getPublicationTypesHiearchy", TRUE);
    }
    
    function user_OrganisationTypesSelector(&$PA, &$fobj)
	{
        return $this->createHiearchySelector($PA, "Organisation Types (Click to open/close)", "tx_pure_pi::getOrganisationTypesHiearchy", TRUE);
    }

    function user_EmploymentTypesSelector(&$PA, &$fobj)
	{
        return $this->createHiearchySelector($PA, "Limit to Employment Types (Click to open/close. All types in output by default.)", "tx_pure_pi::getEmploymentTypesHiearchy", TRUE, TRUE, 200);
    }

    function user_OrganisationSelector(&$PA, &$fobj)
	{
        // TODO: Should be FALSE, but is TRUE until we have find another workarond,
        // that the Panel fully load in TYPO3 tab.
        return $this->createHiearchySelector($PA, "Organisations (Click to open/close)", "tx_pure_pi::getOrganisationsHiearchy", TRUE);
    }

    private function createHiearchySelector($PA, $title, $ajaxFunction, $colapsed, $hideExcluded = FALSE, $height = 300)
    {
        $url = self::getPureUrl($PA);

        $html = '<div id="pure-ExtJS'.$PA['itemFormElName'].'">';
        $html .= '  <input type="hidden" id="'.$PA['itemFormElName'].'" name="'.$PA['itemFormElName'].'" value="'.$PA['itemFormElValue'].'" />';
        $html .= '</div>';
        //$html .= '<script type="text/javascript" src="'.t3lib_extMgm::extRelPath('pure').'pi/organisation-hiearchy.js'.'"></script>';
        $html .= '<script type="text/javascript">
                    Ext.onReady(function () {

                        var tree = new TYPO3.PURE.PureTreePanel({
                            title: "'.$title.'",
                            renderTo: "pure-ExtJS'.$PA['itemFormElName'].'",
                            pureServerUrl: "'.$url.'",

                            ajaxID: "'.$ajaxFunction.'",

                            hiddenFieldName: "'.$PA['itemFormElName'].'",
                            collapsed: '. ($colapsed ? 'true': 'false').',
                            hideExcluded: '. ($hideExcluded ? 'true': 'false').',
                            height: '. $height.'
                        });
                    });
                    </script>';

        $this->addPureExtJS();
        return $html;
    }

    function user_EmploymentIDSelector(&$PA, &$fobj)
	{
        return $this->createIDNameSelector($PA, "Persons to show (Click to open/close)", 
                "Person IDs", "Name", "WAYF ID",
                "tx_pure_pi::getPersonsSearch", TRUE, 'TYPO3.PURE.PersonTemplate');
    }

    function user_PublicationIDSelector(&$PA, &$fobj)
	{
        return $this->createIDNameSelector($PA, "Publications to show (Click to open/close)", 
                "Publication IDs", "Title", "UUID",
                "tx_pure_pi::getPublicationsSearch", TRUE);
    }

    function user_ActivityIDSelector(&$PA, &$fobj)
	{
        return $this->createIDNameSelector($PA, "Activities to show (Click to open/close)",
                "Activity IDs", "Title", "UUID",
                "tx_pure_pi::getActivitiesSearch", TRUE);
    }

    private function createIDNameSelector($PA, $title, $editMsgTitle,
            $nameColumnTitle, $idColumnTitle, $ajaxFunction,
            $colapsed, $itemSearchTemplate = NULL, $height = 300)
    {
        $url = self::getPureUrl($PA);

        $html = '<div id="pure-ExtJS'.$PA['itemFormElName'].'">';
        $html .= '  <input type="hidden" id="'.$PA['itemFormElName'].'" name="'.$PA['itemFormElName'].'" value="'.$PA['itemFormElValue'].'" />';
        $html .= '</div>';
        $html .= '<script type="text/javascript">
                    Ext.onReady(function () {

                        var control = new TYPO3.PURE.EntrySearchControl({
                            title: "'.$title.'",
                            renderTo: "pure-ExtJS'.$PA['itemFormElName'].'",
                            pureServerUrl: "'.$url.'",

                            ajaxID: "'.$ajaxFunction.'",
                            editMsgTitle: "'.$editMsgTitle.'",
                            nameColumnTitle: "'.$nameColumnTitle.'",
                            idColumnTitle: "'.$idColumnTitle.'",
                            ' .($itemSearchTemplate ? 'itemSearchTemplate: ' . $itemSearchTemplate . ',' : '') .'

                            hiddenFieldName: "'.$PA['itemFormElName'].'",
                            collapsed: '. ($colapsed ? 'true': 'false').',
                            height: '. $height.'
                        });
                    });
                    </script>';

        $this->addPureExtJS();
        return $html;
    }

    /**
     * Adds PURE ExtJS JavaScript and CSS to the backend.
     */
    private function addPureExtJS() {
        $GLOBALS['SOBE']->doc->getPageRenderer()->loadExtJS();
        $GLOBALS['SOBE']->doc->getPageRenderer()->addJsFile(t3lib_extMgm::extRelPath('pure').'pi/pureExtJS.js');
        $GLOBALS['SOBE']->doc->addStyleSheet('pure', t3lib_extMgm::extRelPath('pure'). 'res/css/customExtJs.css');
    }

    /**
     * Inject single items to $PA
     * @param <type> $PA
     */
    private function addSingleItems(&$PA)
    {
        $ll = t3lib_div::makeInstance('language');
        $locallang = t3lib_div::readLLfile(t3lib_extMgm::extPath('pure').'locallang_tca.xml', 'default');

        $PA['fieldConf']['config']['items'][] = array($ll->getLLL('pure.pi_flexform.what_to_display.singleelements', $locallang), '--div--');
        $PA['fieldConf']['config']['items'][] = array($ll->getLLL('pure.pi_flexform.what_to_display.singleperson', $locallang), 'SINGLE_PERSON');
        $PA['fieldConf']['config']['items'][] = array($ll->getLLL('pure.pi_flexform.what_to_display.singlepublication', $locallang), 'SINGLE_PUBLICATION');
        $PA['fieldConf']['config']['items'][] = array($ll->getLLL('pure.pi_flexform.what_to_display.singleactivity', $locallang), 'SINGLE_ACTIVITY');

        // TODO: Update templates, that are usefull
        // $PA['fieldConf']['config']['items'][] = array($ll->getLLL('pure.pi_flexform.what_to_display.singleorganisations', $locallang), 'SINGLE_ORGANISATION');
    }

	//See class.t3lib_tcsforms.php -  getSingleField_typeSelect - getSingleField_typeSelect_multiple
	function user_WhatToShowForm(&$PA, &$fobj)
	{
		$forms = t3lib_div::makeInstance('t3lib_TCEforms');
        $pid = $PA['row']['pid'];
        $tmpl = self::getTypoScript($pid);
        if ($tmpl->setup['plugin.']['tx_pure_pi.']['showSingleItemsBackend']) {
            $this->addSingleItems($PA);
        }
		$items = $forms->initItemArray($PA['fieldConf']); //Localize

        //Update PA['itemFormElValue']
		$newitemFormElValue = '';
		$values = explode(',', $PA['itemFormElValue']);
		$i = 0;
		foreach($values as &$value)
		{
			if(!$value)
				continue;
			//Find LL:
			$langValue = '';
			foreach($items as $item)
			{
				if($item[1] === $value)
				{
					$langValue = $item[0];
					break;
				}
			}
			$value .='|'. ++$i . ' '. $langValue ;
		}
		unset($value);
		$newitemFormElValue = implode(',', $values);
		$PA['itemFormElValue'] = $newitemFormElValue;

		//Make opdates on the html, so onchange it will save.
		$PA['fieldChangeFunc'][] = 'document.editform.doSave.value=1; document.editform.submit();';
		$html = $forms->getSingleField_typeSelect_multiple(NULL, NULL,$PA['row'],$PA,$PA['fieldConf']['config'], $items,'[ INVALID VALUE ("%s") ]');

		//Dirty hack. Still have to save 1 time more.
		$html = str_replace('\'Remove\'); return false', '\'Remove\');'. 'document.editform.doSave.value=1; document.editform.submit();', $html );
		$html = $forms->printNeededJSFunctions_top().$html.$forms->printNeededJSFunctions();

        if ($i == 0)
        {
            //Display flash message. Typo3 v.4.3:
            $message = t3lib_div::makeInstance(
                't3lib_FlashMessage',
                'Nothing is displayed.', //TODO Localize
                '',
                t3lib_FlashMessage::INFO
            );
            t3lib_FlashMessageQueue::addMessage($message);
        }
		return $html;
	}
	
	
	/**
	 * [Describe function...]
	 *
	 * @param	[type]		$ceUid: ...
	 * @param	[type]		$flexData: ...
	 * @return	[type]		...
	 */
	function user_addSheets($ceUid, &$flexData)
	{
		$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery(
				'pi_flexform',
				'tt_content',
				'uid=' .$ceUid
			);
		$sourceData = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);

		if (!isset($sourceData['pi_flexform']) || !(trim($sourceData['pi_flexform'])))
			return;
		$sourceData = (is_array($sourceData['pi_flexform'])) ? $sourceData['pi_flexform'] : t3lib_div::xml2array($sourceData['pi_flexform']);

		if(!is_array($sourceData))
			return;

		//Clean up flexData sheets:
		foreach ($flexData['sheets'] as $key => $sheet)
		{
            if ($key != 'sDEF') {
                unset($flexData['sheets'][$key]);
            }
		}
        
		$i = 1;
		$whatToShow = explode(',', $sourceData['data']['sDEF']['lDEF']['what_to_display']['vDEF']); // Sheets to show
		foreach ($whatToShow as $show)
		{
			if (!$show)
				continue;
			//add a single sheet
			$flexData['sheets'][strtolower($show).'-'.$i]['ROOT']['el'] = $flexData['ROOT']['el'][strtolower($show)]; //ROOT/el/single_person
			$flexData['sheets'][strtolower($show).'-'.$i]['ROOT']['TCEforms']['sheetTitle'] =  $i . ' ' .$GLOBALS['LANG']->sL('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.sheet.'.strtolower($show));
			$flexData['sheets'][strtolower($show).'-'.$i]['ROOT']['TCEforms']['cshFile'] =  'LLL:EXT:pure/locallang_csh_flexform.xml';
			++$i;
		}
	}


    private static function getTypoScript($pid)
    {
		$tmpl = t3lib_div::makeInstance('t3lib_tsparser_ext');
		$tmpl->tt_track = 0;	// Do not log time-performance information
		$tmpl->init();

		// Gets the rootLine
		$sys_page = t3lib_div::makeInstance('t3lib_pageSelect');
		$rootLine = $sys_page->getRootLine($pid);

		$tmpl->runThroughTemplates($rootLine,0);	// This generates the constants/config + hierarchy info for the template.
		$tmpl->generateConfig();

        return $tmpl;
    }

	/**
	 * [Describe function...]
	 *
	 * @param	[type]		$pid: ...
	 * @return	[type]		...
	 */
	private static function getPureServerFromTypoScriptSetup($pid)
	{
		$servers = '';

		//Look up the servers listed in the typoScript setup for the template used.
		$tmpl = self::getTypoScript($pid);

        $servers = array();
		if ($tmpl->setup['plugin.']['tx_pure_pi.']['pure_servers.'])
		{
            //First item is the default.
            $defaultServer = $tmpl->setup['plugin.']['tx_pure_pi.']['pure_servers.']['default.'];
            if ($defaultServer)
            {
                $servers[] = $defaultServer;
            }

            //Add all other server which are not the same as the default
            foreach($tmpl->setup['plugin.']['tx_pure_pi.']['pure_servers.'] as $k => $server)
            {
                if ($k !== 'default.' && !(is_array($defaultServer) &&  $defaultServer['flexFormId'] === $server['flexFormId']))
                    $servers[] = $server;
            }
		}
		return $servers;
	}

	/**
	 * [Describe function...]
	 *
	 * @param	[type]		$config: ...
	 * @return	[type]		...
	 */
	function user_addPureServersFromTypoScript($config)
	{
		$pid = $config['row']['pid'];

		$servers = self::getPureServerFromTypoScriptSetup($pid);
		$serverItems = array();
		foreach($servers as $k => $server)
		{
			$serverItems[] = array(iconv('iso-8859-1', $GLOBALS['LANG']->charSet, $server['name']), $server['flexFormId']);
		}

        $config['items'] = array_merge($config['items'],$serverItems);

        if(empty($servers))
        {
            //Display flash message. Typo3 v.4.3:
            $message = t3lib_div::makeInstance(
                't3lib_FlashMessage',
                'No servers found in TypoScript. Check configuration of the plugin.', //TODO Localize
                'No PURE servers',
                t3lib_FlashMessage::ERROR
            );
            t3lib_FlashMessageQueue::addMessage($message);
        }
        else
        {
            //Check PURE server is alive
            $url = self::getPureUrl($config);
            $rest = new tx_pure_rest($url);
            if (!$rest->isAlive())
            {
                $message = t3lib_div::makeInstance(
                    't3lib_FlashMessage',
                    'The PURE server did not response. <br />Failed to contact server on url: \''.$url. '\'', //TODO Localize
                    'No PURE response',
                    t3lib_FlashMessage::ERROR
                );
                t3lib_FlashMessageQueue::addMessage($message);
            }
        }
	}

    
	/**
	 * [Describe function...]
	 *
	 * @param	[type]		$pid: ...
	 * @return	[type]		...
	 */
	function getTSTemplate($pid)
	{
		//Look up the templates listed in the typoScript setup for the template used.
		$tmpl = t3lib_div::makeInstance('t3lib_tsparser_ext');	// Defined global here!
		$tmpl->tt_track = 0;	// Do not log time-performance information
		$tmpl->init();

		// Gets the rootLine
		$sys_page = t3lib_div::makeInstance('t3lib_pageSelect');
		$rootLine = $sys_page->getRootLine($pid);

		$tmpl->runThroughTemplates($rootLine,0);	// This generates the constants/config + hierarchy info for the template.

		$tmpl->generateConfig();
		return $tmpl;
	}


	/**
	 * [Describe function...]
	 *
	 * @param	[type]		$config: ...
	 * @return	[type]		...
	 */
	function user_addTemplateItems($config)
	{
		//var_dump($config);
		$templates = array();
		$typoName = $config['config']['typoscript_name'];
		$pid = $config['row']['pid'];

		$tmpl = $this->getTSTemplate($pid);

		if ($tmpl->setup['plugin.']['tx_pure_pi.']['templates.'] && $tmpl->setup['plugin.']['tx_pure_pi.']['templates.'][$typoName.'.'])
		{
			foreach($tmpl->setup['plugin.']['tx_pure_pi.']['templates.'][$typoName.'.'] as $template)
			{
				$name = $GLOBALS['LANG']->sL($template['name']);
				$templates[] = array($name, $template['template']);
			}
		}

		$config['items'] = array_merge($config['items'], $templates);
	}
	


    private static function getPureUrl($config)
    {
        $sourceData = (is_array($config['row']['pi_flexform'])) ? $config['row']['pi_flexform'] : t3lib_div::xml2array($config['row']['pi_flexform']);

        $url = '';
        if(is_array($sourceData) && $sourceData['data']['sDEF']['lDEF']['pure_server']['vDEF'])
        {
            $flexFormId = $sourceData['data']['sDEF']['lDEF']['pure_server']['vDEF'];
            $url = self::getPureServerUrlFromFlexFormId($flexFormId, $config['row']['pid']);
        }
        else //Get default server.
        {
            $url = self::getDefaultPureServerUrl($config['row']['pid']);
        }
        return $url;
    }

    private static function getPureServerUrlFromFlexFormId($flexFormId, $pid)
    {
        $servers = self::getPureServerFromTypoScriptSetup($pid);
        foreach($servers as $server)
        {
            if ($server['flexFormId'] === $flexFormId)
                return $server['url'];
        }
        return '';
    }

    private static function getDefaultPureServerUrl($pid)
    {
      $servers = self::getPureServerFromTypoScriptSetup($pid);
      if ($servers[0])
      {
          return $servers[0]['url'];
      }
      return '';
    }


}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/pure/class.tx_pure_addFieldsToFlexForm.php']) {
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/pure/class.tx_pure_addFieldsToFlexForm.php']);
}

?>