<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2009-2010 Mads Sandberg Brun <msb@cs.au.dk>
 *  (c) 2009-2010 Peter Sandberg Brun <psb@cs.au.dk>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

require_once(PATH_t3lib."class.t3lib_page.php"); 	//For caching

class tx_pure_cache  {

    public static $DefaultCacheTime = 86400;
    /**
     * Insert data into the cache.
     * @param mixed $data The data to cache.
     * @param array $requestInfo A unigue array for the data.
     * @param integer $cacheTime The time to cache.
     */
 	public static function insertCachedData($data, array $requestInfo, $cacheTime = 0)
	{
		$storeKey = md5('pureData:'.serialize($requestInfo));
		t3lib_pageSelect::storeHash($storeKey, serialize($data), 'pureData', $cacheTime);
	}

	/**
     * Gets data from cache.
     * @param array $requestInfo A unigue array for the data.
     * @param integer $cacheTime The cache time.
     * @return mixed The cached data
     */
	public static function getCachedData(array $requestInfo, $cacheTime = 0)
	{
        $storeArr = NULL;
		$storeKey = md5('pureData:'.serialize($requestInfo));
		$storeArrDat = t3lib_pageSelect::getHash($storeKey, $cacheTime);
		if (isset($storeArrDat))
		{
			$storeArr = unserialize($storeArrDat);
		}
		return $storeArr;
	}
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/pure/class.tx_pure_cache.php']) {
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/pure/class.tx_pure_cache.php']);
}
?>