<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2009-2010 Mads Sandberg Brun <msb@cs.au.dk>
 *  (c) 2009-2010 Peter Sandberg Brun <psb@cs.au.dk>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 *
 */

class tx_pure_image {
	var $image;
	var $image_width;
	var $image_height;
	var $image_type;
	var $image_url;
 
	function load($url) {
		$this->image_url = $url;
		$image_info = getimagesize($url);
		$this->image_width = $image_info[0];
		$this->image_height = $image_info[1];
		$this->image_type = $image_info[2];

		switch ($this->image_type)
		{
			case IMAGETYPE_JPEG:
				$this->image = imagecreatefromjpeg($url);
				break;
			case IMAGETYPE_GIF:
				$this->image = imagecreatefromgif($url);
				break;
			case IMAGETYPE_PNG:
				$this->image = imagecreatefrompng($url);
				break;
			default:
				$this->image = null;
				break;
		}
	}
	
	function output($path = NULL) 
	{
		if ($this->image == null || !is_resource($this->image))
		{
			if ($this->image_url)
			{
				Header( 'Location: '. $this->image_url );
			}
			exit;
		}
		
		$succes = false;
	   	switch ($this->image_type)
	   	{
	   		case IMAGETYPE_JPEG:
	   			$succes = imagejpeg($this->image, $path);
	   			break;
	   		case IMAGETYPE_GIF:
	   			$succes = imagepng($this->image, $path);
	   			break;
	   		case IMAGETYPE_PNG:
	   			$succes = imagepng($this->image, $path);
	   			break;
	   		default:
	   			break;
	   	}
	   	if ($succes)
	   	{
	   		header("Content-type: " . image_type_to_mime_type($this->image_type));
	   	}
	   	else
	   	{
	   		if ($this->image_url)
			{
				Header( 'Location: '. $this->image_url );
			}
			exit;
	   	}
	   	
	   	
	   	//imagedestroy($this->image);
	}
	
	function loadAndOutput($url, $width, $height, $clip = true)
	{
		//Check cache
		
		$this->load($url);
		$this->resize($url);
		//make cahce
		$this->output();
	}
   
	function resize($width, $height, $clip = true) 
	{
		if ($this->image == null)
			return;
		$width = intval($width);
		$height = intval($height);
		
		//Can not be bigger than original size
		$max_width = min($width, $this->image_width);
		$max_height = min($height, $this->image_height);
		
		//Calculate offset and original image size, if clip.
		$x_offset = 0;
		$y_offset = 0;
		$org_width = $this->image_width;
		$org_height = $this->image_height;
      	
		if ($clip)
		{
			$org_ratio = (float) $this->image_width / $this->image_height;
			$dest_ratio	= (float) $width / $height;
			if ($org_ratio < $dest_ratio) 
			{
				//Image is higher than destination, so we clip of the height 
				//	by calculating y_offset and the heigt to use of the original image.
				$org_height = $this->image_width / $dest_ratio;
				$y_offset = (float)($this->image_height - $org_height) / 2;
				
				$width = $max_width;
				$height = $max_width / $dest_ratio;
			}
			else if ($org_ratio > $dest_ratio)
			{
				$org_width = $this->image_height * $dest_ratio;
				$x_offset = (float)($this->image_width - $org_width) / 2;
				
				$height = $max_height;
				$width = $max_height * $dest_ratio;
			}
		}
		else
		{
			
		}
		
		$new_image = imagecreatetruecolor($width, $height);
		imagecopyresampled($new_image, $this->image, 0, 0, $x_offset, $y_offset, $width, $height, $org_width, $org_height);
		$this->image = $new_image;
	}
	
/*********************************************/
/* Fonction: ImageCreateFromBMP              */
/* Author:   DHKold                          */
/* Contact:  admin@dhkold.com                */
/* Date:     The 15th of June 2005           */
/* Version:  2.0B                            */
/*********************************************/

function ImageCreateFromBMP($filename)
{
 //Ouverture du fichier en mode binaire
   if (! $f1 = fopen($filename,"rb")) return FALSE;

   $FILE = unpack("vfile_type/Vfile_size/Vreserved/Vbitmap_offset", fread($f1,14));
   if ($FILE['file_type'] != 19778) return FALSE;

   $BMP = unpack('Vheader_size/Vwidth/Vheight/vplanes/vbits_per_pixel'.
                 '/Vcompression/Vsize_bitmap/Vhoriz_resolution'.
                 '/Vvert_resolution/Vcolors_used/Vcolors_important', fread($f1,40));
   $BMP['colors'] = pow(2,$BMP['bits_per_pixel']);
   if ($BMP['size_bitmap'] == 0) $BMP['size_bitmap'] = $FILE['file_size'] - $FILE['bitmap_offset'];
   $BMP['bytes_per_pixel'] = $BMP['bits_per_pixel']/8;
   $BMP['bytes_per_pixel2'] = ceil($BMP['bytes_per_pixel']);
   $BMP['decal'] = ($BMP['width']*$BMP['bytes_per_pixel']/4);
   $BMP['decal'] -= floor($BMP['width']*$BMP['bytes_per_pixel']/4);
   $BMP['decal'] = 4-(4*$BMP['decal']);
   if ($BMP['decal'] == 4) $BMP['decal'] = 0;

   $PALETTE = array();
   if ($BMP['colors'] < 16777216)
   {
    $PALETTE = unpack('V'.$BMP['colors'], fread($f1,$BMP['colors']*4));
   }

   $IMG = fread($f1,$BMP['size_bitmap']);
   $VIDE = chr(0);

   $res = imagecreatetruecolor($BMP['width'],$BMP['height']);
   $P = 0;
   $Y = $BMP['height']-1;
   while ($Y >= 0)
   {
    $X=0;
    while ($X < $BMP['width'])
    {
     if ($BMP['bits_per_pixel'] == 24)
        $COLOR = unpack("V",substr($IMG,$P,3).$VIDE);
     elseif ($BMP['bits_per_pixel'] == 16)
     { 
        $COLOR = unpack("n",substr($IMG,$P,2));
        $COLOR[1] = $PALETTE[$COLOR[1]+1];
     }
     elseif ($BMP['bits_per_pixel'] == 8)
     { 
        $COLOR = unpack("n",$VIDE.substr($IMG,$P,1));
        $COLOR[1] = $PALETTE[$COLOR[1]+1];
     }
     elseif ($BMP['bits_per_pixel'] == 4)
     {
        $COLOR = unpack("n",$VIDE.substr($IMG,floor($P),1));
        if (($P*2)%2 == 0) $COLOR[1] = ($COLOR[1] >> 4) ; else $COLOR[1] = ($COLOR[1] & 0x0F);
        $COLOR[1] = $PALETTE[$COLOR[1]+1];
     }
     elseif ($BMP['bits_per_pixel'] == 1)
     {
        $COLOR = unpack("n",$VIDE.substr($IMG,floor($P),1));
        if     (($P*8)%8 == 0) $COLOR[1] =  $COLOR[1]        >>7;
        elseif (($P*8)%8 == 1) $COLOR[1] = ($COLOR[1] & 0x40)>>6;
        elseif (($P*8)%8 == 2) $COLOR[1] = ($COLOR[1] & 0x20)>>5;
        elseif (($P*8)%8 == 3) $COLOR[1] = ($COLOR[1] & 0x10)>>4;
        elseif (($P*8)%8 == 4) $COLOR[1] = ($COLOR[1] & 0x8)>>3;
        elseif (($P*8)%8 == 5) $COLOR[1] = ($COLOR[1] & 0x4)>>2;
        elseif (($P*8)%8 == 6) $COLOR[1] = ($COLOR[1] & 0x2)>>1;
        elseif (($P*8)%8 == 7) $COLOR[1] = ($COLOR[1] & 0x1);
        $COLOR[1] = $PALETTE[$COLOR[1]+1];
     }
     else
        return FALSE;
     imagesetpixel($res,$X,$Y,$COLOR[1]);
     $X++;
     $P += $BMP['bytes_per_pixel'];
    }
    $Y--;
    $P+=$BMP['decal'];
   }

 //Fermeture du fichier
   fclose($f1);

 return $res;
}
}



//$image = new tx_pure_image();
//$image->load('http://pure3a.au.dk:8080/ws/fbspretrieve/18108458/jrb.png');
//$image->load('http://pure3a.au.dk:8080/ws/fbspretrieve/10456919/kaj-web2.jpg');
//$image->resize(150, 200, true);
//$image->output();

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/pure/class.tx_pure_image.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/pure/class.tx_pure_image.php']);
}
?>