<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2009-2010 Mads Sandberg Brun <msb@cs.au.dk>
 *  (c) 2009-2010 Peter Sandberg Brun <psb@cs.au.dk>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 *
 *
 *   44: class tx_pure_pichange
 *
 * TOTAL FUNCTIONS: 0
 * (This index is automatically created/updated by the extension "extdeveval")
 *
 */
/**
 * Class that define how the different "tabs" in pure-extension is displayed.
 *
 * @author	Mads Sandberg Brun <msb@cs.au.dk>
 * @author	Peter Sandberg Brun <psb@cs.au.dk>
 * @package	TYPO3
 * @subpackage	tx_pure
 */
class tx_pure_pichange	{
		// only process DCA if we have a special list-type
	var $rowChecks = array (
		'list_type' => 'pure_pi',
		'CType' => 'list'
	);

	//See http://typo3.org/documentation/document-library/extension-manuals/dynaflex/1.11.0/view/ for documentation
	//And TCA (DCA): http://typo3.org/documentation/document-library/core-documentation/doc_core_api/4.1.0/view/4/2/
	var $DCA = array (
		0 => array (
			'path' => 'tt_content/columns/pi_flexform/config/ds/pure_pi,list',  //"pure_pi1,list" !!! IMPORTANT
			'modifications' => array (
				array (
					'method' => 'add',
					'path' => 'ROOT/el/single_person',
					'type' => 'fields',
					'field_config' => array(
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.single_person.name',//'Person navne (komma seperated)',
								'name' => 'single_person_email',
								'config' => array (
                                    'type' => 'user',
                                    'userFunc' => 'tx_pure_addFieldsToFlexForm->user_EmploymentIDSelector'
                                )
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.templateToUse',
								'name' => 'single_person_templateName',
								'config' => array (
									'type' => 'user', //select
									'userFunc' => 'tx_pure_addFieldsToFlexForm->user_TemplateSelector',
									'itemsProcFunc' =>  'tx_pure_addFieldsToFlexForm->user_addTemplateItems',
									'typoscript_name' => 'single_person'
									
								),
								
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.single_person.tabIndex',
								'name' => 'single_person_tabIndex',
								'displayCond' => 'FIELD:single_person_templateName:=:true',
								'config' => array (
									'type' => 'select', //select
									'items'  => array(
										array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.single_person.tabIndex.None', 0),
										array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.single_person.tabIndex.Keyword', 'KEYWORDCLASS'),
										array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.single_person.tabIndex.Cv', 'CVCLASS'),
										array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.single_person.tabIndex.Publications', 'PUBCLASS'),
										array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.single_person.tabIndex.Activities', 'ACTCLASS'),
										array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.single_person.tabIndex.Misc', 'MISCCLASS'),
										array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.single_person.tabIndex.Extra', 'EXTRACLASS'),
									),
								),
								
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.templateToUse.userDefined',
								'name' => 'single_person_templateName_userdefined',
								'config' => array (
									'type' => 'input'
								)
						)

					)
				)
				,

				array (
					'method' => 'add',
					'path' => 'ROOT/el/single_activity',
					'type' => 'fields',
					'field_config' => array(
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.single_activity.id',//'Person navne (komma seperated)',
								'name' => 'single_activity_id',
								'config' => array (
                                    'type' => 'user',
                                    'userFunc' => 'tx_pure_addFieldsToFlexForm->user_ActivityIDSelector'
                                )
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.templateToUse',
								'name' => 'single_activity_templateName',
								'config' => array (
									'type' => 'user', //select
									'userFunc' => 'tx_pure_addFieldsToFlexForm->user_TemplateSelector',
									'itemsProcFunc' =>  'tx_pure_addFieldsToFlexForm->user_addTemplateItems',
									'typoscript_name' => 'single_activity'
									
								)
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.templateToUse.userDefined',
								'name' => 'single_activity_templateName_userdefined',
								'config' => array (
									'type' => 'input'
								)
						)

					)
				)
				,

				array (
					'method' => 'add',
					
					'path' => 'ROOT/el/single_publication',
					'type' => 'fields',
					'field_config' => array(
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.single_publication.id',//'Person navne (komma seperated)',
								'name' => 'single_publication_id',
								'config' => array (
                                    'type' => 'user',
                                    'userFunc' => 'tx_pure_addFieldsToFlexForm->user_PublicationIDSelector'
                                )
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.templateToUse',
								'name' => 'single_publication_templateName',
								'config' => array (
									'type' => 'user', //select
									'userFunc' => 'tx_pure_addFieldsToFlexForm->user_TemplateSelector',
									'itemsProcFunc' =>  'tx_pure_addFieldsToFlexForm->user_addTemplateItems',
									'typoscript_name' => 'single_publication'
									
								)
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.templateToUse.userDefined',
								'name' => 'single_publication_templateName_userdefined',
								'config' => array (
									'type' => 'input'
								)
						)

					)
				)
				,

                array (
					'method' => 'add',
					'path' => 'ROOT/el/single_organisation',
					'type' => 'fields',
					'field_config' => array(

                        array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.persons.organisation',
								'name' => 'single_organisation_organisation',
								'config' => array (
									'type' => 'user', //select
									'userFunc' => 'tx_pure_addFieldsToFlexForm->user_OrganisationSelector'
								)
						),

						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.templateToUse',
								'name' => 'single_organisation_templateName',
								'config' => array (
									'type' => 'user', //select
									'userFunc' => 'tx_pure_addFieldsToFlexForm->user_TemplateSelector',
									'itemsProcFunc' =>  'tx_pure_addFieldsToFlexForm->user_addTemplateItems',
									'typoscript_name' => 'single_organisation'
								)
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.templateToUse.userDefined',
								'name' => 'single_organisation_templateName_userdefined',
								'config' => array (
									'type' => 'input'
								)
						)

					)
				),

				array (
					'method' => 'add',
					'path' => 'ROOT/el/persons',
					'type' => 'fields',
					'field_config' => array(
                        array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.persons.organisation',
								'name' => 'persons_organisation',
								'config' => array (
									'type' => 'user', //select
									'userFunc' => 'tx_pure_addFieldsToFlexForm->user_OrganisationSelector'
								)
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.persons.names',//'Person navne (komma seperated)',
								'name' => 'persons_emails',
								'config' => array (
                                    'type' => 'user',
                                    'userFunc' => 'tx_pure_addFieldsToFlexForm->user_EmploymentIDSelector'
                                )
                            /*'config' => array (
									'type' => 'text',
									'cols' => 60,
									//'eval' => 'nospace'
								)*/
						),

                        array(
                                'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.persons.type',
								'name' => 'persons_type',
								'config' => array (
                                    'type' => 'user', //select
									'userFunc' => 'tx_pure_addFieldsToFlexForm->user_EmploymentTypesSelector'

                                    // Multi selector: Do not work, because the values contains '/', so we use hierarchy selector instead.
									//'type' => 'select',
                                    //'itemsProcFunc' =>  'tx_pure_addFieldsToFlexForm->user_addPersonTypes',
                                    //'size' => 12,
                                    //'maxitems' => 100,
								)
                        ),
						/*
						array(  'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.persons.type',  //created, firstname, id, lastname, modified, rating, title
								'name' => 'persons_type',
								'config' => array (
									'type' => 'select',
									'items' => array(array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.persons.type.all' , 'all'),
													array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.persons.type.vip' , 'VIP'),
													array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.persons.type.tap', 'TAP'),
													array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.persons.type.phd', 'PHD'),
													array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.persons.type.stud', 'STUD'),
													),
								)
						
						),*/

						array( 	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.persons.state',  //created, firstname, id, lastname, modified, rating, title
								'name' => 'persons_state',
								'config' => array (
									'type' => 'select',
									'items' => array(array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.persons.state.active' , 'active'),
													array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.persons.state.inactive' , 'inactive'),
													array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.persons.state.both', 'both')),

									'listStyle' => 'width:150px'
								)
						),

						array( 	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.persons.sortby',  //created, firstname, id, lastname, modified, rating, title
								'name' => 'persons_ordering',
								'config' => array (
									'type' => 'select',
									'items' => array(array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.persons.sortby.lastname' , 'lastname'),
													array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.persons.sortby.firstname' , 'firstname'),
													array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.persons.sortby.id', 'id')),

									'listStyle' => 'width:150px'
								)
						),
						/*
						array( 	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.persons.groupby',
								'name' => 'persons_groupby',
								'config' => array (
									'type' => 'select',
									'items' => array(array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.persons.groupby.none' , 'none'),
													array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.persons.groupby.lastname' , 'lastname')
													),

									'listStyle' => 'width:150px'
								)
						),
						*/

						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.ascDesc',
								'name' => 'persons_ascDesc',
								'config' => array (
									'type' => 'select',
									'items' => array(array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.ascDesc.ascending' , 'asc'),
												array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.ascDesc.descending' , 'desc'))
								)
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.templateToUse',
								'name' => 'persons_templateName',
								'config' => array (
									'type' => 'user', //select
									'userFunc' => 'tx_pure_addFieldsToFlexForm->user_TemplateSelector',
									'itemsProcFunc' =>  'tx_pure_addFieldsToFlexForm->user_addTemplateItems',
									'typoscript_name' => 'persons'
									/*
									'items' => array(
												array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.templateToUse.full' , 'TEMPLATE_PERSONS_FULL'),
												array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.templateToUse.basic' , 'TEMPLATE_PERSONS_BASIC'),
												array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.templateToUse.simple' , 'TEMPLATE_PERSONS_SIMPLE')
												),
									'default' => 'TEMPLATE_PERSONS_SIMPLE' */

								)
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.templateToUse.userDefined',
								'name' => 'persons_templateName_userdefined',
								'config' => array (
									'type' => 'input'
								)
						)

					)
				)
				,array (
					'method' => 'add',
					'path' => 'ROOT/el/publications',
					'type' => 'fields',
					'field_config' => array(
                        array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.persons.organisation',
								'name' => 'publications_organisation',
								'config' => array (
									'type' => 'user', //select
									'userFunc' => 'tx_pure_addFieldsToFlexForm->user_OrganisationSelector'
								)
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.publications.names',
								'name' => 'publications_persons_emails',
								'config' => array (
                                    'type' => 'user',
                                    'userFunc' => 'tx_pure_addFieldsToFlexForm->user_EmploymentIDSelector'
                                )
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.publications.ids',
								'name' => 'publications_ids',
								'config' => array (
                                    'type' => 'user',
                                    'userFunc' => 'tx_pure_addFieldsToFlexForm->user_PublicationIDSelector'
                                )
						),
                        array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.publications.types',
								'name' => 'publications_types',
								'config' => array (
									'type' => 'user', //select
									'userFunc' => 'tx_pure_addFieldsToFlexForm->user_PublicationTypesSelector'
								)
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.publications.year',
								'name' => 'publications_persons_year',
								'config' => array (
									'type' => 'input'
								)
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.publications.showall',
								'name' => 'publications_showAll',
								'config' => array (
									'type' => 'check',
									'default' => '0',
								) 
						),
						
						array( 	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.publications.sortby',  //[authorLastName, created, doi, id, lowertitle, modified, publicationDate, publicationYear, submissionYear, title, typeClassification]
								'name' => 'publications_ordering',
								'config' => array (
									'type' => 'select',
									'items' => array(
												array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.publications.sortby.publicationYear' , 'publicationYear'),
												array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.publications.sortby.created' , 'created'),
												array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.publications.sortby.firstAuthor' , 'authorLastName'),
												array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.publications.sortby.title', 'title')),

									'listStyle' => 'width:150px'

								)
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.ascDesc',
								'name' => 'publications_ascDesc',
								'config' => array (
									'type' => 'select',
									'items' => array(array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.ascDesc.ascending' , 'asc'),
												array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.ascDesc.descending' , 'desc'))
								)
						),
						array( 	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.publications.groupby',
								'name' => 'publications_groupby',
								'config' => array (
									'type' => 'select',
									'items' => array(array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.publications.groupby.none' , ''),
													//array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.publications.groupby.publicationCategory' , 'publicationCategory'),
													array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.publications.groupby.publicationYear' , 'publicationYear'),
													array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.publications.groupby.publicationType' , 'publicationType'),
													array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.publications.groupby.submittedYear' , 'submittedYear')
													),

									'listStyle' => 'width:150px'
								)
						),
						array( 	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.publications.groupby2',
								'name' => 'publications_groupby2',
								'config' => array (
									'type' => 'select',
									'items' => array(array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.publications.groupby.none' , ''),
													//array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.publications.groupby.publicationCategory' , 'publicationCategory'),
													array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.publications.groupby.publicationYear' , 'publicationYear'),
													array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.publications.groupby.publicationType' , 'publicationType'),
													array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.publications.groupby.submittedYear' , 'submittedYear')
													),

									'listStyle' => 'width:150px'
								)
						),
						
						array( 	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.publications.size',
								'name' => 'publications_size',
								'config' => array (
									'type' => 'input',
								)
						),

						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.templateToUse',
								'name' => 'publcations_templateName',
								'config' => array (
									'type' => 'user', //select
									'userFunc' => 'tx_pure_addFieldsToFlexForm->user_TemplateSelector',
									'itemsProcFunc' =>  'tx_pure_addFieldsToFlexForm->user_addTemplateItems',
									'typoscript_name' => 'publications'
									/*
									'items' => array(
												array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.templateToUse.simple' , 'TEMPLATE_PUBLICATIONS_SIMLPLE')
												)*/
								)
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.templateToUse.userDefined',
								'name' => 'publcations_templateName_userdefined',
								'config' => array (
									'type' => 'input'
								)
						)

					)
				),
				array (
					'method' => 'add',
					'path' => 'ROOT/el/activities',
					'type' => 'fields',
					'field_config' => array(

                        array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.persons.organisation',
								'name' => 'activities_organisation',
								'config' => array (
									'type' => 'user', //select
									'userFunc' => 'tx_pure_addFieldsToFlexForm->user_OrganisationSelector'
								)
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.activities.names',
								'name' => 'activities_persons_emails',
								'config' => array (
                                    'type' => 'user',
                                    'userFunc' => 'tx_pure_addFieldsToFlexForm->user_EmploymentIDSelector'
                                )
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.activities.ids',
								'name' => 'activities_ids',
								'config' => array (
                                    'type' => 'user',
                                    'userFunc' => 'tx_pure_addFieldsToFlexForm->user_ActivityIDSelector'
                                )
						),
                        array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.activities.types',
								'name' => 'activities_types',
								'config' => array (
									'type' => 'user', //select
									'userFunc' => 'tx_pure_addFieldsToFlexForm->user_ActivityTypesSelector'
								)
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.activities.year',
								'name' => 'activities_year',
								'config' => array (
									'type' => 'input'
								)
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.activities.showall',
								'name' => 'activities_showAll',
								'config' => array (
									'type' => 'check',
									'default' => '0',
								) 
						),
						//[activityTypeIndex, created, end, id, modified, owner, rating, start, startYear, title]
						array( 	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.activities.sortby',
								'name' => 'activities_ordering',
								'config' => array (
									'type' => 'select',
									'items' => array(
												array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.activities.sortby.start' , 'start'),
												array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.activities.sortby.title', 'title')

												),
									'listStyle' => 'width:150px'

								)
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.ascDesc',
								'name' => 'activities_ascDesc',
								'config' => array (
									'type' => 'select',
									'items' => array(array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.ascDesc.ascending' , 'asc'),
												array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.ascDesc.descending' , 'desc'))
								)
						),
						array( 	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.activities.groupby',
								'name' => 'activities_groupby',
								'config' => array (
									'type' => 'select',
									'items' => array(array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.activities.groupby.none' , ''),
													//array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.activities.groupby.type' , '@xsi:type'),
													array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.activities.groupby.activityType' , 'activityType'),
													array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.activities.groupby.startYear' , 'startYear')
													),

									'listStyle' => 'width:150px'
								)
						),
						array( 	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.activities.groupby2',
								'name' => 'activities_groupby2',
								'config' => array (
									'type' => 'select',
									'items' => array(array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.activities.groupby.none' , ''),
													//array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.activities.groupby.type' , '@xsi:type'),
													array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.activities.groupby.activityType' , 'activityType'),
													array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.activities.groupby.startYear' , 'startYear')
													),

									'listStyle' => 'width:150px'
								)
						),
						
						array( 	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.activities.size',
								'name' => 'activities_size',
								'config' => array (
									'type' => 'input',
								)
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.templateToUse',
								'name' => 'activities_templateName',
								'config' => array (
									'type' => 'user', //select
									'userFunc' => 'tx_pure_addFieldsToFlexForm->user_TemplateSelector',
									'itemsProcFunc' =>  'tx_pure_addFieldsToFlexForm->user_addTemplateItems',
									'typoscript_name' => 'activities'
									/*
									'items' => array(
												array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.templateToUse.full' , 'TEMPLATE_ACTIVITIES_SIMLPLE')
												)*/
								)
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.templateToUse.userDefined',
								'name' => 'activities_templateName_userdefined',
								'config' => array (
									'type' => 'input'
								)
						)

					)
				),

                array (
					'method' => 'add',
					'path' => 'ROOT/el/organisations',
					'type' => 'fields',
					'field_config' => array(

                        array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.persons.organisation',
								'name' => 'organisations_organisation',
								'config' => array (
									'type' => 'user', //select
									'userFunc' => 'tx_pure_addFieldsToFlexForm->user_OrganisationSelector'
								)
						),

                        array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.organisation.types',
								'name' => 'organisation_types',
								'config' => array (
									'type' => 'user', //select
									'userFunc' => 'tx_pure_addFieldsToFlexForm->user_OrganisationTypesSelector'
								)
						),

						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.templateToUse',
								'name' => 'organisations_templateName',
								'config' => array (
									'type' => 'user', //select
									'userFunc' => 'tx_pure_addFieldsToFlexForm->user_TemplateSelector',
									'itemsProcFunc' =>  'tx_pure_addFieldsToFlexForm->user_addTemplateItems',
									'typoscript_name' => 'organisations'
									/*
									'items' => array(
												array('LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.templateToUse.full' , 'TEMPLATE_ACTIVITIES_SIMLPLE')
												)*/
								)
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.templateToUse.userDefined',
								'name' => 'organisations_templateName_userdefined',
								'config' => array (
									'type' => 'input'
								)
						)

					)
				),
				
/****************************************************************/
/*******************	Search tabs   ***************************/ 
/****************************************************************/
				
				array (
					'method' => 'add',
					'path' => 'ROOT/el/search_activities',
					'type' => 'fields',
					'field_config' => array(
                        array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.search.organisation',
								'name' => 'organisations',
								'config' => array (
									'type' => 'user', //select
									'userFunc' => 'tx_pure_addFieldsToFlexForm->user_OrganisationSelector'
								)
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.search.redirectToPid',
								'name' => 'redirectToSinglePid',
								'config' => array (
									'type' => 'check',
									'default' => '0',
								) 
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.search.templateToUseForSearch',
								'name' => 'search_activities_templateName',
								'config' => array (
									'type' => 'user', //select
									'userFunc' => 'tx_pure_addFieldsToFlexForm->user_TemplateSelector',
									'itemsProcFunc' =>  'tx_pure_addFieldsToFlexForm->user_addTemplateItems',
									'typoscript_name' => 'search_activities'
								)
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.search.templateToUseForResult',
								'name' => 'search_activities_result_templateName',
								'config' => array (
									'type' => 'user', //select
									'userFunc' => 'tx_pure_addFieldsToFlexForm->user_TemplateSelector',
									'itemsProcFunc' =>  'tx_pure_addFieldsToFlexForm->user_addTemplateItems',
									'typoscript_name' => 'search_activities_result'
								)
						),
						
					)
				),
				
				array (
					'method' => 'add',
					'path' => 'ROOT/el/search_publications',
					'type' => 'fields',
					'field_config' => array( 
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.search.organisation',
								'name' => 'organisations',
								'config' => array (
									'type' => 'user', //select
									'userFunc' => 'tx_pure_addFieldsToFlexForm->user_OrganisationSelector'
								)
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.search.redirectToPid',
								'name' => 'redirectToSinglePid',
								'config' => array (
									'type' => 'check',
									'default' => '0',
								) 
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.search.templateToUseForSearch',
								'name' => 'search_publications_templateName',
								'config' => array (
									'type' => 'user', //select
									'userFunc' => 'tx_pure_addFieldsToFlexForm->user_TemplateSelector',
									'itemsProcFunc' =>  'tx_pure_addFieldsToFlexForm->user_addTemplateItems',
									'typoscript_name' => 'search_publications'
								)
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.search.templateToUseForResult',
								'name' => 'search_publications_result_templateName',
								'config' => array (
									'type' => 'user', //select
									'userFunc' => 'tx_pure_addFieldsToFlexForm->user_TemplateSelector',
									'itemsProcFunc' =>  'tx_pure_addFieldsToFlexForm->user_addTemplateItems',
									'typoscript_name' => 'search_publications_result'
								)
						),
					)
				),
				
				array (
					'method' => 'add',
					'path' => 'ROOT/el/search_persons',
					'type' => 'fields',
					'field_config' => array(
                        array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.search.organisation',
								'name' => 'organisations',
								'config' => array (
									'type' => 'user', //select
									'userFunc' => 'tx_pure_addFieldsToFlexForm->user_OrganisationSelector'
								)
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.search.redirectToPid',
								'name' => 'redirectToSinglePid',
								'config' => array (
									'type' => 'check',
									'default' => '0',
								) 
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.search.templateToUseForSearch',
								'name' => 'search_persons_templateName',
								'config' => array (
									'type' => 'user', //select
									'userFunc' => 'tx_pure_addFieldsToFlexForm->user_TemplateSelector',
									'itemsProcFunc' =>  'tx_pure_addFieldsToFlexForm->user_addTemplateItems',
									'typoscript_name' => 'search_persons'
								)
						),
						array(	'label' => 'LLL:EXT:pure/locallang_tca.xml:pure.pi_flexform.search.templateToUseForResult',
								'name' => 'search_persons_result_templateName',
								'config' => array (
									'type' => 'user', //select
									'userFunc' => 'tx_pure_addFieldsToFlexForm->user_TemplateSelector',
									'itemsProcFunc' =>  'tx_pure_addFieldsToFlexForm->user_addTemplateItems',
									'typoscript_name' => 'search_persons_result'
								)
						),
					)
				),


				/*
				array (
					'method' => 'add',
					'path' => 'ROOT/el',
					'type' => 'fields',
					'field_config' => array(
						array(	'label' => 'Person navne (komma seperated)',
								'name' => 'what_to_displayss',
								'config' => array (
									'type' => 'input'
								)
						)
						)
				),*/

				//Sheet for configuration:

				/*
				array (
					'method' => 'move',
						// define the condition when this modification should be executed
						'condition' => array (
						'source' => 'db',					// condition source is the database
						'if' => 'isGreater',				// how should be compared?
						'compareTo' => 0,					// and with *what* should be compared?
						'table' => 'tt_content',	// the table where the data comes from
						'select' => 'uid',				// the field that is used as data for comparison
						'where' => 'uid=###uid###'			// what should be selected? ###uid### is replaced with the UID of the current content element
					),
					'source' => 'sheets/s_template/ROOT/el',					// what should be copied
					'dest' => 'ROOT/el/s_template'		// where should it be copied to
				),

				array (
					'method' => 'move',
						// define the condition when this modification should be executed
						'condition' => array (
						'source' => 'db',					// condition source is the database
						'if' => 'isGreater',				// how should be compared?
						'compareTo' => 0,					// and with *what* should be compared?
						'table' => 'tt_content',	// the table where the data comes from
						'select' => 'uid',				// the field that is used as data for comparison
						'where' => 'uid=###uid###'			// what should be selected? ###uid### is replaced with the UID of the current content element
					),
					'source' => 'ROOT/el/s_template',					// what should be copied
					'dest' => 'sheets/s_template/ROOT/el'		// where should it be copied to
				),*//*
				array (
					'method' => 'move',
						// define the condition when this modification should be executed
					'condition' => array (
						'source' => 'db',					// condition source is the database
						'if' => 'isGreater',				// how should be compared?
						'compareTo' => 0,					// and with *what* should be compared?
						'table' => 'tt_content',	// the table where the data comes from
						'select' => 'uid',				// the field that is used as data for comparison
						'where' => 'uid=###uid###'			// what should be selected? ###uid### is replaced with the UID of the current content element
					),
					'source' => 'ROOT/el',					// what should be copied
					'dest' => 'sheets/sCONF/ROOT/el'		// where should it be copied to
				),*/

				/*
				array (
					'method' => 'add',
					'source_type' => 'csl',
					'source' =>  'field',
					'source_config' => array(
						//'source' => 'cce',
				        //'cefield' => 'pi_flexform',
						//'isXML' => true,
						'table' => 'tt_content',
						'db_field' => 'pi_flexform',
						'path' => 'sDEF/lDEF',
						'xml_field' => 'what_to_display'

						),
					'type' => 'sheets'

				),
				*/
				/*
				array (
					'method' => 'add',
					'source_type' => 'csl',
					'source' =>  'condition',
					'condition' => array(
						'source' => 'cce',
				        'cefield' => 'pi_flexform',
						'isXML' => true,
						'path' => 'data/sDEF/lDEF/what_to_display/vDEF',

						'if' => 'notEqual',
						//'compareTo' => 'MADS'
						),
					'type' => 'fields'

				),*/
				array (
					'method' => 'function_call',
						// define the condition when this modification should be executed
					'condition' => array (
						'source' => 'db',					// condition source is the database
						'if' => 'isGreater',				// how should be compared?
						'compareTo' => 0,					// and with *what* should be compared?
						'table' => 'tt_content',	// the table where the data comes from
						'select' => 'uid',				// the field that is used as data for comparison
						'where' => 'uid=###uid###'			// what should be selected? ###uid### is replaced with the UID of the current content element
					),
					'function' => 'tx_pure_addFieldsToFlexForm->user_addSheets'
					//'source' => 'ROOT/el',					// what should be copied
					//'dest' => 'sheets/sCONF/ROOT/el'		// where should it be copied to
				)
				/*array (
					'method' => 'move',
						// define the condition when this modification should be executed
						'condition' => array (
						'source' => 'db',					// condition source is the database
						'if' => 'isGreater',				// how should be compared?
						'compareTo' => 0,					// and with *what* should be compared?
						'table' => 'tt_content',	// the table where the data comes from
						'select' => 'uid',				// the field that is used as data for comparison
						'where' => 'uid=###uid###'			// what should be selected? ###uid### is replaced with the UID of the current content element
					),
					'source' => 'sheets/sDEF/ROOT/el',					// what should be copied
					'dest' => 'sheets/sDEF/ROOT/el'		// where should it be copied to
				)*/

			)
		)
	);

	var $cleanUpField = 'pi_flexform';
	//Hook for dynamic e.g. Organisation list selectors
	/*var $hooks = array(
		'EXT:pure/class.tx_pure_dcahooks.php:tx_pure_dcahooks'
	);*/
}
if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/pure/class.tx_pure_pichange.php']) {
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/pure/class.tx_pure_pichange.php']);
}
?>