<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2009-2010 Mads Sandberg Brun <msb@cs.au.dk>
 *  (c) 2009-2010 Peter Sandberg Brun <psb@cs.au.dk>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

require_once(t3lib_extMgm::extPath('pure').'class.tx_pure_rest.php');
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 *
 *
 *
 */
/**
 * Class that can be used from XSLT files.
 *
 * @author	Mads Sandberg Brun <msb@cs.au.dk>
 * @author	Peter Sandberg Brun <psb@cs.au.dk>
 * @package	TYPO3
 * @subpackage	tx_pure
 */
class tx_pure_xsltfunctions
{
	public static function infoExistForPerson($url, $func, $personId)
	{
		//Get only information needed.
		$parray=array(
				'associatedPersonEmployeeIds.value' => $personId,
                'window.size' => '0'
		);
        if ($func == 'publications') {
            $parray['hideExternalPublications'] = 'false'; //Include all publications.
        }
		return self::inforExist($url, $func, $parray);
	}

    public static function infoExistForOrganisation($url, $func, $uuid)
	{
		//Get only information needed.
		$parray=array(
				'owningOrganisationUuids.uuid' => $uuid,
                'window.size' => '0'
		);
		return self::inforExist($url, $func, $parray);
	}

    /**
     * TODO: PURE4 have not selectedByPersons field.
     * TODO: Remove from templates.
     */
	public static function haveSelectedByPersons($url, $func, $personId)
	{
		//Get only information needed.
		$parray=array(
				'personnelIds' => $personId,
				'selectedByPersons' => 'true',
                'window.size' => '0'
		);
		return self::inforExist($url, $func, $parray);
	}

    private static function inforExist($url, $func, array $parray)
    {
        $rest = new tx_pure_rest($url, NULL);
		$xmlDoc = $rest->callFunction($func, $parray);

		if ($xmlDoc == NULL)
		{
			return false;
		}

		$xp = new DOMXPath($xmlDoc);
		$count = intval($xp->evaluate('string(//core:count)'));
		return $count > 0;
    }
	
	
	


}
if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/pure/class.tx_pure_xsltfunctions.php']) {
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/pure/class.tx_pure_xsltfunctions.php']);
}

?>