<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2009-2010 Mads Sandberg Brun <msb@cs.au.dk>
 *  (c) 2009-2010 Peter Sandberg Brun <psb@cs.au.dk>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

require_once(t3lib_extMgm::extPath('pure').'hooks/class.tx_pure_processing.php');
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 *
 *
 *   39: class tx_pure_processing_getActivities implements tx_pure_processing
 *   49:     public function process($xml, tx_pure_pi $pi)
 *
 * TOTAL FUNCTIONS: 1
 * (This index is automatically created/updated by the extension "extdeveval")
 *
 */
class tx_pure_processing_getActivities implements tx_pure_processing {


	/**
	 * Used to insert localized links before doing XSLT transformation.
	 *
	 * @param	object		$xml: The XML document from the PURE webservice.
	 * @param	object		$pi: The tx_pure_pi object.
	 * @return	void
	 */
	public function process(DOMDocument $xml, tx_pure_pi $pi, array $hookParams = array())
	{
		$xp = new DOMXPath($xml);

		$domNodeList = $xp->query('//core:result/core:content');
		foreach($domNodeList as $domNode){
			$typo3 = $domNode->appendChild(new DOMElement("typo3"));
		    $node = $typo3->appendChild(new DOMElement("links"));

		    $actId = $xp->evaluate('string(@uuid)', $domNode);
		    //Add actlink, if they exist
		   	if ($actId)
		   	{
			    $link = $node->appendChild(new DOMElement('activityUrl'));
			   	$url = $pi->pi_linkTP_keepPIvars_url(array('actId' => $actId, 'personId' => $pi->piVars['personId']), $pi->allowCaching, 1,  $pi->conf['singlePid']);
			   	$text = $link->appendChild(new DOMText($url));
		   	}

            //Add grouping values here:
            ///////@xsi:type  => activity:typeClassification/core:term/core:localizedString[@locale= 'en_GB' /'da_DK']
            //activityType => activity:typeClassification/core:term/core:localizedString[@locale= 'en_GB' /'da_DK']
            //startYear => activity:personAssociation/activity:startDate/core:year[1]
           
            $activityType = $domNode->appendChild(new DOMElement("activityType"));
            $text = $activityType->appendChild(new DOMText($xp->evaluate("string(activity:typeClassification/core:term/core:localizedString[@locale='en_GB'])", $domNode)));

            $startYear = $domNode->appendChild(new DOMElement("startYear"));
            $text = $startYear->appendChild(new DOMText($xp->evaluate("string(activity:personAssociation/activity:startDate/core:year[1])", $domNode)));
		}

		$typo3 = $xml->appendChild(new DOMElement("typo3"));
	    $node = $typo3->appendChild(new DOMElement("links"));
		//Add sorting links:

	    $link = $node->appendChild(new DOMElement('sortDateUrl'));
   		$url = $pi->pi_linkTP_keepPIvars_url(array('actsort' => 'startDate', 'showType' => $pi->piVars['showType'], 'personId' => $pi->piVars['personId'], 'showAll' => $pi->piVars['showAll'], 'sword' => $pi->piVars['sword']), $pi->allowCaching, 0);
   		$text = $link->appendChild(new DOMText($url));

   		$link = $node->appendChild(new DOMElement('sortTitleUrl'));
   		$url = $pi->pi_linkTP_keepPIvars_url( array('actsort' => 'title', 'showType' =>$pi->piVars['showType'], 'personId' => $pi->piVars['personId'], 'showAll' => $pi->piVars['showAll'], 'sword' => $pi->piVars['sword']), $pi->allowCaching, 0);
   		$text = $link->appendChild(new DOMText($url));

		//Selected by persons links:
		$link = $node->appendChild(new DOMElement('allActivitiesUrl'));
   		$url = $pi->pi_linkTP_keepPIvars_url(array('showType' => $pi->piVars['showType'], 'showAll' => 'true', 'personId' => $pi->piVars['personId'],'actsort' => $pi->piVars['actsort']), $pi->allowCaching, 1);
   		$text = $link->appendChild(new DOMText($url));

   		$link = $node->appendChild(new DOMElement('selectedActivitiesUrl'));
   		$url = $pi->pi_linkTP_keepPIvars_url(array('showType' => $pi->piVars['showType'], 'showAll' => 'false', 'personId' => $pi->piVars['personId'],'actsort' => $pi->piVars['actsort']), $pi->allowCaching, 1);
   		$text = $link->appendChild(new DOMText($url));

	}
}


if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/pure/hooks/class.tx_pure_processing_getActivities.php']) {
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/pure/hooks/class.tx_pure_processing_getActivities.php']);
}

?>