<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2009-2010 Mads Sandberg Brun <msb@cs.au.dk>
 *  (c) 2009-2010 Peter Sandberg Brun <psb@cs.au.dk>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

require_once(t3lib_extMgm::extPath('pure').'hooks/class.tx_pure_processing.php');
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 *
 *
 *   39: class tx_pure_processing_getKeywords implements tx_pure_processing
 *   49:     public function process($xml, tx_pure_pi $pi)
 *
 * TOTAL FUNCTIONS: 1
 * (This index is automatically created/updated by the extension "extdeveval")
 *
 */
class tx_pure_processing_getOrganisations implements tx_pure_processing {


	/**
	 * Used to insert localized links before doing XSLT transformation.
	 *
	 * @param	object		$xml: The XML document from the PURE webservice.
	 * @param	object		$pi: The tx_pure_pi object.
	 * @return	void
	 */
	public function process(DOMDocument $xml, tx_pure_pi $pi, array $hookParams = array())
	{
        $xp = new DOMXPath($xml);

		$domNodeList = $xp->query('//core:result/core:content');
		foreach($domNodeList as $domNode)
        {
			$typo3 = $domNode->appendChild(new DOMElement("typo3"));
		    $node = $typo3->appendChild(new DOMElement("links"));

		    $uuid = $xp->evaluate('string(@uuid)', $domNode);
		   	if ($uuid)
		   	{
                //Add links to publications and activities.
		   		$link = $node->appendChild(new DOMElement('publicationUrl'));
		   		$url = $pi->pi_linkTP_keepPIvars_url(array('showType' => 'pub' , 'orgId' => $personnelId), $pi->allowCaching, 1,  $pi->conf['singlePid']);
                $text = $link->appendChild(new DOMText($url));

				$link = $node->appendChild(new DOMElement('activitiesUrl'));
		   		$url = $pi->pi_linkTP_keepPIvars_url(array('showType' => 'act', 'orgId' => $personnelId), $pi->allowCaching, 1,  $pi->conf['singlePid']);
		   		$text = $link->appendChild(new DOMText($url));
		   	}
		}
	}
}


if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/pure/hooks/class.tx_pure_processing_getOrganisations.php']) {
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/pure/hooks/class.tx_pure_processing_getOrganisations.php']);
}

?>