<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2009-2010 Mads Sandberg Brun <msb@cs.au.dk>
 *  (c) 2009-2010 Peter Sandberg Brun <psb@cs.au.dk>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

require_once(t3lib_extMgm::extPath('pure') . 'hooks/redirectHooks/class.tx_pure_redirect.php');

/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 */
class tx_pure_redirect_vbn implements tx_pure_redirect {

    public static $PortalPrefix = 'http://vbn.aau.dk/';

    /**
     * Redirect method that return a url or false if it have no redirect.
     *
     * @param	array		$config: The Config with parameters.
     * @param	object		$pi: The tx_pure_pi object.
     * @return	void
     */
    public function redirect(array $config, $pi) {
        $urlPrefix = self::$PortalPrefix . $pi->pi_getLL('redirect_lang') . '/';
        $url = false;
        if ($config['keywordId']) {
            
        } else if ($config['orgId']) {
            
        } else if ($config['actId']) {
            $url = $urlPrefix . 'activities/pub_' . $config['actId'] . '.html';
            /* if($config['personId'])
              $url .= '?id='.$config['personId']; */
        } else if ($config['pubId']) {
            $url = $urlPrefix . 'publications/pub_' . $config['pubId'] . '.html';
            /* if($config['personId'])
              $url .= '?id='.$config['personId']; */
        } else if ($config['personId']) {
            //full or show CV, act or pub:
            switch ($config['showType']) {
                case 'pubrss' :
                    $url = $urlPrefix . 'persons/person_'. $config['personId'] . '/publications.rss';
                    break;
                case 'act':
                    $url = $urlPrefix . 'persons/person_' . $config['personId'] . '/activities.html';
                    break;
                case 'pub':
                    $url = $urlPrefix . 'persons/person_' . $config['personId'] . '/publications.html';
                    break;
                case 'cv':
                    $url = $urlPrefix . 'persons/person_' . $config['personId'] . '.html';
                    //$url = $urlPrefix . $config['personId'] . '/cv';
                    break;
                case 'keyword':

                    break;
                default:
                    $url = $urlPrefix . 'persons/person_' . $config['personId'] . '.html';
            }
        }
        return $url;
    }

}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/pure/hooks/redirectHooks/class.tx_pure_redirect_vbn.php']) {
    include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/pure/hooks/redirectHooks/class.tx_pure_redirect_vbn.php']);
}

?>
