<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2009-2010 Mads Sandberg Brun <msb@cs.au.dk>
 *  (c) 2009-2010 Peter Sandberg Brun <psb@cs.au.dk>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 *
 *
 */

require_once(PATH_tslib.'class.tslib_pibase.php');
require_once(PATH_typo3.'sysext/lang/lang.php');
require_once(t3lib_extMgm::extPath('pure').'class.tx_pure_rest.php');
require_once(t3lib_extMgm::extPath('pure').'class.tx_pure_cache.php');
require_once(t3lib_extMgm::extPath('pure').'class.tx_pure_xsltfunctions.php');
require_once(t3lib_extMgm::extPath('pure').'class.tx_pure_image.php');
require_once(t3lib_extMgm::extPath('pure').'pi/class.tx_pure_pi_publications.php');
require_once(t3lib_extMgm::extPath('pure').'pi/class.tx_pure_pi_persons.php');
require_once(t3lib_extMgm::extPath('pure').'pi/class.tx_pure_pi_activities.php');
require_once(t3lib_extMgm::extPath('pure').'pi/class.tx_pure_pi_organisations.php');

/**
 * Plugin 'PURE' for the 'pure' extension.
 *
 * @author	Mads Sandberg Brun <msb@cs.au.dk>
 * @author	Peter Sandberg Brun <psb@cs.au.dk>
 * @package	TYPO3
 * @subpackage	tx_pure
 */
class tx_pure_pi extends tslib_pibase {
	var $prefixId      = 'tx_pure_pi';		// Same as class name
	var $scriptRelPath = 'pi/class.tx_pure_pi.php';	// Path to this script relative to the extension dir.
	var $extKey        = 'pure';	// The extension key.
	var $pi_checkCHash = true;   // if this is a USER plugin
	var $allowCaching = 0;
	//var $pi_USER_INT_obj = 1;    // Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!

	
	var $config;
	var $pureUrl;
	var $currentShowId = 0; //Used to proces correct ajax result.
	var $currentRecord; //Used to proces correct ajax result.
	var $cookie_time = 300;

    var $linkToPortal = false;
	var $resultCount = 0;

    //var $personType;

	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	string		The content that is displayed on the website
	 */
	function main($content, $conf) {
		$this->init($conf);

		$this->cookie_time += time();

		//$this->isSearchBot = $this->isUserBot();
		$this->setCacheTimeOutForPage();

		if($this->conf['include_jquery'])
		{
			$this->includeJQueryHeader();
		}
		if ($this->conf['include_pureJS'])
		{
            $this->includePureJS();
		}


        //Handle pure tag
        if ($this->cObj->parameters)
        {
            $content .= $this->handlePureTag();
            return $this->pi_wrapInBaseClass($content);
        }


		$rssRequest = ($this->config['showType'] == 'pubrss');
		$jqueryRequest = $this->config['ajax_request'];
        
		if($jqueryRequest || $rssRequest)
		{
			//Render as 'UTF-8'.
			$GLOBALS['TSFE']->renderCharset = 'UTF-8';
			$GLOBALS['TSFE']->localeCharset = 'UTF-8';
			$currentRecord = $GLOBALS['TSFE']->currentRecord;
			if (strlen($currentRecord) > 11) //tt_content:1234
				$currentRecord = substr($currentRecord, 11);
			$currentRecord = intval($currentRecord);
            
			//It is not this tt_content elements responsible!
			if ($currentRecord != intval($this->config['ajax_content_id']) && $this->config['sDEF']['what_to_display']) //$this->conf['singlePid'] != $GLOBALS['TSFE']->id
			{
				return '';
			}
		}

        //If something to display from flexform. Else is can be the Master page
		if($this->config['sDEF']['what_to_display']) 
		{
	    	$code = $this->config['sDEF']['what_to_display'];
	    	//Override piVars with data from pi_flexform.

	    	$jqueryIndexRequest = $this->config['ajax_request'] || $rssRequest;
    		$index = intval($this->config['ajax_index']);

            //Check index is out of scope of this plugin, and to not process
    		if ($jqueryIndexRequest && ($index <= 0 || $index > count(explode(',',$this->config['sDEF']['what_to_display']))))
    		{
                exit;
    		}
			$this->currentShowId = 0;
    		//Normal processing
    		foreach(array_keys($this->config) as $what) {

	    		$theCode = explode('-', $what);
				$theCode = strtoupper($theCode[0]);
                
                if (!empty($theCode) && is_array($this->config[$what]))
                {
                    if ($jqueryIndexRequest && $this->currentShowId != $index)
                    {
                        //Ignore it, and try the next index.
                    }
                    else
                    {
                        $content .= $this->handleFlexformConfiguration($theCode, $this->config[$what]);
                        $this->updateAjaxIds();
                    }
                    $this->currentShowId++;
                }
		    }
	    }
	    else if ($this->isMasterPage())
	    {
	    	//Master page content. May not cache the master page, because the output is dynamic.
	    	$this->pi_USER_INT_obj = 1;
	    	$GLOBALS['TSFE']->set_no_cache();
            
            $content = $this->handleMasterPage();
            
            /*
			if($this->noindexoutput)
			{
				//Do make any robots index the site.
				$this->insertNoIndex();
			}
            */
	    }
        
	    if ($rssRequest)
	    {
	    	$GLOBALS['TSFE']->set_no_cache();
	    	Header('Cache-Control: no-cache');
  			Header('Pragma: no-cache');
  			Header('Content-Type: application/rss+xml; charset=utf-8');
  			print($content);
	    	exit;
	    }
	    else if ($jqueryRequest)
	    {
	    	//May cache the content, if a user requested a specific page
	    	if (!$this->conf['cacheTime'] || !$this->config['userclick'])
	    	{
	    		Header('Cache-Control: no-cache');
	  			Header('Pragma: no-cache');
	    	}
	    	else
	    	{
	    		Header('Cache-Control: public, max-age=' . (int)$this->conf['cacheTime']);
	    	}

	    	//Header('Cache-Control: no-cache');
  			//Header('Pragma: no-cache');
	    	Header('Content-Type: text/html; charset=utf-8');
  			print($content);
	    	exit;
	    }

		return $this->pi_wrapInBaseClass($content);
	}


    private function handleFlexformConfiguration($theCode, array $whatConfig)
    {
        $pub_pi = new tx_pure_pi_publications($this);
        $act_pi = new tx_pure_pi_activities($this);
        $per_pi = new tx_pure_pi_persons($this);
        

        switch ($theCode) {
            case 'SINGLE_PERSON':
                $displayConfig = array();
                $displayConfig['personEmployeeIds'] = $this->replaceLineAndSpaceWithCommaAndLower($whatConfig['single_person_email']);
                if (trim($whatConfig['single_person_templateName_userdefined']))
                    $templateName = $whatConfig['single_person_templateName_userdefined'];
                else
                    $templateName = $whatConfig['single_person_templateName'];

                $displayConfig['tabIndexToOpen'] = $whatConfig['single_person_tabIndex'];

                return $per_pi->displayList($displayConfig, $templateName);
            case 'SINGLE_PUBLICATION':
                $displayConfig = array();
                $displayConfig['pubId'] = $this->replaceLineAndSpaceWithCommaAndLower($whatConfig['single_publication_id']);

                if (trim($whatConfig['single_publication_templateName_userdefined']))
                    $templateName = $whatConfig['single_publication_templateName_userdefined'];
                else
                    $templateName = $whatConfig['single_publication_templateName'];
                return $pub_pi->displaySingle($displayConfig, $templateName);
            case 'SINGLE_ACTIVITY':
                $displayConfig = array();
                $displayConfig['actId'] = $this->replaceLineAndSpaceWithCommaAndLower($whatConfig['single_activity_id']);
                if (trim($whatConfig['single_activity_templateName_userdefined']))
                    $templateName = $whatConfig['single_activity_templateName_userdefined'];
                else
                    $templateName = $whatConfig['single_activity_templateName'];
                return $act_pi->displaySingle($displayConfig, $templateName);

            case 'SINGLE_ORGANISATION':
                $displayConfig = array();
                $displayConfig['orgId'] = $this->getRootOrganisations($whatConfig['single_organisation_organisation']);

                if (trim($whatConfig['single_organisation_templateName_userdefined']))
                    $templateName = $whatConfig['single_organisation_templateName_userdefined'];
                else
                    $templateName = $whatConfig['single_organisation_templateName'];

                $org_pi = new tx_pure_pi_organisations($this);
                return $org_pi->displaySingle($displayConfig, $templateName);
            case 'PERSONS':
                $displayConfig = array();

                $displayConfig['orgId'] = $this->getDescandentOrganisations($whatConfig['persons_organisation']);

                //var_dump($displayConfig['orgId']);

                //$displayConfig['orgId'] = $whatConfig['persons_organisation'];
                $displayConfig['personEmployeeIds'] = $this->replaceLineAndSpaceWithCommaAndLower($whatConfig['persons_emails']);

                $displayConfig['sort'] = $whatConfig['persons_ordering'];
                $displayConfig['ascDesc'] = $whatConfig['persons_ascDesc'];
                $displayConfig['state'] = $whatConfig['persons_state'];
                $displayConfig['type'] = $this->getDescandentClassifications($whatConfig['persons_type'],'/dk/atira/pure/person/employmenttypes');

                if ($displayConfig['type'] == 'all') //Version before 2.0.4, 'all' values was used to indentify the no value.
                    $displayConfig['type'] = '';

                /*
                //PURE 3 -> 4
                if (in_array(strtolower($displayConfig['type']), array('tap', 'vip')))
                {
                    $displayConfig['type'] = '/dk/atira/pure/person/employmenttypes/'. strtolower( $displayConfig['type']);
                }
                else if (in_array(strtolower($displayConfig['type']), array('stud', 'phd')))
                {
                    //STUD and PHD is in VIP
                    $displayConfig['type'] = '/dk/atira/pure/person/employmenttypes/vip';
                }
                 */

                if (trim($whatConfig['persons_templateName_userdefined']))
                    $templateName = $whatConfig['persons_templateName_userdefined'];
                else
                    $templateName = $whatConfig['persons_templateName'];

                return $per_pi->displayList($displayConfig, $templateName);
            case 'PUBLICATIONS' :
                $displayConfig = array();
                $displayConfig['orgId'] = $this->getDescandentOrganisations($whatConfig['publications_organisation']);
                $displayConfig['personEmployeeIds'] = $this->replaceLineAndSpaceWithCommaAndLower($whatConfig['publications_persons_emails']);
                $displayConfig['publicationTypes'] = $this->getDescandentClassifications($whatConfig['publications_types'], '/dk/atira/pure/publication/publicationtypes');
                $displayConfig['submittedyear'] = $whatConfig['publications_persons_year'];
                $displayConfig['selectedByPersons'] = $whatConfig['publications_showAll'] ? false : true;
                $displayConfig['pubsort'] = $whatConfig['publications_ordering'];
                $displayConfig['ascDesc'] = $whatConfig['publications_ascDesc'];
                $displayConfig['groupby'] = $whatConfig['publications_groupby'];
                $displayConfig['groupby2'] = $whatConfig['publications_groupby2'];
                $displayConfig['pubIds'] = $this->replaceLineAndSpaceWithCommaAndLower($whatConfig['publications_ids']);
                $displayConfig['size'] = $whatConfig['publications_size'];
                if (trim($whatConfig['publcations_templateName_userdefined']))
                    $templateName = $whatConfig['publcations_templateName_userdefined'];
                else
                    $templateName = $whatConfig['publcations_templateName'];
                if ($this->config['showType'] == 'pubrss')
                {
                    $displayConfig['groupby'] = '';
                    $displayConfig['groupby2'] = '';
                    $displayConfig['ascDesc'] = 'desc';
                    $displayConfig['pubsort'] = 'created';
                    $displayConfig['size'] = $this->conf['rss_list_size'];
                    $templateName = $this->conf['templates.']['singlePidsTemplates.']['rss'];
                }

                return $pub_pi->displayList($displayConfig, $templateName);
            case 'ACTIVITIES' :
                $displayConfig = array();
                $displayConfig['year'] = $whatConfig['activities_year'];
                $displayConfig['orgId'] = $this->getDescandentOrganisations($whatConfig['activities_organisation']);
                $displayConfig['personEmployeeIds'] = $this->replaceLineAndSpaceWithCommaAndLower($whatConfig['activities_persons_emails']);
                $displayConfig['activityTypes'] = $this->getDescandentClassifications($whatConfig['activities_types'], '/dk/atira/pure/activity/activitytypes');
                $displayConfig['selectedByPersons'] = $whatConfig['activities_showAll'] ? false : true;
                $displayConfig['actsort'] = $whatConfig['activities_ordering'];
                $displayConfig['ascDesc'] = $whatConfig['activities_ascDesc'];
                $displayConfig['groupby'] = $whatConfig['activities_groupby'];
                $displayConfig['groupby2'] = $whatConfig['activities_groupby2'];
                $displayConfig['actIds'] = $this->replaceLineAndSpaceWithCommaAndLower($whatConfig['activities_ids']);
                $displayConfig['size'] = $whatConfig['activities_size'];
                if (trim($whatConfig['activities_templateName_userdefined']))
                    $templateName = $whatConfig['activities_templateName_userdefined'];
                else
                    $templateName = $whatConfig['activities_templateName'];
                //PURE 3 -> 4
                if ($displayConfig['actsort'] == 'start')
                    $displayConfig['actsort'] = 'startDate';
                

                return $act_pi->displayList($displayConfig, $templateName);

            case 'ORGANISATIONS':
                $displayConfig = array();
                $displayConfig['orgId'] = $this->getDescandentOrganisations($whatConfig['organisations_organisation']);
                $displayConfig['rootOrgIds'] = $this->getRootOrganisations($whatConfig['organisations_organisation']);

                if (trim($whatConfig['organisations_templateName_userdefined']))
                    $templateName = $whatConfig['organisations_templateName_userdefined'];
                else
                    $templateName = $whatConfig['organisations_templateName'];

                $org_pi = new tx_pure_pi_organisations($this);
                return $org_pi->displayList($displayConfig, $templateName);

            case 'SEARCH_PERSONS':
                $ids = $this->getDescandentOrganisations($whatConfig['organisations']);
                $resultPage = $whatConfig['redirectToSinglePid'] ? $this->conf['singlePid'] : 0;
                return $per_pi->displaySearch($whatConfig['search_persons_result_templateName'],
                                                            $whatConfig['search_persons_templateName'],
                                                            $ids,
                                                            $jqueryIndexRequest,
                                                            $resultPage,
                                                            $whatConfig['redirectToSinglePid']);
            case 'SEARCH_PUBLICATIONS':
                $ids = $this->getDescandentOrganisations($whatConfig['organisations']);
                $resultPage = $whatConfig['redirectToSinglePid'] ? $this->conf['singlePid'] : 0;
                return $pub_pi->displaySearch($whatConfig['search_publications_result_templateName'],
                                                            $whatConfig['search_publications_templateName'],
                                                            $ids,
                                                            $jqueryIndexRequest,
                                                            $resultPage,
                                                            $whatConfig['redirectToSinglePid']);
            case 'SEARCH_ACTIVITIES':
                $ids = $this->getDescandentOrganisations($whatConfig['organisations']);
                $resultPage = $whatConfig['redirectToSinglePid'] ? $this->conf['singlePid'] : 0;
                return $act_pi->displaySearch($whatConfig['search_activities_result_templateName'],
                                                            $whatConfig['search_activities_templateName'],
                                                            $ids,
                                                            $jqueryIndexRequest,
                                                            $resultPage,
                                                            $whatConfig['redirectToSinglePid']);
            default:
                return '';
        }
    }

    
    private function handlePureTag()
    {
        require_once(t3lib_extMgm::extPath('pure').'class.tx_pure_tag.php');
        $tagParser = t3lib_div::makeInstance('tx_pure_tag');
        return $tagParser->parse($this);
    }

    private function handleMasterPage()
    {
        $pub_pi = new tx_pure_pi_publications($this);
        $act_pi = new tx_pure_pi_activities($this);
        $per_pi = new tx_pure_pi_persons($this);

        // If all links should go to Portal, we will also redirect request to
        // the master page to the portal.
        if ($this->linkToPortal) {
            $this->makeRedirect();
        }

        if ($this->config['sword'])
        {
            //Make search
            $type = $this->piVars['search_type'];
            $orgs = '';
            if (isset($this->piVars['organisationIdsToChoose']))
                $orgs = htmlspecialchars($this->piVars['organisationIdsToChoose']);

            if ($type == 'publications')
            {
                return $pub_pi->displaySearch($this->conf['templates.']['singlePidsTemplates.']['search_publications_result'],
                                                        $this->conf['templates.']['singlePidsTemplates.']['search_publications'],
                                                        $orgs, $jqueryRequest, $this->conf['singlePid'], false);
            }
            else if ($type == 'activities')
            {
                return $act_pi->displaySearch($this->conf['templates.']['singlePidsTemplates.']['search_activities_result'],
                                                        $this->conf['templates.']['singlePidsTemplates.']['search_activities'],
                                                        $orgs, $jqueryRequest, $this->conf['singlePid'], false);
            }
            else if ($type == 'persons')
            {
                return $per_pi->displaySearch($this->conf['templates.']['singlePidsTemplates.']['search_persons_result'],
                                            $this->conf['templates.']['singlePidsTemplates.']['search_persons'],
                                            $orgs, $jqueryRequest, $this->conf['singlePid'], false);
            }
        }
        else if ($this->config['keywordId'])
        {
            //Show subKeyword and persons with this keyword
            return $per_pi->displayKeywordPage($this->config['keywordId'], $this->conf['templates.']['singlePidsTemplates.']['keyword_page']);
        }
        else if ($this->config['orgId'])
        {
            //'TEMPLATE_PERSONS_SIMPLE'
            $displayConfig = array();
            $displayConfig['orgId'] = $this->config['orgId'];
            return $per_pi->displayList($displayConfig, $this->conf['templates.']['singlePidsTemplates.']['persons']);
        }
        else if ($this->config['actId'] )
        {
            //TEMPLATE_SINGLE_ACTIVITY_FULL
            //Show single activite
            $displayConfig = array();
            $displayConfig['actId'] = $this->config['actId'];
            return $act_pi->displaySingle($displayConfig, $this->conf['templates.']['singlePidsTemplates.']['single_activity']);
        }
        else if ($this->config['pubId'])
        {
            //TEMPLATE_SINGLE_PUBLICATION_FULL
            //Show single publication
            $displayConfig = array();
            $displayConfig['pubId'] = $this->config['pubId'];
            return $pub_pi->displaySingle($displayConfig, $this->conf['templates.']['singlePidsTemplates.']['single_publication']);
        }
        else if ($this->config['personId'])
        {
            $displayConfig = array();
            $displayConfig['personId'] = $this->config['personId'];
            //full or show CV, act or pub:
            switch ($this->config['showType']) {
                case 'pubrss' :
                    $displayConfig['groupby'] = '';
                    $displayConfig['groupby2'] = '';
                    $displayConfig['ascDesc'] = 'desc';
                    $displayConfig['pubsort'] = 'created';
                    $displayConfig['size'] = $this->conf['rss_list_size'];
                    return $pub_pi->displayList($displayConfig, $this->conf['templates.']['singlePidsTemplates.']['rss']);
                case 'act':
                    //TEMPLATE_ACTIVITIES_SIMLPLE
                    $displayConfig['selectedByPersons'] = true;
                    //$displayConfig['groupby'] = '@xsi:type';
                    $displayConfig['size'] = 300; //TODO: Use TS.
                    return $act_pi->displayList($displayConfig, $this->conf['templates.']['singlePidsTemplates.']['activities']); //'Aktiviteter';
                case 'pub':
                    $displayConfig['selectedByPersons'] = true;
                    //TODO: PURE 4 do not support Category
                    //$displayConfig['groupby'] = 'publicationCategory'; //Make it group
                    $displayConfig['size'] = 300;
                    return $pub_pi->displayList($displayConfig, $this->conf['templates.']['singlePidsTemplates.']['publications']);
                    //$content .= $this->displayList($this->conf['templates.']['singlePidsTemplates.']['publications'], 'publicationYear,publicationCategory'); //set the ordering
                case 'cv':
                    //TEMPLATE_SIGNLE_PERSON_CV
                    return $per_pi->displayList($displayConfig, $this->conf['templates.']['singlePidsTemplates.']['cv']);
                case 'keyword':
                    //TEMPLATE_SIGNLE_PERSON_KEYWORD
                    $displayConfig = array();
                    $displayConfig['personId'] = $this->config['personId'];
                    return $per_pi->displayKeywords($displayConfig, $this->conf['templates.']['singlePidsTemplates.']['keyword']);
                default:
                    $displayConfig['foldOutFirstTab'] = true;
                    //TEMPLATE_SINGLE_PERSON_BASIC
                    //$displayConfig['state'] = 'both';
                    $content = $per_pi->displayList($displayConfig, $this->conf['templates.']['singlePidsTemplates.']['single_person']);
                    if ($this->getLastResultCount() === 0)
                    {
                        //Do make any robots index the site, because there where no result to show.
                        $this->insertNoIndex();
                    }
                    return $content;
            }
        }
        return '';
        /* TODO: Too slow method. Should save the image to disk in typo3temp and make links to these directly
			else if ($this->config['imageId'])
			{
				if (!$this->config['width'] || !$this->config['height']
					|| $this->config['width'] > 1000 || $this->config['height'] > 1000)
				{
					return 'Invalid image size';
				}
				else
				{
					$this->displayImage($this->config['imageId'], $this->config['width'], $this->config['height']);
					exit;
				}
			}*/

    }

    

	/*********************************************************
	 *
	 * 	Display functions
	 *
	 *********************************************************/


	


	

	
	





	/**
	 * ******************************************************
	 *
	 * 	Links functions
	 *
	 * ********************************************************/


	/**
	 * Returns a results browser.
	 * See pi_list_browseresults.
	 *
	 * @param	integer		$res_count: The resource count. See pi_list_browseresults.
	 * @return	string		HTML.
	 */
	function list_browseresults($res_count)
	{
		$this->internal['res_count'] = $res_count;

		//Get all the wrapper fields from TS.
		$wrapArrFields = explode(',', 'disabledLinkWrap,inactiveLinkWrap,activeLinkWrap,browseLinksWrap,showResultsWrap,showResultsNumbersWrap,browseBoxWrap');
		$wrapArr = array();
		foreach($wrapArrFields as $key) {
			if ($this->conf['pageBrowser.'][$key]) {
				$wrapArr[$key] = $this->conf['pageBrowser.'][$key];
			}
		}
		$this->internal['maxPages'] = $this->conf['pageBrowser.']['maxPages'];
		$this->internal['pagefloat'] = $this->conf['pageBrowser.']['pagefloat'];
		$this->internal['showFirstLast'] = $this->conf['pageBrowser.']['showFirstLast'];
		$this->internal['showRange'] = $this->conf['pageBrowser.']['showRange'];
		$this->internal['dontLinkActivePage'] = $this->conf['pageBrowser.']['dontLinkActivePage'];

		$this->pi_alwaysPrev = $this->conf['pageBrowser.']['alwaysPrev'];

		$this->pi_isOnlyFields = 'pointer,nojs,showAll';
		//$this->pi_lowerThan = 1000000;

		return $this->pi_list_browseresults($this->conf['pageBrowser.']['showResultCount'], $this->conf['pageBrowser.']['tableParams'],$wrapArr, 'pointer', $this->conf['pageBrowser.']['hscText']);

	}


	/**
	 * Link a string to the current page while keeping currently set values in piVars.
	 * Like pi_linkTP, but $urlParameters is by default set to $this->piVars with $overrulePIvars overlaid.
	 * This means any current entries from this->piVars are passed on (except the key "DATA" which will be unset before!) and entries in $overrulePIvars will OVERRULE the current in the link.
	 *
	 * @param	string		The content string to wrap in <a> tags
	 * @param	array		Array of values to override in the current piVars. Contrary to pi_linkTP the keys in this array must correspond to the real piVars array and therefore NOT be prefixed with the $this->prefixId string. Further, if a value is a blank string it means the piVar key will not be a part of the link (unset)
	 * @param	boolean		If $cache is set, the page is asked to be cached by a &cHash value (unless the current plugin using this class is a USER_INT). Otherwise the no_cache-parameter will be a part of the link.
	 * @param	boolean		If set, then the current values of piVars will NOT be preserved anyways... Practical if you want an easy way to set piVars without having to worry about the prefix, "tx_xxxxx[]"
	 * @param	integer		Alternative page ID for the link. (By default this function links to the SAME page!)
	 * @return	string		The input string wrapped in <a> tags
	 */
	function pi_linkTP_keepPIvars($str, $overrulePIvars=array(),$cache=0,$clearAnyway=0,$altPageId=0)
	{
		$piVars = $overrulePIvars;
		if ($this->config['pure_server'])
			$piVars = array_merge($piVars, array('pure_server' => $this->config['pure_server'] ));
		else
			$piVars = array_merge($piVars, array('pure_server' => null ));
		if (isset($this->piVars['nojs']))
			$piVars = array_merge($piVars, array('nojs' => nojs ));

        //$this->getPortalUrl($this->config);
        //var_dump($piVars);
        
            //  return '<a href="'.$portalUrl.'">'.$str.'</a>';
        //var_dump($portalUrl);
        //$this->pi_linkTP_keepPIvars_url();

		return parent::pi_linkTP_keepPIvars($str, $piVars, $cache, $clearAnyway, $altPageId);
	}

    function pi_linkTP_keepPIvars_url($overrulePIvars=array(),$cache=0,$clearAnyway=0,$altPageId=0)	{
        //Make links if there is no showType specified. TODO: Not to use 'showType'
        if ($this->linkToPortal) {
            $url = $this->getPortalUrlWithPIVars($overrulePIvars);
            if ($url) {
                return $url;
            }
        }
        /*else if (!isset($overrulePIvars['showType']))
        {
            //TODO: Should only go to portal if it should redirect to them.
            //$portalUrl = $this->getPortalUrl($overrulePIvars);
            //if ($portalUrl)
                //return $portalUrl;
        }*/
        return parent::pi_linkTP_keepPIvars_url($overrulePIvars, $cache, $clearAnyway, $altPageId);
    }


	/**
	 * Same as pi_linkTP_keepPIvars_url but with extra pi_vars for the ajax_index and ajax_content_id.
	 * Used by links to RSS and other absolute links that requ.
	 *
	 * @param	array		See pi_linkTP_keepPIvars
	 * @param	boolean		See pi_linkTP_keepPIvars
	 * @param	boolean		See pi_linkTP_keepPIvars
	 * @param	integer		See pi_linkTP_keepPIvars
	 * @return	string		The URL ($this->cObj->lastTypoLinkUrl)
	 * @see pi_linkTP_keepPIvars()
	 */
	function pi_linkTP_keepPIvars_ajax_id_url($overrulePIvars=array(),$cache=0,$clearAnyway=0,$altPageId=0)
	{
        if ($this->linkToPortal) {
            $url = $this->getPortalUrlWithPIVars($overrulePIvars);
            if ($url) {
                return $url;
            }
        }
		$jqPiVars = array('ajax_request_id' => intval($this->currentRecord).':'.intval($this->currentShowId) );
		$jqueryLink = $this->pi_linkTP_keepPIvars('|', array_merge($jqPiVars,$overrulePIvars), $cache, $clearAnyway, $altPageId);
		$jqueryLink = $this->cObj->lastTypoLinkUrl;
		return $jqueryLink;
	}

    private function getPortalUrlWithPIVars($piVars) {
        if (!(isset($piVars['pubsort']) || isset($piVars['actsort']))) {
            $portalUrl = $this->getPortalUrl($piVars);
            if ($portalUrl) {
                return $portalUrl;
            }
        }
        return FALSE;
    }


	/*********************************************************
	 *
	 * 	Ajax functions
	 *
	 *********************************************************/

	/**
	 * Sets $this->config['ajax_content_id'] and $this->config['ajax_index'] to the current generated output. Used in main().
	 *
	 * @return	void
	 */
	private function updateAjaxIds()
	{
		$currentRecord = $GLOBALS['TSFE']->currentRecord;
		if (strlen($currentRecord) > 11) //tt_content:
			$currentRecord = substr($currentRecord, 11);
		$currentRecord = intval($currentRecord);
		$this->config['ajax_content_id'] = $currentRecord;
		$this->config['ajax_index'] = $this->currentShowId + 1;
	}

	/**
	 * Include the jQuery libary in the header.
	 *
	 * @return	void
	 */
	private function includeJQueryHeader()
	{
        $GLOBALS['TSFE']->getPageRenderer()->addJsFile(t3lib_extMgm::siteRelPath($this->extKey).'jquery.min.js');
	}

    private function includePureJS()
    {
        $GLOBALS['TSFE']->getPageRenderer()->addJsFile(t3lib_extMgm::siteRelPath($this->extKey).'pure.min.js');
    }

	/**
	 * Includes nosciprt tag refreshed the current page.
	 *
	 * @return	void
	 */
	private function includeNoscriptHeader()
	{
		if (!isset($this->piVars['nojs'])) {
			$url = htmlentities(t3lib_div::getIndpEnv('TYPO3_SITE_URL') . $this->pi_linkTP_keepPIvars_url(array(nojs => 'nojs'),$this->allowCaching, 1));
			$noscript = '<noscript><meta http-equiv="refresh" content="0; URL='.$url.'" /></noscript>';
			$GLOBALS['TSFE']->additionalHeaderData[$this->prefixId.'noscript'] = $noscript;
		}
	}

	/**
	 * Display a single ajax loading page, with a loading image. Will load the data async on the client with JavaScript.
	 *
	 * @return	string		The ajax loading page in HTML.
	 */
	private function displaySingleLoadingPage()
	{
		//Do not cahce this:
		$GLOBALS['TSFE']->set_no_cache();

		$content = '<a class="ajax_request" href="' .
					htmlentities($this->pi_linkTP_keepPIvars_url())
					 . '">'.
					'</a>';
		//$url = htmlentities(t3lib_div::getIndpEnv('TYPO3_SITE_URL') . $this->pi_linkTP_keepPIvars_url(array(nojs => 'nojs'),$this->allowCaching, 1));
		//$noscript = '<noscript><meta http-equiv="refresh" content="0; URL='.$url.'" /></noscript>';
		$link = $this->pi_linkTP_keepPIvars("here", array(nojs => 'nojs'),$this->allowCaching);
		$noscript = '<noscript><div class="pure-nojs">This page works best with JavaScript enabled. Click '.$link.' to see the content anyway.</div></noscript>';

		return $this->appendPureDiv($content, true).$noscript;
	}

	/**
	 * Appends a div tag with a hided loading picture used by pure.js.
	 *
	 * @param	string		$content: The content to append.
	 * @param	[type]		$hideImage: ...
	 * @return	string		HTML.
	 */
	public function appendPureDiv($content, $hideImage = true)
	{
		if ($this->config['ajax_request'] || $this->config['showType'] == 'pubrss')
		{
			$GLOBALS['TSFE']->set_no_cache();
			return $content;
		}
		//Please cache this.
		//id="currentId:currentIndex" to proces ajax request to the right.
		return '<div class="pure-result-page" id="p'.intval($this->currentRecord) . ':'. intval($this->currentShowId) .'" >'
					.'<div class="pure-result">'.$content.'</div>'
					.$this->loadingImg($hideImage)
				.'</div>';
	}
    
	/**
	 * Retuns a loading image.
	 *
	 * @param	boolean		$hide: Set to false to hide the picture.
	 * @return	string		HTML.
	 */
	private function loadingImg($hide = false)
	{
		return '<div ' .($hide ? 'style="display:none;" ': '') .'class="pure_loading" ><img src="'
			 		.t3lib_extMgm::siteRelPath($this->extKey).$this->pi_getLL('loadingFilePath')
			 		.'" alt="" /></div>';
	}




	/*********************************************************
	 *
	 * 	Cache functions
	 *
	 *********************************************************/


	/**
	 * Insert $storeArr into the cache.
	 *
	 * @param	string		$queryUri: The uri used.
	 * @param	string		$template: The template used.
	 * @param	array		$storeArr: The data to store in cache.
	 * @return	void
	 */
	public function insertCachedData($queryUri, $template, $storeArr)
	{
        tx_pure_cache::insertCachedData($storeArr, array($template,$queryUri), $this->conf['cacheTime']);
	}

	/**
	 * Gets the data from the cache, if in cache.
	 *
	 * @param	string		$queryUri: The uri used.
	 * @param	string		$template: The template used.
	 * @return	array		Returns NULL if cache not found.
	 */
	public function getCachedData($queryUri, $template)
	{
        return tx_pure_cache::getCachedData(array($template,$queryUri), $this->conf['cacheTime']);
	}

	/**
	 * Will update the page cache time out, so this plug-in's output will be regenerated, when needed!
	 *
	 * @return	void
	 */
	private function setCacheTimeOutForPage()
	{
		if (!$this->allowCaching)
			return;
		$newCacheTime = $this->conf['cacheTime'];
		if (intval($GLOBALS['TSFE']->cacheTimeOutDefault) > $newCacheTime || intval($GLOBALS['TSFE']->cacheTimeOutDefault) < 1)
		{
			$GLOBALS['TSFE']->cacheTimeOutDefault = $newCacheTime;
		}
	}


	/*********************************************************
	 *
	 * 	Misc. functions
	 *
	 *********************************************************/


        /**
     *
     * @param string $organisationList The comma formated list with a single ":"
     *      dividing the included and excluded. Format= Inclueded:Excluded
     */
    private function getRootOrganisations($organisationList)
    {
        list($included, $excluded) = explode(":", $organisationList);

        return $included;
    }


    /**
     *
     * @param string $organisationList The comma formated list with a single ":"
     *      dividing the included and excluded. Format= Inclueded:Excluded
     */
    private function getDescandentOrganisations($organisationList)
    {
        $included = array();
        $excluded = array();
        list($included, $excluded) = explode(":", $organisationList);

        $excludedOrgs = explode(",", $excluded);
        $includedOrgs = explode(",", $included);
        
        $uuids = array();
        //Start values are the included
        
        while(!empty($includedOrgs))
        {
            $partensUuids = implode(",", $includedOrgs);
            $uuids = array_merge($uuids, $includedOrgs);
            $includedOrgs = array(); //Clear
            
            //Get organisation and check they are not in $excludedOrgs
            // and then add to $includedOrgs.
            foreach($this->getChildOrgansation($partensUuids) as $uuid)
            {
                if (!in_array($uuid, $excludedOrgs)) //Check for excluded
                    $includedOrgs[] = $uuid;
            }
        }
        return implode(",", $uuids);
    }

    private function getChildOrgansation($partensUuids)
    {
        $uuids = array();
        $rest = new tx_pure_rest($this->pureUrl);
        $xml = $rest->getOrganisations(array(
                'parentUuids.uuid' => $partensUuids,
                'window.size' => "-1",
                'active' => 'true'
            ));

        if ($xml) {
            $xp = new DOMXPath($xml);
            $domNodeList = $xp->query('//core:result/core:content');
            foreach($domNodeList as $domNode){
                $uuid = $xp->evaluate('string(@uuid)', $domNode);
                $uuids[] = $uuid;
            }
            return $uuids;
        }
        
    }

    /**
     *
     * @param string $organisationList The comma formated list with a single ":"
     *      dividing the included and excluded. Format= Inclueded:Excluded
     */
    private function getDescandentClassifications($classificationList, $baseUri)
    {
        list($included, $excluded) = explode(":", $classificationList);
        $excludedOrgs = explode(",", $excluded);
        $includedOrgs = explode(",", $included);

        return implode(',', $this->getClassificationsUris($baseUri, $includedOrgs, $excludedOrgs));
    }


    /**
     * Return recursive array of uri and there child.
     * Contains index 'uri' and 'children' recursive.
     * @param string $baseUri The classification baseUri
     * @return array
     */
    private function getClassificationsUris($baseUri, $includedOrgs, $excludedOrgs)
    {
        $rest = new tx_pure_rest($this->pureUrl);
        $xml = $rest->getClassificationschemeHierarchy($baseUri);
        if ($xml)
        {
            $xp = new DOMXPath($xml);

            $topLevelList = $xp->query('//core:topLevel');
            if ($topLevelList->length)
            {
                $topLevelNode = $topLevelList->item(0);
                $resultList = array();
                
                $this->visitChildClassificationsUriArrayTree($topLevelNode, $xp, $includedOrgs, $excludedOrgs, $resultList, false);

                return $resultList;
            }
        }
        return array();
    }

    private function visitChildClassificationsUriArrayTree($rootNode, $xp, $includedOrgs, $excludedOrgs, &$resultList, $include)
    {
        $nodeList = $xp->query('core:node', $rootNode);
        if ($nodeList->length)
        {
            foreach ($nodeList as $node) {
                //Get Uri
                $uri = $xp->evaluate('string(core:classification/core:uri)', $node);

                $includeNode = ($include && !in_array($uri, $excludedOrgs))
                        || in_array($uri, $includedOrgs);
                if ($includeNode)
                    $resultList[] = $uri;
                //Visit children if any
                $childNodeList = $xp->query('core:children[core:node]', $node);
                if ($childNodeList->length)
                {
                    $childNode = $childNodeList->item(0);
                    $this->visitChildClassificationsUriArrayTree($childNode, $xp, $includedOrgs, $excludedOrgs, $resultList, $includeNode);
                }
            }
        }
    }

	/**
	 * Returns true if search engine requesting the page.
	 *
	 * @return	boolean		True, if bot.
	 */
	public function isUserBot()
	{
		//Check for site-crawler extension:
		if ($_SERVER['HTTP_X_T3CRAWLER'])
			return true;

		$bots = array(
			'google' => 'googlebot',
			'msn' => 'msnbot',
			'yahoo' => 'yahoo.com',
			'webArchive' => 'web.archive.org',
			'crawler' => 'crawler'
		);
		$agent = strtolower($_SERVER['HTTP_USER_AGENT']);
		foreach($bots as $bot)
		{
		    if(stripos($agent,$bot)!==false)
		    {
		    	//Found bot agent
		       	return true;
		    }
		}
		return false;
	}

	/**
	 * Inserts a noindex meta-tag to the respone.
	 *
	 * @return	void
	 */
	public function insertNoIndex()
	{
		$GLOBALS['TSFE']->additionalHeaderData[$this->prefixId.'robot']
			= '<meta name="robots" content="noindex"/>';
	}

    private function isMasterPage()
    {
        return $this->conf['singlePid'] == $GLOBALS['TSFE']->id;
    }

	/**
	 * Makes a redirect to a predefined site.
	 *
	 * @return	void
	 */
	public function makeRedirect()
	{
        //Only handle for the master page
        if (!$this->isMasterPage())
            return;
        //TODO: Remove
        //return; //Ignore for testing

        $url = $this->getPortalUrl($this->config);
        //var_dump($url);
        if ($url) {
            Header( 'Location: '. $url, true, 301 );
            exit;
        }
	}

    private function initRedirectHook() {
        $this->redirectHook = NULL;
        //Call redirect hook
        global $TYPO3_CONF_VARS;
        $hookObjectsArr = array();
        if (is_array ($TYPO3_CONF_VARS['EXTCONF']['pure']['redirect'])) {
            foreach ($TYPO3_CONF_VARS['EXTCONF']['pure']['redirect'] as $key => $classRef) {
                if ($this->pureId == $key) {
                    $hookObj = t3lib_div::getUserObj($classRef);
                    if ( method_exists($hookObj, 'redirect')) {
                        $this->redirectHook = $hookObj;
                        break; //Is now handled by a hook.
                    }
                }
            }
        }
    }


    private function getPortalUrl($piVars)
    {
        if ($this->redirectHook != NULL)
        {
            $url = $this->redirectHook->redirect($piVars, $this);
            if($url)
            {
                return $url;
            }
        }
        return FALSE;
    }

    /**
	 * Init the pure request url.
     * 1. Url from flexform
     * 2. Url from piVars['pure_server']
     * 3. Default url.
     *
     * Sets $this->config['pure_server'] if it not the default url.
	 *
	 * @return	void
	 */
	private function initUrl()
	{
        //Get pureUrl from flexform if is set
		$this->pureUrl = '';
		if($this->config['sDEF']['pure_server'])
		{
			$flexFormId = $this->config['sDEF']['pure_server'];
            foreach($this->conf['pure_servers.'] as $k => $serer)
			{
				if ($serer['flexFormId'] === $flexFormId)
				{
					$this->pureUrl = $serer['url'];
                    $this->pureId = $flexFormId;
					break;
				}
			}
		}

        //Get pure_server url from piVars if it is set
		if ($this->piVars['pure_server'])
		{
			foreach($this->conf['pure_servers.'] as $k => $serer)
			{
				if ($serer['flexFormId'] === $this->piVars['pure_server'])
				{
					$this->pureUrl = $serer['url'];
                    $this->pureId = $serer['flexFormId'];
					break;
				}
			}
		}
        
        $defaultServerUrl = $this->conf['pure_servers.']['default.']['url'];
		if(!$this->pureUrl) 
		{
            //Get default server if none set.
			$this->pureUrl = $defaultServerUrl;
            $this->pureId = $this->conf['pure_servers.']['default.']['flexFormId'];
		}


        //Set pure_server name. Used for generating links.
        //Only set if not default server is used.
		$this->config['pure_server'] = $this->piVars['pure_server'];
        if (!$this->config['pure_server'] && $this->pureUrl != $defaultServerUrl)
		{
			if (is_array($this->conf['pure_servers.']))
			{
				foreach($this->conf['pure_servers.'] as $k => $server)
				{
					if ($server['flexFormId'] === $this->config['sDEF']['pure_server'] && $k !== 'default.')
					{
						$this->config['pure_server'] = $server['flexFormId'];
						break;
					}
				}
			}
		}
	}

    public function initWithPid($pid)
    {
        //Get configuration from TS
        //Look up the servers listed in the typoScript setup for the template used.
        $tmpl = t3lib_div::makeInstance('t3lib_tsparser_ext');	// Defined global here!
        $tmpl->tt_track = 0;	// Do not log time-performance information
        $tmpl->init();

        // Gets the rootLine
        $sys_page = t3lib_div::makeInstance('t3lib_pageSelect');
        $rootLine = $sys_page->getRootLine($pid);

        $tmpl->runThroughTemplates($rootLine,0);	// This generates the constants/config + hierarchy info for the template.
        $tmpl->generateConfig();

        $conf = array();
        if ($tmpl->setup['plugin.']['tx_pure_pi.'])
        {
            $conf = $tmpl->setup['plugin.']['tx_pure_pi.'];
        }

        $this->cObj = t3lib_div::makeInstance('tslib_cObj');
        //$this->cObj->start($this->page,'pages');

        $this->init($conf);
    }

	/**
	 * Init Function: here all the needed configuration values are stored in class variables..
	 *
	 * @param	array		$conf : configuration array from TS
	 * @return	void
	 */
	private function init($conf) {


		$this->conf = $conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL(); //Loads locallang.xml
		$this->pi_initPIflexForm(); // Init FlexForm configuration for plugin

		//$this->pi_USER_INT_obj = 0;
		$this->config['showType'] = $this->piVars['showType']; //person, act, pub, cv
		$this->config['personId'] = $this->piVars['personId']; //personId
		$this->config['actId'] = $this->piVars['actId']; //actID, pubID
		$this->config['pubId'] = $this->piVars['pubId']; //actID, pubID
		$this->config['orgId'] = $this->piVars['orgId'];
		$this->config['sort'] = $this->piVars['sort'];
		$this->config['ascDesc'] = $this->piVars['ascDesc'];
		$this->config['sword'] = $this->piVars['sword'];
		$this->config['keywordId'] = $this->piVars['keywordId'];
		$this->config['imageId'] = htmlspecialchars($this->piVars['imageId']);
		$this->config['width'] = intval($this->piVars['width']);
		$this->config['height'] = intval($this->piVars['height']);

		//Limit the list_size (used for pagebrowser) by list_max_size.
		if ($this->conf['list_max_size'] && $this->conf['list_max_size'] < $this->conf['list_size'])
			$this->conf['list_size'] = $this->conf['list_max_size'];


		$piFlexForm = $this->cObj->data['pi_flexform'];

		// Traverse the entire array based on the language...
	    // and assign each configuration option to $this->config array...
		if ( isset($piFlexForm) && isset($piFlexForm['data']))
		{
		    foreach ( $piFlexForm['data'] as $sheet => $data ) {
		    	$this->config[$sheet] = array();
		    	foreach ( $data as  $value ) {
		            foreach ( array_keys($value) as $key) {
		                $this->config[$sheet][$key] = $this->pi_getFFvalue($piFlexForm, $key, $sheet);
		            }
		        }
		    }
		}

		// Configure caching  $this->conf['allowCaching' is set from TS
		$this->allowCaching = $this->conf['allowCaching']?1:0;
		if (!$this->allowCaching ) {
			$GLOBALS['TSFE']->set_no_cache();
		}

		//Do not cache if no javascript client,
		//because links are being generated with nojs options and shold therefore not be cached.
		if (isset($this->piVars['nojs']))
			$GLOBALS['TSFE']->set_no_cache();


		//Do not cache pages, requested by users (sort etc.)
		if (!empty($this->piVars) || $_COOKIE["au-activities-sort"] || $_COOKIE["au-publication-sort"]
				|| $_COOKIE["au-activities-pointer"] || $_COOKIE["au-publication-pointer"]) {
			$GLOBALS['TSFE']->set_no_cache();
		}

		//Set the current id:
		$currentRecord = $GLOBALS['TSFE']->currentRecord;
		if (strlen($currentRecord) > 11) //tt_content:
			$currentRecord = substr($currentRecord, 11);
		$this->currentRecord = intval($currentRecord);

		//Used to reset pointer cookie.
		$this->config['userclick'] = $this->piVars['userclick'] === "true";
		unset($this->piVars['userclick']);

		//Sets the ajax_request_id params
		if ($this->piVars['ajax_request_id'])
		{
			$this->config['ajax_request'] = $this->piVars['ajax_request_id'] ? true : false;
			$id = $this->piVars['ajax_request_id'];
			$id = explode(':', $id, 2);
			if ($id[0])
				$this->config['ajax_content_id'] = intval($id[0]);
			if ($id[1])
				$this->config['ajax_index'] = intval($id[1]);
			unset($this->piVars['ajax_request_id']);
		}
		else
		{
			//For backward compatible (RSS):
			if ($this->piVars['ajax_index'])
				$this->config['ajax_index'] = intval($this->piVars['ajax_index']);
			if ($this->piVars['ajax_content_id'])
				$this->config['ajax_content_id'] = intval($this->piVars['ajax_content_id']);
			unset($this->piVars['ajax_index']);
			unset($this->piVars['ajax_content_id']);
		}

        // Should we link to portal?
        $this->linkToPortal = intval($this->conf['link_to_portal']) == 1;
        
        $this->initUrl();
        $this->initRedirectHook();
	}

	/**
	 * Replaces linespaces, spaces with commaes.
	 *
	 * @param	string		$str: The input string.
	 * @return	string		The string.
	 */
	public function replaceLineAndSpaceWithCommaAndLower($str)
	{
		$newStr = $str;
		$newStr = str_replace(" ", ',', $newStr);
		$newStr = str_replace("\n", ',', $newStr);
		$newStr = str_replace("\n", ',', $newStr);
		return strtolower($newStr);
	}

    public function setLastResultCount($count)
    {
        $this->resultCount = $count;
    }

    public function getLastResultCount()
    {
        return $this->resultCount;
    }

}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/pure/pi/class.tx_pure_pi.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/pure/pi/class.tx_pure_pi.php']);
}

?>