<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2009-2010 Mads Sandberg Brun <msb@cs.au.dk>
 *  (c) 2009-2010 Peter Sandberg Brun <psb@cs.au.dk>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 *
 *
 */
require_once(t3lib_extMgm::extPath('pure').'pi/class.tx_pure_pi_base.php');
/**
 * Organisation controller for the 'pure' extension.
 *
 * @author	Mads Sandberg Brun <msb@cs.au.dk>
 * @author	Peter Sandberg Brun <psb@cs.au.dk>
 * @package	TYPO3
 * @subpackage	tx_pure
 */
class tx_pure_pi_organisations extends tx_pure_pi_base{

    /**
	 * Displays a single organisation.
	 * The $displayConfig have the following keys:
	 * 		orgId: The organisation id.
	 *
	 * @param	array		$displayConfig: The configuration array with the following options used.
	 * @param	string		$templateName: The name of the template to use.
	 * @return	string		The output from the template. Etc. HTML.
	 */
	public function displaySingle(array $displayConfig, $templateName)
	{
		if(!$displayConfig['orgId'])
			return $this->displayNothing();
		$parray=array(
				'uuids.uuid' => $displayConfig['orgId'],
				'rendering' => "xml_long",
				'window.offset' => "0",
				'window.size' => "-1",
                'active' => 'true',
		);
        return $this->transformOutput('organisations', $parray, $templateName);
	}

    /**
	 * Displays organisations.
	 * The $displayConfig have the following keys:
	 * 		orgId: The organisation id.
     *      organisationType: The typeclassifications uri for organisations.
	 *
	 * @param	array		$displayConfig: The configuration array with the following options used.
	 * @param	string		$templateName: The name of the template to use.
	 * @return	string		The output from the template. Etc. HTML.
	 */
	public function displayList(array $displayConfig, $templateName)
	{
		if(!$displayConfig['orgId'])
			return $this->displayNothing();
		$parray=array(
				'uuids.uuid' => $displayConfig['orgId'],
				'rendering' => "xml_long",
				'window.offset' => "0",
				'window.size' => "-1",
                'active' => 'true',
		);
        if ($displayConfig['organisationType'])
                $parray['typeClassificationUris.uri'] = $displayConfig['organisationType'];

		$extraParameters = array(
                    'rootOrgIds' => $displayConfig['rootOrgIds']
                    );
        return $this->transformOutput('organisations', $parray, $templateName, $extraParameters);
	}
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/pure/pi/class.tx_pure_pi_organisations.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/pure/pi/class.tx_pure_pi_organisations.php']);
}

?>
