<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:fn="http://www.w3.org/2005/02/xpath-functions"
                xmlns:regexp="http://exslt.org/regular-expressions"
                xmlns:ll="http://typo3.org/extensions/repository/view/pure/current/"
                xmlns:str="http://exslt.org/strings"
                
                xmlns:core="http://atira.dk/schemas/pure4/model/core/stable"
                xmlns:activity="http://atira.dk/schemas/pure4/model/abstractactivity/stable"

                exclude-result-prefixes="fn regexp ll core persons">
  <xsl:output omit-xml-declaration="yes" encoding="utf-8" method="text" />
  <xsl:template match="/">
      <xsl:text>{</xsl:text>
      <xsl:text>
    "metaData": {
        "idProperty": "id",
        "root": "activties",
        "totalProperty": "totalCount",
        "fields": [
            {"name": "name", "mapping": "title"},
            {"name": "id"}
        ],
        "sortInfo":{
           "field": "name",
           "direction": "DESC"
        }
    },
      </xsl:text>

      <xsl:text>"totalCount": "</xsl:text>
      <xsl:value-of select="*/core:count" />
      <xsl:text>"</xsl:text>

      <xsl:text>,"activties": [</xsl:text>
        <xsl:if test="count(//core:result/core:content) > 0" >
            <xsl:for-each select="//core:result/core:content">
              <xsl:text>{</xsl:text>
                <xsl:apply-templates select="."/>
              <xsl:text>}</xsl:text>
              <xsl:if test="position()!=last()">
                <xsl:text>,</xsl:text>
              </xsl:if>
            </xsl:for-each>
        </xsl:if>
      <xsl:text>]</xsl:text>
    <xsl:text>}</xsl:text>
  </xsl:template>

 <xsl:template match="core:result/core:content">
    <xsl:text>"id":"</xsl:text>
    <xsl:value-of select="@uuid" />
    <xsl:text>",</xsl:text>
    <xsl:text>"title":"</xsl:text>
    <xsl:apply-templates select="activity:title" mode="localize"/>
    <xsl:text>"</xsl:text>
  </xsl:template>

<xsl:template match="*[core:localizedString]" mode="localize">
    <xsl:choose>
      <xsl:when test="core:localizedString[@locale='en_GB']">
        <xsl:value-of select="str:replace(php:function('json_encode', string(core:localizedString[@locale='en_GB']/text())), '&quot;', '&amp;quot;')" disable-output-escaping="yes"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="str:replace(php:function('json_encode', string(core:localizedString[1]/text())), '&quot;', '&amp;quot;')" disable-output-escaping="yes"  />
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

</xsl:stylesheet>
