<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:fn="http://www.w3.org/2005/02/xpath-functions"
                xmlns:regexp="http://exslt.org/regular-expressions"
                xmlns:ll="http://typo3.org/extensions/repository/view/pure/current/"
                

                xmlns:core="http://atira.dk/schemas/pure4/model/core/stable" 

                exclude-result-prefixes="fn regexp ll core">
  <xsl:output omit-xml-declaration="yes" encoding="utf-8" method="text" />
  <xsl:template match="/">
    <xsl:apply-templates select="//core:topLevel" />
  </xsl:template>

  <xsl:template match="*[core:node]">
    <xsl:text>[</xsl:text>
    <xsl:for-each select="./core:node">
      <xsl:text>{</xsl:text>

      <xsl:text>"id":"</xsl:text>
      <xsl:value-of select="core:classification/core:uri"/>
      <xsl:text>",</xsl:text>
      <xsl:text>"text":"</xsl:text>
      <xsl:apply-templates select="core:classification/core:term" mode="localize" />
      <xsl:text>",</xsl:text>
      <xsl:choose>
        <xsl:when test="core:children[core:node]">
          <xsl:text>"children":</xsl:text>
          <xsl:apply-templates select="core:children" />
        </xsl:when>
        <xsl:otherwise>"leaf": true</xsl:otherwise>
      </xsl:choose>

      <xsl:text>}</xsl:text>
      <xsl:if test="position()!=last()">
        <xsl:text>,</xsl:text>
      </xsl:if>
    </xsl:for-each>
    <xsl:text>]</xsl:text>
  </xsl:template>


  <xsl:template match="*[core:localizedString]" mode="localize">
    <xsl:choose>
      <xsl:when test="core:localizedString[@locale='en_GB']">
        <xsl:value-of select="core:localizedString[@locale='en_GB']/text()" />
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="core:localizedString[1]/text()" />
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

</xsl:stylesheet>
