<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:fn="http://www.w3.org/2005/02/xpath-functions"
                xmlns:regexp="http://exslt.org/regular-expressions"
                xmlns:ll="http://typo3.org/extensions/repository/view/pure/current/"
                
                xmlns:stab="http://atira.dk/schemas/pure4/dk/model/organisation/stable"
                xmlns:organisation="http://atira.dk/schemas/pure4/model/abstractorganisation/stable" 
                xmlns:core="http://atira.dk/schemas/pure4/model/core/stable" 
                
                xmlns:str="http://exslt.org/strings"
                exclude-result-prefixes="fn str regexp ll stab organisation core">
  <xsl:output omit-xml-declaration="yes" encoding="utf-8" method="text" />

  <xsl:key name="nodeChildren" match="//core:result/core:content" use="organisation:organisations/organisation:organisation[1]/@uuid"/>
  <xsl:param name="extRelPath" />

  <xsl:template match="/">
    <xsl:text>[</xsl:text>
    <xsl:for-each select="//core:result/core:content[not(organisation:organisations/organisation:organisation[1])]">
      <xsl:text>{</xsl:text>
        <xsl:apply-templates select="."/>
      <xsl:text>}</xsl:text>
      <xsl:if test="position()!=last()">
        <xsl:text>,</xsl:text>
      </xsl:if>
    </xsl:for-each>
    <xsl:text>]</xsl:text>
  </xsl:template>
  <xsl:template match="core:content">
    <xsl:text>"id":"</xsl:text><xsl:value-of select="@uuid"/>
    <xsl:text>",</xsl:text>
    <xsl:text>"text":"</xsl:text><xsl:apply-templates select="organisation:name" mode="localize" />
    <xsl:if test="organisation:organisationId">
        <xsl:text> (</xsl:text>
        <xsl:value-of select="organisation:organisationId"/>
        <xsl:text>)</xsl:text>
    </xsl:if>
    <xsl:text>",</xsl:text>
    <xsl:text>"icon": "</xsl:text>
    <xsl:value-of select="$extRelPath" />
    <xsl:text>res/icons/District.ico"</xsl:text>
    <xsl:text>,</xsl:text>
    <xsl:choose>
      <xsl:when test="key('nodeChildren', @uuid)">
        <xsl:text>"children": [</xsl:text>
        <xsl:for-each select="key('nodeChildren', @uuid)">
          <xsl:text>{</xsl:text>
          <xsl:apply-templates select="."/>
          <xsl:text>}</xsl:text>
          <xsl:if test="position()!=last()">
            <xsl:text>,</xsl:text>
          </xsl:if>
        </xsl:for-each>
        <xsl:text>]</xsl:text>
      </xsl:when>
      <xsl:otherwise>
            <xsl:text>"leaf": true</xsl:text>
            <xsl:text>,</xsl:text>
            <xsl:text>"icon": "</xsl:text>
            <xsl:value-of select="$extRelPath" />
            <xsl:text>res/icons/Building.ico"</xsl:text>
        </xsl:otherwise>
    </xsl:choose>
    
  </xsl:template>

  <xsl:template match="*[core:localizedString]" mode="localize">
    <xsl:choose>
      <xsl:when test="core:localizedString[@locale='en_GB']">
        <xsl:value-of select="core:localizedString[@locale='en_GB']/text()" />
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="core:localizedString[1]/text()" />
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

</xsl:stylesheet>
