<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:fn="http://www.w3.org/2005/02/xpath-functions"
                xmlns:regexp="http://exslt.org/regular-expressions"
                xmlns:ll="http://typo3.org/extensions/repository/view/pure/current/"
                
                xmlns:core="http://atira.dk/schemas/pure4/model/core/stable"
                xmlns:person="http://atira.dk/schemas/pure4/model/abstractperson/stable"

                exclude-result-prefixes="fn regexp ll core persons">
  <xsl:output omit-xml-declaration="yes" encoding="utf-8" method="text" />
  <xsl:template match="/">
      <xsl:text>{</xsl:text>
      <xsl:text>
    "metaData": {
        "idProperty": "id",
        "root": "persons",
        "totalProperty": "totalCount",
        "fields": [
            {"name": "name"},
            {"name": "id"},
            {"name": "email"},
            {"name": "pictureUrl"}
        ],
        "sortInfo":{
           "field": "name",
           "direction": "DESC"
        }
    },
      </xsl:text>


      <xsl:text>"totalCount": "</xsl:text>
      <xsl:value-of select="*/core:count" />
      <xsl:text>"</xsl:text>

      <xsl:text>,"persons": [</xsl:text>
        <xsl:if test="count(//core:result/core:content) > 0" >
            <xsl:for-each select="//core:result/core:content">
              <xsl:text>{</xsl:text>
                <xsl:apply-templates select="."/>
              <xsl:text>}</xsl:text>
              <xsl:if test="position()!=last()">
                <xsl:text>,</xsl:text>
              </xsl:if>
            </xsl:for-each>
        </xsl:if>
      <xsl:text>]</xsl:text>
    <xsl:text>}</xsl:text>
  </xsl:template>

  <xsl:template match="core:result/core:content">
    <xsl:text>"id":"</xsl:text>
    <xsl:value-of select="person:employeeId" />
    <xsl:text>",</xsl:text>
    <xsl:text>"name":"</xsl:text>
    <xsl:value-of select="person:name/core:firstName"/>
    <xsl:text> </xsl:text>
    <xsl:value-of select="person:name/core:lastName"/>
    <xsl:text>",</xsl:text>
    <xsl:text>"email":"</xsl:text>
    <xsl:for-each select="person:organisationAssociations/person:organisationAssociation">
        <xsl:value-of select="person:email" />
        <xsl:if test="position()!=last()">
            <xsl:text>, </xsl:text>
        </xsl:if>
    </xsl:for-each>
    <xsl:text>"</xsl:text>
    <xsl:if test="person:photos/core:file[1]/core:url" >
        <xsl:text>,</xsl:text>
        <xsl:text>"pictureUrl":"</xsl:text>
        <xsl:value-of select="person:photos/core:file[1]/core:url" />
        <xsl:text>"</xsl:text>
    </xsl:if>

    <!-- If image are wanted (Requires xml_long)-->
    <!--<xsl:text>",</xsl:text>
    <xsl:text>"url":"</xsl:text>
    <xsl:value-of select="person:photos/core:file[1]/core:url" />
    <xsl:text>"</xsl:text>-->
  </xsl:template>


  <xsl:template match="*[core:localizedString]" mode="localize">
    <xsl:choose>
      <xsl:when test="core:localizedString[@locale='en_GB']">
        <xsl:value-of select="core:localizedString[@locale='en_GB']/text()" disable-output-escaping="yes"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="core:localizedString[1]/text()" disable-output-escaping="yes" />
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

</xsl:stylesheet>
