<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:fn="http://www.w3.org/2005/02/xpath-functions"
                xmlns:regexp="http://exslt.org/regular-expressions"
                xmlns:ll="http://typo3.org/extensions/repository/view/pure/current/"
                
                xmlns:core="http://atira.dk/schemas/pure4/model/core/stable"
                xmlns:publication="http://atira.dk/schemas/pure4/model/abstractpublication/stable"

                exclude-result-prefixes="fn regexp ll core persons">
  <xsl:output omit-xml-declaration="yes" encoding="utf-8" method="text" />
  <xsl:template match="/">
      <xsl:text>{</xsl:text>
      <xsl:text>
    "metaData": {
        "idProperty": "id",
        "root": "publications",
        "totalProperty": "totalCount",
        "fields": [
            {"name": "name", "mapping": "title"},
            {"name": "id"}
        ],
        "sortInfo":{
           "field": "name",
           "direction": "DESC"
        }
    },
      </xsl:text>

      <xsl:text>"totalCount": "</xsl:text>
      <xsl:value-of select="*/core:count" />
      <xsl:text>"</xsl:text>

      
        <xsl:text>,"publications": [</xsl:text>
        <xsl:if test="count(//core:result/core:content) > 0" >
            <xsl:for-each select="//core:result/core:content">
              <xsl:text>{</xsl:text>
                <xsl:apply-templates select="."/>
              <xsl:text>}</xsl:text>
              <xsl:if test="position()!=last()">
                <xsl:text>,</xsl:text>
              </xsl:if>
            </xsl:for-each>
            </xsl:if>
        <xsl:text>]</xsl:text>
      
    <xsl:text>}</xsl:text>
  </xsl:template>

  <xsl:template match="core:result/core:content">
    <xsl:text>"id":"</xsl:text>
    <xsl:value-of select="@uuid" />
    <xsl:text>",</xsl:text>
    <xsl:text>"title":"</xsl:text>
    <xsl:value-of select="php:function('json_encode', string(publication:title))" disable-output-escaping="yes"/>
    <xsl:text>"</xsl:text>
  </xsl:template>



</xsl:stylesheet>
