<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns="http://www.w3.org/1999/xhtml"
                xmlns:fn="http://www.w3.org/2005/02/xpath-functions"
                xmlns:regexp="http://exslt.org/regular-expressions"
                xmlns:ll="http://typo3.org/extensions/repository/view/pure/current/"
                xmlns:str="http://exslt.org/strings"
                
                xmlns:core="http://atira.dk/schemas/pure4/model/core/stable"
                
                exclude-result-prefixes="fn str regexp ll">
  <xsl:import href="localization.xsl" />
  <xsl:output method="xml" indent="yes" encoding="utf-8" />
  <xsl:param name="group1" select="''" />
  <xsl:param name="group2" select="''" />
  
  <xsl:key name="by-group1" match="core:content[@uuid]" use="*[local-name() = $group1]" />
  <xsl:key name="by-group2" match="core:content[@uuid]" use="*[local-name() = $group2]" />
  <xsl:key name="by-group2-1" match="core:content[@uuid]" use="concat(*[local-name() = $group1], ':',*[local-name() = $group2])" />

  <!-- Include this to get grouping of items. Make a template with name="list" to transform the sublist-->

  <xsl:template match="/" mode="group">
    <div class="publication-simple">
      <div class="publications">
        <xsl:choose>
          <xsl:when test="$group1">
            <xsl:for-each select="//core:result/core:content[@uuid and count(. | key('by-group1', *[local-name() = $group1])[1]) = 1]">
              <!--<xsl:sort select="*[local-name() = $group1]" />-->
              <xsl:if test="*[local-name() = $group1]">
                <h2>
                  <xsl:value-of select="ll:getLL(concat('group.', *[local-name() = $group1]), *[local-name() = $group1])"/>
                </h2>
              </xsl:if>
              <xsl:apply-templates mode="group2-1" select="key('by-group1', *[local-name() = $group1])[generate-id() = generate-id(key('by-group2-1', concat(*[local-name() = $group1], ':', *[local-name() = $group2]))[1])]" />

            </xsl:for-each>
          </xsl:when>
          <xsl:otherwise>
            <xsl:choose>
              <xsl:when test="$group2">
                <xsl:for-each select="//core:result/core:content[@uuid and count(. | key('by-group2', *[local-name() = $group2])[1]) = 1]">
                 <!-- <xsl:sort select="*[local-name() = $group2]" />-->
                    <h3>
                      <xsl:value-of select="ll:getLL(concat('group.', *[local-name() = $group2]), *[local-name() = $group2])"/>
                    </h3>
                  <xsl:call-template name="list">
                    <xsl:with-param name="items" select="key('by-group2', *[local-name() = $group2])" />
                  </xsl:call-template>
                  <!--
                  <xsl:for-each select="key('by-group2', *[local-name() = $group2])">
                    <xsl:apply-templates select="." />
                  </xsl:for-each>-->
                </xsl:for-each>
              </xsl:when>
              <xsl:otherwise>
                <xsl:call-template name="list">
                  <xsl:with-param name="items" select="//core:result/core:content[@uuid]" />
                </xsl:call-template>
                <!--
                <xsl:apply-templates select="//result/item" />-->
              </xsl:otherwise>  
            </xsl:choose>
            
          </xsl:otherwise>
        </xsl:choose>
      </div>
    </div>
  </xsl:template>

  <xsl:template match="//core:result/core:content" mode="group2-1">
    <xsl:if test="*[local-name() = $group2]">
      <h3>
        <xsl:value-of select="ll:getLL(concat('group.', *[local-name() = $group2]), *[local-name() = $group2])"/>
      </h3>
    </xsl:if>
    <!-- Call a defined template in an other XSL with the list of items as parameter-->
    <xsl:call-template name="list">
      <xsl:with-param name="items" select="key('by-group2-1', concat(*[local-name() = $group1], ':', *[local-name() = $group2]))" />
    </xsl:call-template>
    <!--<xsl:apply-templates select="key('by-group2-1', concat(*[local-name() = $group1], ':', *[local-name() = $group2]))" />
    <xsl:for-each select="key('by-group2-1', concat(*[local-name() = $group1], ':', *[local-name() = $group2]))">
      <xsl:apply-templates select="." />
    </xsl:for-each>-->
  </xsl:template>

  <!--

  <xsl:key name="by-year" match="item" use="publicationYear"/>


  <xsl:template match="/">
    <div class="publication-simple">

      <div class="publications">
        <xsl:for-each select="//result/item[count(. | key('by-year', publicationYear)[1]) = 1]">
          <xsl:sort select="publicationYear" />
          <h1>
            <xsl:value-of select="publicationYear" />
          </h1>
          <xsl:for-each select="key('by-year', publicationYear)">
            <xsl:value-of select="title_ll" />
            <br />
          </xsl:for-each>
        </xsl:for-each>

      </div>
    </div>
	</xsl:template>
-->


</xsl:stylesheet>