<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns="http://www.w3.org/1999/xhtml"
                xmlns:fn="http://www.w3.org/2005/02/xpath-functions"
                xmlns:regexp="http://exslt.org/regular-expressions"
                xmlns:ll="http://typo3.org/extensions/repository/view/pure/current/"
                xmlns:str="http://exslt.org/strings"
                
                xmlns:core="http://atira.dk/schemas/pure4/model/core/stable"
                
                exclude-result-prefixes="fn str regexp ll core">
  <xsl:import href="localization.xsl" />
  <xsl:param name="ll:localizationFile" select="'locallang_keyword.xml'" />
  <xsl:param name="rootClassificationUri" />
  <xsl:output encoding="utf-8" />
  <xsl:template match="/">
    <div>
      <xsl:if test="count(//core:node[core:classification/core:uri = $rootClassificationUri]/core:children/core:node) > 0">
      <h2>
        <xsl:value-of select="ll:getLL('keyword_keywords')"/>
      </h2>
      <div class="keywords">
        <xsl:for-each select="//core:node[core:classification/core:uri = $rootClassificationUri]/core:children/core:node">
          <a href="{keywordUrl}">
            <xsl:apply-templates select="core:classification/core:term" mode="localize" />
          </a>
          <xsl:if test="position()!=last()">
            <xsl:text> &#8226; </xsl:text>
          </xsl:if>
        </xsl:for-each>
      </div>
      </xsl:if>
    </div>
  </xsl:template>

  
</xsl:stylesheet>