<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns="http://www.w3.org/1999/xhtml"
                xmlns:fn="http://www.w3.org/2005/02/xpath-functions"
                xmlns:regexp="http://exslt.org/regular-expressions"
                xmlns:ll="http://typo3.org/extensions/repository/view/pure/current/"
                xmlns:php="http://php.net/xsl"
                
                xmlns:core="http://atira.dk/schemas/pure4/model/core/stable"
                xmlns:publication="http://atira.dk/schemas/pure4/model/abstractpublication/stable"
                xmlns:person="http://atira.dk/schemas/pure4/model/abstractperson/stable"
                xmlns:extensions="http://atira.dk/schemas/pure4/model/extensions/stable"
                xmlns:organisation="http://atira.dk/schemas/pure4/model/abstractorganisation/stable"
                xmlns:event="http://atira.dk/schemas/pure4/model/abstractevent/stable"
                xmlns:stab="http://atira.dk/schemas/pure4/dk/model/publication/stable"
                
                xmlns:str="http://exslt.org/strings"
                exclude-result-prefixes="fn str php regexp ll core publication person extensions organisation event stab">
  <xsl:import href="localization.xsl" />
  <xsl:param name="ll:localizationFile" select="'locallang_person.xml'" />
  <xsl:param name="rootOrgIds" />
  <xsl:output omit-xml-declaration="yes" encoding="utf-8"  />
  <xsl:param name="pureUrl" />

  <xsl:key name="nodeChildren" match="//core:result/core:content" use="organisation:organisations/organisation:organisation[1]/@uuid"/>

  <xsl:template match="/">
    <div class="organisations-hiearchy">
        <xsl:for-each select="//core:result/core:content[contains($rootOrgIds,@uuid)]" >
            <xsl:apply-templates select="." mode="root"/>
        </xsl:for-each>
    </div>
  </xsl:template>

  <xsl:template match="core:content" mode="root">
      <h2><xsl:apply-templates select="organisation:name" mode="localize" /></h2>
      <ul>
       <xsl:for-each select="key('nodeChildren', @uuid)">
           <xsl:apply-templates select="."/>
       </xsl:for-each>
       </ul>
  </xsl:template>

  <xsl:template match="core:content">
    <!--<xsl:variable name="gotPublications" select="php:function('tx_pure_xsltfunctions::infoExistForOrganisation', $pureUrl, 'publications', string(@uuid))" />
    <xsl:variable name="gotActivities" select="php:function('tx_pure_xsltfunctions::infoExistForOrganisation', $pureUrl, 'activities', string(@uuid))" />-->

    <li>
          <xsl:choose>
            <xsl:when test="organisation:website">
              <xsl:element name="a">
                <xsl:attribute name="href">
                  <xsl:apply-templates select="organisation:website" mode="localize" />
                </xsl:attribute>
                <xsl:apply-templates select="organisation:name" mode="localize" />
              </xsl:element>
            </xsl:when>
            <xsl:otherwise>
              <xsl:apply-templates select="organisation:name" mode="localize" />
            </xsl:otherwise>
          </xsl:choose>

      <!--<xsl:if test="$gotPublications">
        <strong>Publications</strong>
      </xsl:if>

      <xsl:if test="$gotActivities">
        <strong>Activities</strong>
      </xsl:if>-->
      
          <xsl:if test="key('nodeChildren', @uuid)">
            <ul>
              <xsl:for-each select="key('nodeChildren', @uuid)">
               <xsl:apply-templates select="."/>
           </xsl:for-each>
             </ul>
          </xsl:if>
      </li>

  </xsl:template>


</xsl:stylesheet>