<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns="http://www.w3.org/1999/xhtml"
                xmlns:fn="http://www.w3.org/2005/02/xpath-functions"
                xmlns:regexp="http://exslt.org/regular-expressions"
                xmlns:ll="http://typo3.org/extensions/repository/view/pure/current/"

                xmlns:core="http://atira.dk/schemas/pure4/model/core/stable"
                xmlns:publication="http://atira.dk/schemas/pure4/model/abstractpublication/stable"
                xmlns:person="http://atira.dk/schemas/pure4/model/abstractperson/stable"
                xmlns:extensions="http://atira.dk/schemas/pure4/model/extensions/stable"
                xmlns:organisation="http://atira.dk/schemas/pure4/model/abstractorganisation/stable"
                xmlns:event="http://atira.dk/schemas/pure4/model/abstractevent/stable"
                xmlns:stab="http://atira.dk/schemas/pure4/dk/model/publication/stable"

                xmlns:str="http://exslt.org/strings"
                exclude-result-prefixes="fn str regexp ll core publication person extensions organisation event stab">
  <xsl:import href="localization.xsl" />
  <xsl:param name="ll:localizationFile" select="'locallang_person.xml'" />
  <xsl:output omit-xml-declaration="yes" encoding="utf-8" />

  <xsl:template match="/">
    <div class="pure-image-person" >
      <xsl:for-each select="//core:result/core:content">
        <!-- Only persons with images are showed.-->
        <xsl:if test="person:photos/core:file">

            <a href="{typo3/links/personUrl}" title="{person:name/core:firstName} {person:name/core:lastName}">
                <img class="photo logo" src="{person:photos/core:file[1]/core:url}" alt="{person:name/core:firstName} {person:name/core:lastName}" />
              </a>

<!--          <xsl:choose>
            Image
            <xsl:when test="imageLowres/url">
              <a href="{typo3/links/personUrl}" title="{firstname} {lastname}">
                <img class="photo logo" src="{imageLowres/url}" alt="{firstname} {lastname}" />
              </a>
            </xsl:when >
            <xsl:otherwise>
              <a href="{typo3/links/personUrl}" title="{firstname} {lastname}">
                <img class="photo logo" src="{imageHighres/url}" alt="{firstname} {lastname}" />
              </a>
            </xsl:otherwise>
          </xsl:choose>-->
        </xsl:if>

      </xsl:for-each>
    </div>
  </xsl:template>

</xsl:stylesheet>
