﻿<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns="http://www.w3.org/1999/xhtml"
                xmlns:fn="http://www.w3.org/2005/02/xpath-functions"
                xmlns:regexp="http://exslt.org/regular-expressions"
                xmlns:ll="http://typo3.org/extensions/repository/view/pure/current/"
                xmlns:str="http://exslt.org/strings" exclude-result-prefixes="fn str regexp ll">
  <xsl:import href="localization.xsl" />
  <xsl:import href="image.xsl" />
  <xsl:param name="ll:localizationFile" select="'locallang_person.xml'" />
  <xsl:output omit-xml-declaration="yes" encoding="utf-8" />

  <xsl:template match="/">
    <div class="pure-image-person" >
      <xsl:for-each select="//result/item">
        <!-- Only persons with images are showed.-->
        <xsl:if test="imageLowres/url or imageHighres/url">
          <xsl:choose>
            <!--Image-->
            <xsl:when test="imageLowres/url">
              <a href="{typo3/links/personUrl}" title="{firstname} {lastname}">
                <img class="photo logo" src="{ll:getImage(imageLowres/url, 75, 100)}" alt="{firstname} {lastname}" />
              </a>
            </xsl:when >
            <xsl:otherwise>
              <a href="{typo3/links/personUrl}" title="{firstname} {lastname}">
                <img class="photo logo" src="{ll:getImage(imageHighres/url, 75, 100)}" alt="{firstname} {lastname}" />
              </a>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:if>

      </xsl:for-each>
    </div>
  </xsl:template>

</xsl:stylesheet>
