<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns="http://www.w3.org/1999/xhtml"
                xmlns:fn="http://www.w3.org/2005/02/xpath-functions"
                xmlns:regexp="http://exslt.org/regular-expressions"
                xmlns:ll="http://typo3.org/extensions/repository/view/pure/current/"
                xmlns:str="http://exslt.org/strings" 
                
                xmlns:core="http://atira.dk/schemas/pure4/model/core/stable" 
                xmlns:publication="http://atira.dk/schemas/pure4/model/abstractpublication/stable"
                xmlns:person="http://atira.dk/schemas/pure4/model/abstractperson/stable"
                xmlns:extensions="http://atira.dk/schemas/pure4/model/extensions/stable"
                xmlns:organisation="http://atira.dk/schemas/pure4/model/abstractorganisation/stable"
                xmlns:event="http://atira.dk/schemas/pure4/model/abstractevent/stable"
                xmlns:stab="http://atira.dk/schemas/pure4/dk/model/publication/stable"
                
                exclude-result-prefixes="fn str regexp ll core publication person extensions organisation event stab">
  <xsl:import href="localization.xsl" />
  <xsl:param name="ll:localizationFile" select="'locallang_keyword.xml'" />
  <xsl:output encoding="utf-8" />
  <xsl:template match="/">
    <div>
      <xsl:if test="//core:result/core:content">
        <h2>
          <xsl:value-of select="ll:getLL('keyword_persons')"/>
        </h2>
        <div class="persons">
          <xsl:for-each select="//core:result/core:content">
            <a href="{typo3/links/personUrl}">
              <xsl:value-of select="person:name/core:firstName"/>
              <xsl:text> </xsl:text>
              <xsl:value-of select="person:name/core:lastName"/>
            </a>
            <xsl:if test="position()!=last()">
              <xsl:text> &#8226; </xsl:text>
            </xsl:if>
          </xsl:for-each>
        </div>
        <br />
      </xsl:if>
    </div>
  </xsl:template>

</xsl:stylesheet>