<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns="http://www.w3.org/1999/xhtml"
                xmlns:fn="http://www.w3.org/2005/02/xpath-functions"
                xmlns:regexp="http://exslt.org/regular-expressions"
                xmlns:ll="http://typo3.org/extensions/repository/view/pure/current/"
                xmlns:php="http://php.net/xsl"
                xmlns:str="http://exslt.org/strings" exclude-result-prefixes="fn str regexp php ll">
  <xsl:import href="localization.xsl" />
  <xsl:param name="ll:localizationFile" select="'locallang_publication.xml'" />

  <xsl:output encoding="utf-8" />
  <xsl:param name="pubsort" />
  <xsl:param name="sortdirection" />
  <xsl:param name="pureUrl" select="'http://pure3a.au.dk:8080/ws/axis2/services/PureWebService/'" />
  <xsl:param name="browse_links" />

  <xsl:param name="hide_rss" />


  <!-- Include grouping XSLT -->
  <xsl:include href="Group.xsl" />
  <xsl:include href="TEMPLATE_PUBLICATIONS_FORMAT_STANDARD.xsl" />



  <xsl:template match="/">
    <div class="publication-simple">
      <div class="dropdown-sorting pure-ajax-request">
        <div class="tx-pure-sorting-head">
          <strong>
            <xsl:value-of select="ll:getLL('sortby')"/>
          </strong>
          <xsl:text>: </xsl:text>
          <xsl:choose>
            <xsl:when test="$pubsort = 'authorLastName'">
              <xsl:value-of select="ll:getLL('sortAuthor')"/>
            </xsl:when>
            <xsl:when test="$pubsort = 'publicationYear'">
              <xsl:value-of select="ll:getLL('sortDate')"/>
            </xsl:when>
            <xsl:when test="$pubsort = 'title'">
              <xsl:value-of select="ll:getLL('sortTitle')"/>
            </xsl:when>
            <xsl:when test="$pubsort = 'typeClassification'">
              <xsl:value-of select="ll:getLL('sortPublicationTypeIndex')"/>
            </xsl:when>
            <xsl:when test="$pubsort = 'typeClassification,authorLastName'">
              <xsl:value-of select="ll:getLL('sortPublicationTypeIndexFirstAuthor')"/>
            </xsl:when>
            <xsl:when test="$pubsort = 'submissionYear'">
              <xsl:value-of select="ll:getLL('sortSubmittedYear')"/>
            </xsl:when>
            <xsl:when test="$pubsort = 'submissionYear,authorLastName'">
              <xsl:value-of select="ll:getLL('sortSubmittedYearFirstAuthor')"/>
            </xsl:when>
            <xsl:when test="$pubsort = 'submissionYear,typeClassification,authorLastName'">
              <xsl:value-of select="ll:getLL('sortSubmittedYearPublicationTypeIndexFirstAuthor')"/>
            </xsl:when>
          </xsl:choose>
        </div>
        <div class="tx-pure-sorting-body" style="display: none;">
          <strong>
            <xsl:value-of select="ll:getLL('sortby')"/>
          </strong>
          <ul>
            <li>
              <xsl:choose>
                <xsl:when test="$pubsort = 'title'">
                  <strong>
                    <xsl:value-of select="ll:getLL('sortTitle')"/>
                  </strong>
                </xsl:when>
                <xsl:otherwise>
                  <a href="{typo3/links/sortTitleUrl}">
                    <xsl:value-of select="ll:getLL('sortTitle')"/>
                  </a>
                </xsl:otherwise>
              </xsl:choose>
            </li>
            <li>
              <xsl:choose>
                <xsl:when test="$pubsort = 'typeClassification'">
                  <strong>
                    <xsl:value-of select="ll:getLL('sortPublicationTypeIndex')"/>
                  </strong>
                </xsl:when>
                <xsl:otherwise>
                  <a href="{typo3/links/sortPublicationTypeIndexUrl}">
                    <xsl:value-of select="ll:getLL('sortPublicationTypeIndex')"/>
                  </a>
                </xsl:otherwise>
              </xsl:choose>
            </li>
            <li>
              <xsl:choose>
                <xsl:when test="$pubsort = 'typeClassification,authorLastName'">
                  <strong>
                    <xsl:value-of select="ll:getLL('sortPublicationTypeIndexFirstAuthor')"/>
                  </strong>
                </xsl:when>
                <xsl:otherwise>
                  <a href="{typo3/links/sortPublicationTypeIndexFirstAuthorUrl}">
                    <xsl:value-of select="ll:getLL('sortPublicationTypeIndexFirstAuthor')"/>
                  </a>
                </xsl:otherwise>
              </xsl:choose>
            </li>
            <li>
              <xsl:choose>
                <xsl:when test="$pubsort = 'submissionYear'">
                  <strong>
                    <xsl:value-of select="ll:getLL('sortSubmittedYear')"/>
                  </strong>
                </xsl:when>
                <xsl:otherwise>
                  <a href="{typo3/links/sortSubmittedYearUrl}">
                    <xsl:value-of select="ll:getLL('sortSubmittedYear')"/>
                  </a>
                </xsl:otherwise>
              </xsl:choose>
            </li>
            <li>
              <xsl:choose>
                <xsl:when test="$pubsort = 'submissionYear,authorLastName'">
                  <strong>
                    <xsl:value-of select="ll:getLL('sortSubmittedYearFirstAuthor')"/>
                  </strong>
                </xsl:when>
                <xsl:otherwise>
                  <a href="{typo3/links/sortSubmittedYearFirstAuthorUrl}">
                    <xsl:value-of select="ll:getLL('sortSubmittedYearFirstAuthor')"/>
                  </a>
                </xsl:otherwise>
              </xsl:choose>
            </li>
            <li>
              <xsl:choose>
                <xsl:when test="$pubsort = 'submissionYear,typeClassification,authorLastName'">
                  <strong>
                    <xsl:value-of select="ll:getLL('sortSubmittedYearPublicationTypeIndexFirstAuthor')"/>
                  </strong>
                </xsl:when>
                <xsl:otherwise>
                  <a href="{typo3/links/sortSubmittedYearPublicationTypeIndexFirstAuthorUrl}">
                    <xsl:value-of select="ll:getLL('sortSubmittedYearPublicationTypeIndexFirstAuthor')"/>
                  </a>
                </xsl:otherwise>
              </xsl:choose>
            </li>
          </ul>
          <strong>
            <xsl:value-of select="ll:getLL('sortin')"/>
          </strong>
            <ul>
              <li>
                <xsl:choose>
                  <xsl:when test="$sortdirection = 'asc'">
                    <strong>
                      <xsl:value-of select="ll:getLL('sortAsc')"/>
                    </strong>
                  </xsl:when>
                  <xsl:otherwise>
                    <a href="{typo3/links/sortAscUrl}">
                      <xsl:value-of select="ll:getLL('sortAsc')"/>
                    </a>
                  </xsl:otherwise>
                </xsl:choose>
              </li>
              <li>
                <xsl:choose>
                  <xsl:when test="$sortdirection = 'desc'">
                    <strong>
                      <xsl:value-of select="ll:getLL('sortDesc')"/>
                    </strong>
                  </xsl:when>
                  <xsl:otherwise>
                    <a href="{typo3/links/sortDescUrl}">
                      <xsl:value-of select="ll:getLL('sortDesc')"/>
                    </a>
                  </xsl:otherwise>
                </xsl:choose>
              </li>
            </ul>
        </div>

      </div>

      <xsl:if test="$hide_rss != 'true'">
        <a href="{typo3/links/rssUrl}" title="RSS" class="feedlink">
          <xsl:text>&#160;</xsl:text>
        </a>
      </xsl:if>
      
      <div class="publications">
        <xsl:apply-templates select="." mode="group" />

        <xsl:if test="//result/item[external = 'true']">
          <p>
            <xsl:text>* ) </xsl:text>
            <xsl:value-of select="ll:getLL('producedExternal')"/>
          </p>
        </xsl:if>
      </div>

      <xsl:if test="$browse_links">
        <div class="browse-links pure-ajax-request">
          <p class="results_numbers">
            <xsl:value-of select="$browse_links" disable-output-escaping="yes"/>
          </p>
        </div>
      </xsl:if>

    </div>
  </xsl:template>

  <xsl:template name="list">
    <xsl:param name="items" />

    <ul class="au-smallsans">
      <xsl:for-each select="$items">
        <li>
          <xsl:apply-templates select="." />
        </li>
      </xsl:for-each>
    </ul>
  </xsl:template>


</xsl:stylesheet>