<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns="http://www.w3.org/1999/xhtml"
                xmlns:fn="http://www.w3.org/2005/02/xpath-functions"
                xmlns:regexp="http://exslt.org/regular-expressions"
                xmlns:ll="http://typo3.org/extensions/repository/view/pure/current/"
                xmlns:str="http://exslt.org/strings" exclude-result-prefixes="fn str regexp ll">
  <xsl:import href="localization.xsl" />
  <xsl:param name="ll:localizationFile" select="'locallang_search.xml'" />
  <xsl:output encoding="utf-8"/>
  <xsl:template match="/">
    <div class="pure_search_activities">
      <form class="pure_search_form" method="get" action="{typo3search/config/formUrl}">
        <div>
          <input name="tx_pure_pi[search_type]" type="hidden" value="activities"/>
          <input name="tx_pure_pi[organisationIdsToChoose]" type="hidden" value="{typo3search/config/organisationIdsToChoose}"/>
          <input name="tx_pure_pi[organisationIds]" type="hidden" value="{typo3search/config/organisationIdsToChoose}"/>
        </div>
        <div class="pure-search">
          <input type="text" name="tx_pure_pi[sword]" value="{typo3search/config/sword}" />
          <input type="submit" name="search" value="{ll:getLL('search_button')}" />
        </div>
      </form>
      <xsl:if test="typo3search/config/resultCount > 0">
        <h3>
          <xsl:value-of select="ll:getLL('search_found_found')"/>
          <xsl:text> </xsl:text>
          <xsl:value-of select="typo3search/config/resultCount"/>
          <xsl:text> </xsl:text>
          <xsl:choose>
            <xsl:when test="number(typo3search/config/resultCount) = 1">
              <xsl:value-of select="ll:getLL('search_found_results_one')"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="ll:getLL('search_found_results')"/>
            </xsl:otherwise>
          </xsl:choose>
        </h3>
      </xsl:if>
      <div>
        <xsl:value-of disable-output-escaping="yes" select="typo3search/result" />
      </div>
    </div>
  </xsl:template>

</xsl:stylesheet>