<?xml version="1.0" encoding="UTF-8"?>
<!-- Template for: Big business card with CV, publications etc.  -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns="http://www.w3.org/1999/xhtml"
                xmlns:fn="http://www.w3.org/2005/02/xpath-functions"
                xmlns:regexp="http://exslt.org/regular-expressions"
                xmlns:ll="http://typo3.org/extensions/repository/view/pure/current/"
                xmlns:php="http://php.net/xsl"
                xmlns:func="http://exslt.org/functions" 
                
                xmlns:core="http://atira.dk/schemas/pure4/model/core/stable"
                xmlns:publication="http://atira.dk/schemas/pure4/model/abstractpublication/stable"
                xmlns:person="http://atira.dk/schemas/pure4/model/abstractperson/stable"
                xmlns:extensions="http://atira.dk/schemas/pure4/model/extensions/stable"
                xmlns:organisation="http://atira.dk/schemas/pure4/model/abstractorganisation/stable"
                xmlns:event="http://atira.dk/schemas/pure4/model/abstractevent/stable"
                xmlns:stab="http://atira.dk/schemas/pure4/dk/model/publication/stable"
                
                xmlns:str="http://exslt.org/strings"
                exclude-result-prefixes="fn str regexp php ll func core publication person extensions organisation event stab">
  <xsl:import href="localization.xsl" />
  <xsl:param name="ll:localizationFile" select="'locallang_person.xml'" />

  <xsl:key name="firstKeywordKey" match="//compilations/item/paths/item" use="keywords/item[1]/id" />
  
  <xsl:param name="pureUrl" />
  <xsl:param name="foldOutFirstTab" />
  <xsl:param name="tabIndexToOpen" />
  <xsl:param name="hideJobtitleInList" />
  
  <xsl:output omit-xml-declaration="yes" encoding="utf-8" />

  <xsl:template match="/">
    <div class="pure-basic-person" >
      <xsl:for-each select="//core:result/core:content">
        <div class="vcard pure-basic-person-single">

          <!--Image-->
          <xsl:if test="person:photos/core:file">
            <a href="{typo3/links/personUrl}" title="{person:name/core:firstName} {person:name/core:lastName}">
                <img class="photo logo" src="{person:photos/core:file[1]/core:url}" alt="{person:name/core:firstName} {person:name/core:lastName}" />
              </a>
          </xsl:if>
<!--          <xsl:if test="imageLowres/url or imageHighres/url">
            <xsl:choose>
              <xsl:when test="imageLowres/url">
                <xsl:choose>
                  <xsl:when test="imageHighres/url">
                    <a href="{imageHighres/url}" >
                      <img class="photo logo" src="{imageLowres/url}" alt="{person:name/core:firstName} {person:name/core:lastName}" />
                    </a>
                  </xsl:when>
                  <xsl:otherwise>
                    <img class="photo logo" src="{imageLowres/url}" alt="{person:name/core:firstName} {person:name/core:lastName}" />
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when >
              <xsl:otherwise>
                <a href="{imageHighres/url}" >
                  <img class="photo logo" src="{imageHighres/url}" alt="{person:name/core:firstName} {person:name/core:lastName}" />
                </a>
              </xsl:otherwise>
            </xsl:choose>
         </xsl:if>-->

          <xsl:variable name="primaryOrganisation" select="person:organisationAssociations/person:organisationAssociation[not(person:period/extensions:endDate)][1]" />
          <!--Generel person info-->
          <h2 class="fn">
            <span class="given-name">
              <xsl:value-of select="person:name/core:firstName"/>
            </span>
            <xsl:text>&#160;</xsl:text>
            <span class="family-name">
              <xsl:value-of select="person:name/core:lastName"/>
            </span>
          </h2>
          <p>
            <span class="title">
                <xsl:if test="not($hideJobtitleInList)">
                    <xsl:apply-templates select="$primaryOrganisation/person:jobTitle/core:term" mode="localize" />
                </xsl:if>
              <xsl:if test="person:education">
                  <xsl:if test="not($hideJobtitleInList)">
                    <xsl:text>, </xsl:text>
                  </xsl:if>
                <xsl:apply-templates select="person:education" mode="localize" />
              </xsl:if>
            </span>
          </p>
          <div>
            <xsl:apply-templates select="$primaryOrganisation/person:phone" />
            <xsl:apply-templates select="$primaryOrganisation/person:mobilePhone" />
            <xsl:apply-templates select="$primaryOrganisation/person:fax" />
            <xsl:apply-templates select="$primaryOrganisation/emailLink" />
            <xsl:apply-templates select="$primaryOrganisation/person:address/extensions:room" />
          </div>

          <h4>
            <xsl:value-of select="ll:getLL('mail_address')"/>
          </h4>
          <xsl:apply-templates select="$primaryOrganisation" />

          <div class="adr">
            <!--<abbr class="type" title="work"></abbr>-->
            <span class="street-address">
              <xsl:for-each select="str:tokenize($primaryOrganisation/person:address/extensions:road,';')">
                <xsl:value-of select="."/>
                <br />
              </xsl:for-each>
            </span>

            <span class="postal-code">
              <xsl:value-of select="$primaryOrganisation/person:address/extensions:postalcode"/>
            </span>
            <xsl:text>&#160;</xsl:text>
            <span class="locality">
              <xsl:value-of select="$primaryOrganisation/person:address/extensions:city"/>
            </span>
            <br />
          </div>

          <br />
          <xsl:if test="$primaryOrganisation/person:website">
            <a href="{$primaryOrganisation/person:website}">
            	<xsl:value-of select="ll:getLL('supplementary_homepage')"/>
            </a>
          </xsl:if>

          <!--<xsl:value-of select="php:function('tx_pure_pi::infoExistForPersonXSLT', 'http://pure3a.au.dk:8080/ws/axis2/services/PureWebService/', 'getPublications', 'kgronbak@cs.au.dk')" />-->
          <xsl:variable name="gotPublications" select="php:function('tx_pure_xsltfunctions::infoExistForPerson', $pureUrl, 'publications', string(person:employeeId))" />
          <xsl:variable name="gotActivities" select="php:function('tx_pure_xsltfunctions::infoExistForPerson', $pureUrl, 'activities', string(person:employeeId))" />
          
          
          <!--TODO: Check for Danish/English (da_DK/en_GB)-->
          <xsl:if test="person:KeywordContainers[node()]
              or person:profileInformation/extensions:customField[contains(extensions:typeClassification/core:uri, '/dk/atira/pure/person/customfields/CurriculumVitae') and extensions:value/core:localizedString]
              or $gotPublications
              or $gotActivities
              or person:profileInformation/extensions:customField[contains(extensions:typeClassification/core:uri, '/dk/atira/pure/person/customfields/ResearchAreas') and extensions:value/core:localizedString]
              or person:profileInformation/extensions:customField[contains(extensions:typeClassification/core:uri, '/dk/atira/pure/person/customfields/ResearchAndEducationInformation') and extensions:value/core:localizedString]
              ">
            <xsl:element name="div">
              <xsl:attribute name="class">
                <xsl:text>pure-tabs</xsl:text>
                <xsl:if test="$foldOutFirstTab = 'true'">
                  <xsl:text> pure-tabs-foldOutFirst</xsl:text>
                </xsl:if>
              </xsl:attribute>

              <ul class="pure-tabs-ul">
                <xsl:if test="person:KeywordContainers[node()]">
                  <xsl:apply-templates select="typo3/links/keywordUrl" />
                </xsl:if>

                <xsl:if test="person:profileInformation/extensions:customField[contains(extensions:typeClassification/core:uri, '/dk/atira/pure/person/customfields/CurriculumVitae') and extensions:value/core:localizedString]">
                  <!--<xsl:apply-templates select="typo3/links/cvUrl" /> -->
                  <li>
                    <xsl:element name="a">
                      <xsl:attribute name="class">
                        <xsl:text>pure-tab pure-tab-element</xsl:text>
                        <xsl:if test="$tabIndexToOpen='CVCLASS'">
                          <xsl:text> pure-tab-open</xsl:text>
                        </xsl:if>
                      </xsl:attribute>
                      <xsl:attribute name="href">
                        <xsl:value-of select="concat('#cv',generate-id(.))"/>
                      </xsl:attribute>
                      <span>
                        <xsl:value-of select="ll:getLL('cv')"/>
                      </span>
                    </xsl:element>
                  </li>
                </xsl:if>
                
                <xsl:if test="$gotPublications">
                  <xsl:apply-templates select="typo3/links/publicationUrl" />
                </xsl:if>
                <xsl:if test="$gotActivities">
                  <xsl:apply-templates select="typo3/links/activitiesUrl" />
                </xsl:if>

                <xsl:if test="person:profileInformation/extensions:customField[contains(extensions:typeClassification/core:uri, '/dk/atira/pure/person/customfields/ResearchAreas') and extensions:value/core:localizedString]">
                  <li>
                    <xsl:element name="a">
                      <xsl:attribute name="class">
                        <xsl:text>pure-tab pure-tab-element</xsl:text>
                        <xsl:if test="$tabIndexToOpen='MISCCLASS'">
                          <xsl:text> pure-tab-open</xsl:text>
                        </xsl:if>
                      </xsl:attribute>
                      <xsl:attribute name="href">
                        <xsl:value-of select="concat('#misc',generate-id(.))"/>
                      </xsl:attribute>
                      <span>
                        <xsl:value-of select="ll:getLL('further-information')"/>
                      </span>
                    </xsl:element>
                  </li>
                </xsl:if>
                
                <xsl:if test="person:profileInformation/extensions:customField[contains(extensions:typeClassification/core:uri, '/dk/atira/pure/person/customfields/ResearchAndEducationInformation') and extensions:value/core:localizedString]">
                  <li>
                    <xsl:element name="a">
                      <xsl:attribute name="class">
                        <xsl:text>pure-tab pure-tab-element</xsl:text>
                        <xsl:if test="$tabIndexToOpen='EXTRACLASS'">
                          <xsl:text> pure-tab-open</xsl:text>
                        </xsl:if>
                      </xsl:attribute>
                      <xsl:attribute name="href">
                        <xsl:value-of select="concat('#extra',generate-id(.))"/>
                      </xsl:attribute>
                      <span>
                        <xsl:value-of select="ll:getLL('extra_info')"/>
                      </span>
                    </xsl:element>
                  </li>
                </xsl:if>
              </ul>

              <xsl:if test="person:profileInformation/extensions:customField[contains(extensions:typeClassification/core:uri, '/dk/atira/pure/person/customfields/CurriculumVitae') and extensions:value/core:localizedString]">
                <div id="cv{generate-id(.)}">
                  <div class="cv-info">
                      <xsl:apply-templates select="person:profileInformation/extensions:customField[contains(extensions:typeClassification/core:uri, '/dk/atira/pure/person/customfields/CurriculumVitae') and extensions:value/core:localizedString]/extensions:value" mode="localize" />
                  </div>
                </div>
              </xsl:if>

              <xsl:if test="person:profileInformation/extensions:customField[contains(extensions:typeClassification/core:uri, '/dk/atira/pure/person/customfields/ResearchAreas') and extensions:value/core:localizedString]">
                <div id="misc{generate-id(.)}">
                  <div class="further-info">
                      <xsl:apply-templates select="person:profileInformation/extensions:customField[contains(extensions:typeClassification/core:uri, '/dk/atira/pure/person/customfields/ResearchAreas') and extensions:value/core:localizedString]/extensions:value" mode="localize" />
                  </div>
                </div>
              </xsl:if>
              <xsl:if test="person:profileInformation/extensions:customField[contains(extensions:typeClassification/core:uri, '/dk/atira/pure/person/customfields/ResearchAndEducationInformation') and extensions:value/core:localizedString]">
                <div id="extra{generate-id(.)}">
                  <div class="extra-info">
                    <xsl:apply-templates select="person:profileInformation/extensions:customField[contains(extensions:typeClassification/core:uri, '/dk/atira/pure/person/customfields/ResearchAndEducationInformation') and extensions:value/core:localizedString]/extensions:value" mode="localize" />
                  </div>
                </div>
              </xsl:if>
            </xsl:element>
          </xsl:if>
          <br />
        </div>
      </xsl:for-each>
    </div>
  </xsl:template>


  <xsl:template match="typo3/links/keywordUrl">
    <li>
      <xsl:element name="a">
        <xsl:attribute name="class">
          <xsl:text>pure-tab</xsl:text>
          <xsl:if test="$tabIndexToOpen='KEYWORDCLASS'">
            <xsl:text> pure-tab-open</xsl:text>
          </xsl:if>
        </xsl:attribute>
        <xsl:attribute name="href">
          <xsl:value-of select="."/>
        </xsl:attribute>
        <span>
          <xsl:value-of select="ll:getLL('research')"/>
        </span>
      </xsl:element>
    </li>
  </xsl:template>

  <xsl:template match="typo3/links/cvUrl">
    <li>
      <xsl:element name="a">
        <xsl:attribute name="class">
          <xsl:text>pure-tab</xsl:text>
          <xsl:if test="$tabIndexToOpen='CVCLASS'">
            <xsl:text> pure-tab-open</xsl:text>
          </xsl:if>
        </xsl:attribute>
        <xsl:attribute name="href">
          <xsl:value-of select="."/>
        </xsl:attribute>
        <span>
          <xsl:value-of select="ll:getLL('cv')"/>
        </span>
      </xsl:element>
    </li>
  </xsl:template>

  <xsl:template match="typo3/links/publicationUrl">
    <li>
      <xsl:element name="a">
        <xsl:attribute name="class">
          <xsl:text>pure-tab</xsl:text>
          <xsl:if test="$tabIndexToOpen='PUBCLASS'">
            <xsl:text> pure-tab-open</xsl:text>
          </xsl:if>
        </xsl:attribute>
        <xsl:attribute name="href">
          <xsl:value-of select="."/>
        </xsl:attribute>
        <span>
          <xsl:value-of select="ll:getLL('publications')"/>
        </span>
      </xsl:element>
    </li>
  </xsl:template>

  <xsl:template match="typo3/links/activitiesUrl">
    <li>
      <xsl:element name="a">
        <xsl:attribute name="class">
          <xsl:text>pure-tab</xsl:text>
          <xsl:if test="$tabIndexToOpen='ACTCLASS'">
            <xsl:text> pure-tab-open</xsl:text>
          </xsl:if>
        </xsl:attribute>
        <xsl:attribute name="href">
          <xsl:value-of select="."/>
        </xsl:attribute>
        <span>
          <xsl:value-of select="ll:getLL('activities')"/>
        </span>
      </xsl:element>
    </li>
  </xsl:template>

  <xsl:template match="//core:result/core:content/person:organisationAssociations/person:organisationAssociation/person:phone">
    <strong>
      <xsl:value-of select="ll:getLL('tel')"/>
      <xsl:text>: </xsl:text>
    </strong>
    <span class="tel">
      <xsl:choose>
        <xsl:when test="string-length(.)=8">
          <xsl:value-of select="ll:getLL('phoneprefix.DK')"/>
          <xsl:value-of select="substring(.,1,4)"/>
          <xsl:text> </xsl:text>
          <xsl:value-of select="substring(.,5,4)"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="."/>
        </xsl:otherwise>
      </xsl:choose>
    </span>
    <br />
  </xsl:template>

  <xsl:template match="//core:result/core:content/person:organisationAssociations/person:organisationAssociation/person:mobilePhone">
    <strong>
      <xsl:value-of select="ll:getLL('mobile')"/>
      <xsl:text>: </xsl:text>
    </strong>
    <span class="tel">
      <xsl:choose>
        <xsl:when test="string-length(.)=8">
          <xsl:value-of select="ll:getLL('phoneprefix.DK')"/>
          <xsl:value-of select="substring(.,1,4)"/>
          <xsl:text> </xsl:text>
          <xsl:value-of select="substring(.,5,4)"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="."/>
        </xsl:otherwise>
      </xsl:choose>
    </span>
    <br />

  </xsl:template>

  <xsl:template match="//core:result/core:content/person:organisationAssociations/person:organisationAssociation/person:fax">
    <span class="tel">
      <span class="type">
        <strong>
          <xsl:value-of select="ll:getLL('fax')"/>
          <xsl:text>: </xsl:text>
        </strong>
      </span>
      <span class="value">
        <xsl:choose>
          <xsl:when test="string-length(.)=8">
            <xsl:value-of select="ll:getLL('phoneprefix.DK')"/>
            <xsl:value-of select="substring(.,1,4)"/>
            <xsl:text>&#160;</xsl:text>
            <xsl:value-of select="substring(.,5,4)"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="."/>
          </xsl:otherwise>
        </xsl:choose>
      </span>
    </span>
    <br />
  </xsl:template>

  <xsl:template match="//core:result/core:content/person:organisationAssociations/person:organisationAssociation/emailLink">
    <strong>
      <xsl:value-of select="ll:getLL('email')"/>
      <xsl:text>: </xsl:text>
    </strong>
    <span class="email">
      <xsl:value-of select="." disable-output-escaping="yes"/>
    </span>
    <br />
  </xsl:template>

  <xsl:template match="//core:result/core:content/person:organisationAssociations/person:organisationAssociation/person:address/extensions:room">
    <strong>
      <xsl:value-of select="ll:getLL('office')"/>
      <xsl:text>: </xsl:text>
    </strong>
    <xsl:element name="a">
      <xsl:attribute name="href">
        <xsl:value-of select="ll:getLL('building_url')"/>
        <xsl:value-of select="str:tokenize(., '-')[1]"/>
        <xsl:text>.htm</xsl:text>
      </xsl:attribute>
      <xsl:value-of select="ll:getLL('buildingShort')"/>
      <xsl:text>&#160;</xsl:text>
      <xsl:value-of select="str:tokenize(., '-')[1]"/>
    </xsl:element>

    <xsl:if test="str:tokenize(., '-')[2]">
      <xsl:text>&#160;</xsl:text>
      <xsl:value-of select="ll:getLL('roomShort')"/>
      <xsl:text>&#160;</xsl:text>
      <xsl:value-of select="str:tokenize(., '-')[2]"/>
    </xsl:if>
    <br />
  </xsl:template>

  <xsl:template match="//core:result/core:content/person:organisationAssociations/person:organisationAssociation">

    <!--TODO: Organisation url not present in PURE4?-->
    <!--<xsl:choose>
      <xsl:when test="ll:localize(url_pri, url_sec)">
        <a href="{ll:localize(url_pri, url_sec)}">
          <xsl:apply-templates select="person:organisation/organisation:name" mode="localize" />
        </a>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-templates select="person:organisation/organisation:name" mode="localize" />
      </xsl:otherwise>
    </xsl:choose>-->
    <xsl:apply-templates select="person:organisation/organisation:name" mode="localize" />

  </xsl:template>

</xsl:stylesheet>