<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns="http://www.w3.org/1999/xhtml"
                xmlns:fn="http://www.w3.org/2005/02/xpath-functions"
                xmlns:regexp="http://exslt.org/regular-expressions"
                xmlns:ll="http://typo3.org/extensions/repository/view/pure/current/"
                xmlns:str="http://exslt.org/strings" 
                
                xmlns:core="http://atira.dk/schemas/pure4/model/core/stable"
                
                exclude-result-prefixes="fn str regexp ll core">
  <xsl:import href="localization.xsl" />
  <xsl:param name="ll:localizationFile" select="'locallang_keyword.xml'" />
  <xsl:output encoding="utf-8" />
  <!--<xsl:key name="firstKeywordKey" match="//compilations/item/paths/item" use="keywords/item[1]/id" />-->

  <xsl:param name="ll:locale" select="'da_DK'" />

  <!--The input is a hiearchy core:topLevel/core:node/core:children/core:node....-->

  <xsl:template match="/">
    <div class="person-keyword">
      <xsl:for-each select="//core:topLevel/core:node">
        <h3>
          <xsl:choose>
            <xsl:when test="keywordUrl">
              <a href="{keywordUrl}">
                <xsl:apply-templates select="core:classification/core:term" mode="localize" />
              </a>
            </xsl:when>
            <xsl:otherwise>
              <xsl:apply-templates select="core:classification/core:term" mode="localize" />
            </xsl:otherwise>
          </xsl:choose>
        </h3>
        <p>
          <!--New style: Generate hiearchy. Easier to read.-->
          <xsl:if test="core:children">
            <ul>
              <xsl:for-each select="core:children">
                <xsl:apply-templates select="."/>
              </xsl:for-each>
            </ul>
          </xsl:if>
          
          <!--Old style. TODO: Make it work if people realy want it!. For each leaf generate-->
          <!--<xsl:for-each select=".//core:node[not(core:children)]">

            <xsl:for-each select="keywords/item[position()>1]">
              <a href="{keywordUrl}">
                <xsl:value-of select="ll:localize(title_pri, title_sec)"/>
              </a>
              <xsl:if test="position()!=last()">
                <span class="au-pil"> &#9658; </span>
              </xsl:if>
            </xsl:for-each>
            <xsl:for-each select="userKeywords/item">
              <span class="au-pil"> &#8226; </span>
              <xsl:value-of select="ll:localize(title_pri, title_sec)"/>
            </xsl:for-each>
            <br />

          </xsl:for-each>-->
        </p>
      </xsl:for-each>
    </div>
  </xsl:template>

  <xsl:template match="core:node">
    <li>
      <xsl:choose>
        <xsl:when test="keywordUrl">
          <a href="{keywordUrl}">
            <xsl:apply-templates select="core:classification/core:term" mode="localize" />
          </a>    
        </xsl:when>
        <xsl:otherwise>
          <xsl:apply-templates select="core:classification/core:term" mode="localize" />
        </xsl:otherwise>
      </xsl:choose>


      <xsl:choose>
        <xsl:when test="core:userDefinedKeyword[@locale=$ll:locale]">
          <xsl:for-each select="core:userDefinedKeyword[@locale=$ll:locale]/core:freeKeyword">
            <span class="au-pil"> &#8226; </span>
            <xsl:value-of select="."/>
          </xsl:for-each>
        </xsl:when>
        <xsl:otherwise>
          <xsl:for-each select="core:userDefinedKeyword[1]/core:freeKeyword">
            <span class="au-pil"> &#8226; </span>
            <xsl:value-of select="."/>
          </xsl:for-each>
        </xsl:otherwise>
      </xsl:choose>
      
      <xsl:if test="core:children">
        <ul>
          <xsl:for-each select="core:children">
            <xsl:apply-templates select="."/>
          </xsl:for-each>
        </ul>
      </xsl:if>
    </li>
  </xsl:template>


</xsl:stylesheet>