<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns="http://www.w3.org/1999/xhtml"
                xmlns:fn="http://www.w3.org/2005/02/xpath-functions"
                xmlns:regexp="http://exslt.org/regular-expressions"
                xmlns:ll="http://typo3.org/extensions/repository/view/pure/current/"
                xmlns:date="http://exslt.org/dates-and-times"
                xmlns:str="http://exslt.org/strings" 
                xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
                xmlns:types="http://www.atira.dk/schemas/pure/services/types"
                xmlns:php="http://php.net/xsl"
                
                xmlns:core="http://atira.dk/schemas/pure4/model/core/stable"
                xmlns:publication="http://atira.dk/schemas/pure4/model/abstractpublication/stable"
                xmlns:person="http://atira.dk/schemas/pure4/model/abstractperson/stable"
                xmlns:extensions="http://atira.dk/schemas/pure4/model/extensions/stable"
                xmlns:organisation="http://atira.dk/schemas/pure4/model/abstractorganisation/stable"
                xmlns:event="http://atira.dk/schemas/pure4/model/abstractevent/stable"
                xmlns:publisher="http://atira.dk/schemas/pure4/model/abstractpublisher/stable"
                xmlns:stab="http://atira.dk/schemas/pure4/dk/model/publication/stable"
                xmlns:journal="http://atira.dk/schemas/pure4/model/abstractjournal/stable"
                
                exclude-result-prefixes="fn str regexp php xsi types ll date  core publication person extensions organisation event publisher stab journal"
                
                >
  <xsl:import href="localization.xsl" />
  <xsl:param name="ll:localizationFile" select="'locallang_publication.xml'" />
  
  <xsl:output encoding="utf-8" />

  <xsl:template match="/">
    <div class="pure-simple-publication" >
      <xsl:for-each select="//core:result/core:content">
        <h1 style="text-transform: none;">
          
          <!--Find category using publication:typeClassification/core:uri-->
          <xsl:if test="contains(publication:typeClassification/core:uri, 'research')">
            <xsl:value-of select="ll:getLL('category.Research', 'Research')"/>
          </xsl:if>
          <xsl:if test="contains(publication:typeClassification/core:uri, 'communication')">
            <xsl:value-of select="ll:getLL('category.Information', 'Information')"/>
          </xsl:if>
          <xsl:if test="contains(publication:typeClassification/core:uri, 'education')">
            <xsl:value-of select="ll:getLL('category.Education', 'Education')"/>
          </xsl:if>
          <xsl:if test="contains(publication:typeClassification/core:uri, 'commissioned')">
            <xsl:value-of select="ll:getLL('category.Commissioned', 'Commissioned')"/>
          </xsl:if>
          <xsl:if test="publication:typeClassification/core:term">
            <xsl:text> · </xsl:text>
            <xsl:apply-templates select="publication:typeClassification/core:term" mode="localize"/>
          </xsl:if>
          
          <!-- TODO: State?-->
          <!--<xsl:if test="state != 'Published'">
            <sup>
              <span class="pubstatus">
                <xsl:value-of select="ll:getLL(concat('state.', state), state)"/>
              </span>
            </sup>
          </xsl:if>-->
        </h1>
        
        <table class="nyt" style="margin-top: 15px;" cellspacing="0" cellpadding="0" border="0">
          <!--String-->
          <!--///////////////  Publicatin Type Fields Start  //////////////////// -->
          <!--Types: http://vbn.aau.dk/ws/rest/allowedtypes?family=dk.atira.pure.api.shared.model.base_du.publication.Publication-->
          <!--TODO Namespaces:http://vbn.aau.dk/ws/rest/publications?rendering=xml_long&window.offset=0&window.size=100&uuids.uuid=bb29680b-a77b-4240-81ba-e030b88dc2e0-->
          
          <xsl:apply-templates select="publication:title" />
          <xsl:apply-templates select="publication:subtitle" />
            <!--TranslatedTitle/LocalizedString /TranslatedSubtitle/LocalizedString-->

          <xsl:apply-templates select="publication:persons" />
          
          <xsl:apply-templates select="publication:abstract" />
          <!--<xsl:apply-templates select="abstractTranslated" />-->

          <xsl:apply-templates select="publication:language" />

          <xsl:apply-templates select="publication:numberOfPages" />

          <!--<xsl:apply-templates select="publication:submissionYear" />-->

          <xsl:apply-templates select="publication:publicationDate" />

          <!--///////////////  Publicatin Type Fields End  //////////////////// -->

          <!--Apply for type-->
          <xsl:apply-templates select="." />
          
          
          

          <xsl:apply-templates select="publication:links" />
          <xsl:apply-templates select="publication:dois" />

          <!--@uuid?-->
          <xsl:apply-templates select="documentId" />

          <!--hmm gone?-->
          <xsl:apply-templates select="id" />
          <xsl:apply-templates select="publication:external" />

          <xsl:apply-templates select="publication:bibliographicalNote"/>
          
          
          
          <!--TODO: Proceding?-->
          <!--<xsl:apply-templates select="proceedingTitle" />
          <xsl:apply-templates select="proceedingSubtitle" />-->
          
          <!--String-->
          <!--TODO: conferenceNumber and Title?-->
          <!--<xsl:apply-templates select="conferenceNumber" />
          <xsl:apply-templates select="conferenceTitle" />
          --><!--String--><!--
          <xsl:apply-templates select="conferenceCity" />
          --><!--String--><!--
          <xsl:apply-templates select="conferenceCountry" />-->
          
          <!--TODO:-->
          <!--xsl:apply-templates select="startDate" />
          <xsl:apply-templates select="endDate" />
          --><!--String-->
          
          
          <!--<xsl:apply-templates select="ll:localize(publisher/title_pri, publisher/title_sec)" />-->
          <!--<xsl:apply-templates select="publication:associatedPublisher/publisher:placeOfPublication" />-->
          
          
          
          
          
          <!--Should be publication:journal/issns list-->
          <!--<xsl:apply-templates select="publication:journal/journal:issns" />-->

          
          
          <!--TODO: Find-->
          <!-- Links field? -->
          <!--<xsl:apply-templates select="fulltextFiles" />--><!--Liste-->
          
          
          
          <!--List : TODO-->
          <!--<publication:links>
          <extensions:link id="30855773">
          <extensions:url>http://www.cs.auc.dk/~normark/laml</extensions:url>
          </extensions:link>
          </publication:links>-->

          <!--Liste-->


          
          
        </table>
      </xsl:for-each>
    </div>
  </xsl:template>


  <!--
            Types:
  
            ContributionToJournal
            ContributionToBookAnthology
            BookAnthology
            ContributionToNewspaper
            WorkingPaper
            NetPublication
            ContributionToConference
            NonTextual
            Patent
            Memorandum
            ContributionToMemorandum
            OtherContribution
            -->
  
  <xsl:template match="core:content[contains(core:type, 'ContributionToJournal')]">
    <!--Journal, journalNumber, pages, volume, Event, peerReview, -->
    <!--Journal title?-->
    <xsl:apply-templates select="publication:journal" />
    <xsl:apply-templates select="publication:volume" />
    <xsl:apply-templates select="publication:journalNumber" />
    <xsl:apply-templates select="publication:pages" />
    
  </xsl:template>

  <xsl:template match="core:content[contains(core:type, 'ContributionToBookAnthology')]">
    <xsl:apply-templates select="publication:hostPublicationTitle" />
    <xsl:apply-templates select="publication:hostPublicationSubTitle" />
    <xsl:apply-templates select="publication:hostEditors[publication:hostEditor[node()]]" />
    <xsl:apply-templates select="publication:associatedPublishers/publisher:edition" /> <!--TODO: Use select="associatedPublishers"-->
    <xsl:apply-templates select="publication:pages" />
    <xsl:apply-templates select="stab:chapter" />

    <!--<publication:publicationSeries>
            <extensions:publicationSerie>
            <extensions:name>Lecture Notes in Computer Science</extensions:name>
            <extensions:printISSN>0302-9743</extensions:printISSN>
            <extensions:no>1710</extensions:no>
            </extensions:publicationSerie>
            </publication:publicationSeries>-->
    <xsl:apply-templates select="publication:publicationSeries" />
    
  </xsl:template>

  <xsl:template match="core:content[contains(core:type, 'BookAnthology')]">
    <xsl:apply-templates select="publication:associatedPublishers/publisher:edition" />
    <xsl:apply-templates select="publication:publicationSeries" />
  </xsl:template>

  <xsl:template match="core:content[contains(core:type, 'ContributionToNewspaper')]">
    <!--Same as ContributionToJournal. Should state news (Avis)-->
    
    <xsl:apply-templates select="publication:journal" />
    <xsl:apply-templates select="publication:volume" />
    <xsl:apply-templates select="publication:journalNumber" />
    <xsl:apply-templates select="publication:pages" />
  </xsl:template>

  <xsl:template match="core:content[contains(core:type, 'WorkingPaper')]">

    <xsl:apply-templates select="publication:associatedPublishers/publisher:edition" />
    <xsl:apply-templates select="publication:pages" />
    <xsl:apply-templates select="publication:publicationSeries" />
  </xsl:template>

  <xsl:template match="core:content[contains(core:type, 'NetPublication')]">
    <xsl:apply-templates select="publication:netPublicationType" />
    <xsl:apply-templates select="publication:publisher" />
  </xsl:template>

  <xsl:template match="core:content[contains(core:type, 'NonTextual')]">
    <xsl:apply-templates select="publication:publisher" />
    <xsl:apply-templates select="publication:publisher/publisher:edition" />
    <xsl:apply-templates select="publication:size" />
  </xsl:template>

  <!-- http://vbn.aau.dk/ws/rest/publications?rendering=xml_long&window.offset=0&window.size=10&typeClassificationUris.uri=/dk/atira/pure/publication/publicationtypes/patent/research/patent -->
  <xsl:template match="core:content[contains(core:type, 'Patent')]">
    <!--<stab:date>2010-03-25+01:00</stab:date>-->
    <xsl:apply-templates select="publication:ipc" />
    <xsl:apply-templates select="publication:patentNumber" />
    <xsl:apply-templates select="publication:publisher" />
    <xsl:apply-templates select="publication:date" />
    <xsl:apply-templates select="publication:country" />

  </xsl:template>

  <xsl:template match="core:content[contains(core:type, 'Memorandum')]">
    <xsl:apply-templates select="stab:projectNo" />
    <xsl:apply-templates select="stab:journalNo" />
    <xsl:apply-templates select="stab:dateFinished" />
    <xsl:apply-templates select="stab:applicant" />
    <xsl:apply-templates select="stab:publicationSeries" />
  </xsl:template>

  <xsl:template match="core:content[contains(core:type, 'ContributionToMemorandum')]">
    <xsl:apply-templates select="stab:projectNo" />
    <xsl:apply-templates select="stab:journalNo" />
    <xsl:apply-templates select="stab:dateFinished" />
    <xsl:apply-templates select="stab:applicant" />
    <xsl:apply-templates select="stab:publicationSeries" />
  </xsl:template>

  <xsl:template match="core:content[contains(core:type, 'OtherContribution')]">
    <xsl:apply-templates select="stab:stringType" />
    <xsl:apply-templates select="stab:publisher" />
    <xsl:apply-templates select="stab:publicationSeries" />
  </xsl:template>

  <xsl:template match="core:content">
  </xsl:template>

    <!-- Template for a  property - A singe row -->
  <xsl:template name="table-item">
    <xsl:param name="value" />
    <xsl:param name="title" />
    <tr valign="top">
      <td style="line-height: 20px; padding-right: 10px; color:#666666;" align="right" nowrap="nowrap">
        <xsl:copy-of select="$title"/>
        <xsl:text> :</xsl:text>
      </td>
      <td style="line-height: 20px;">
        <xsl:copy-of select="$value"/>
      </td>
    </tr>
  </xsl:template>

  <!-- ///////////////////////////////////////////////  -->
  <!-- /////////////Common Fields START //////////////  -->
  <!-- ///////////////////////////////////////////////  -->
  
  <!-- Templates for formating single properties -->
  <xsl:template match="//core:result/core:content/publication:title">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:value-of select="." disable-output-escaping="yes"/>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('title')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="//core:result/core:content/publication:subtitle">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:value-of select="." disable-output-escaping="yes"/>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('subtitle')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="//core:result/core:content/publication:language">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:apply-templates select="core:term" mode="localize" />
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('language')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="//core:result/core:content/publication:submissionYear">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:value-of select="."/>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('submissionYear')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <!--Authors-->
  <xsl:template match="//core:result/core:content/publication:persons">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:for-each select="./person:personAssociation[contains(./person:personRole/core:uri/text(), 'author')]">
          <xsl:choose>
            <xsl:when test="link/personUrl">
              <a href="{link/personUrl}">
                <xsl:value-of select="person:name/core:lastName"/>
                <xsl:text>, </xsl:text>
                <xsl:value-of select="person:name/core:firstName"/>
              </a>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="person:name/core:lastName"/>
              <xsl:text>, </xsl:text>
              <xsl:value-of select="person:name/core:firstName"/>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:if test="person:externalOrganisation">
            <xsl:text> (</xsl:text>
            <xsl:value-of select="person:externalOrganisation"/>
            <xsl:text>) </xsl:text>
          </xsl:if>
          <xsl:if test="position()!=last()">
            <br />
          </xsl:if>
        </xsl:for-each>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('authors')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="//core:result/core:content/publication:abstract">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:apply-templates select="." mode="localize" />
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('abstract')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="//core:result/core:content/publication:numberOfPages">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:value-of select="." disable-output-escaping="yes"/>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('numberOfPages')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="//core:result/core:content/publication:publicationDate">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:if test="core:day">
          <xsl:value-of select="core:day"/>
          <xsl:text>.</xsl:text>
        </xsl:if>
        <xsl:if test="core:month">
          <xsl:value-of select="core:month"/>
          <xsl:text>.</xsl:text>
        </xsl:if>
        <xsl:if test="core:year">
          <xsl:value-of select="core:year"/>
        </xsl:if>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('publicationDate')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="//core:result/core:content/publication:links">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:for-each select="extensions:link">
          <a href="{extensions:url}">
            <xsl:apply-templates select="extensions:description" mode="localize" />
          </a>
          <xsl:if test="position()!=last()">
            <br />
          </xsl:if>
        </xsl:for-each>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('links')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <!--<publication:dois>
          −
          <core:doi>
            <core:doi>10.1007/978-3-642-14075-4_18</core:doi>
          </core:doi>
          </publication:dois>-->
  <xsl:template match="//core:result/core:content/publication:dois">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:for-each select="core:doi">
          <a href="{concat('http://dx.doi.org/', core:doi)}">
            <xsl:value-of select="core:doi"/>
          </a>
          <xsl:if test="position()!=last()">
            <br />
          </xsl:if>
        </xsl:for-each>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('dois')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="//core:result/core:content/publication:external">
    <xsl:if test=". = 'true'">
      <xsl:call-template name="table-item">
        <xsl:with-param name="value">
          <xsl:value-of select="ll:getLL('producedExternal')"/>
        </xsl:with-param>
        <xsl:with-param name="title">
          <xsl:value-of select="ll:getLL('isExternal')"/>
        </xsl:with-param>
      </xsl:call-template>
    </xsl:if>
  </xsl:template>

  <xsl:template match="//core:result/core:content/publication:bibliographicalNote">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:apply-templates select="." mode="localize" />
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('bibliographicalNote')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <!-- /////////////////////////////////////////////  -->
  <!-- /////////////Common Fields END //////////////  -->
  <!-- /////////////////////////////////////////////  -->


  <!-- //////////////////////////////////////////////////////////////  -->
  <!-- /////////////ContributionToJournal Fields Start //////////////  -->
  <!-- //////////////////////////////////////////////////////////////  -->


  <!--publication:journal-->
  <xsl:template match="//core:result/core:content/publication:journal">
    <!--TODO: Not in the service-->
    
    <!--<xsl:call-template name="table-item">
      <xsl:with-param name="value">
        --><!--TODO--><!--
        --><!--<xsl:value-of select="journal:titles"/>--><!--
        --><!--Localize--><!--
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('journal_titles')"/>
      </xsl:with-param>
    </xsl:call-template>

    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:value-of select="journal:publisher" disable-output-escaping="yes"/>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('journal_publisher')"/>
      </xsl:with-param>
    </xsl:call-template>-->
    
  </xsl:template>

  <xsl:template match="//core:result/core:content/publication:volume">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:value-of select="." />
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('volume')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="//core:result/core:content/publication:journalNumber">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:value-of select="." />
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('journalNumber')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="//core:result/core:content/publication:pages">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:value-of select="." />
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('pages')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <!-- //////////////////////////////////////////////////////////////  -->
  <!-- /////////////ContributionToJournal Fields END ////////////////  -->
  <!-- //////////////////////////////////////////////////////////////  -->


  <!-- //////////////////////////////////////////////////////////////////////  -->
  <!-- /////////////ContributionToBookAnthology Fields START ////////////////  -->
  <!-- //////////////////////////////////////////////////////////////////////  -->

  <xsl:template match="//core:result/core:content/publication:hostPublicationTitle">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:value-of select="." disable-output-escaping="yes"/>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('hostPublicationTitle')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="//core:result/core:content/publication:hostPublicationSubTitle">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:value-of select="." disable-output-escaping="yes"/>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('hostPublicationSubTitle')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="//core:result/core:content/publication:associatedPublishers">

    <xsl:if test="publisher:edition">
      <xsl:call-template name="table-item">
        <xsl:with-param name="value">
          <xsl:value-of select="publisher:edition" disable-output-escaping="yes"/>
        </xsl:with-param>
        <xsl:with-param name="title">
          <xsl:value-of select="ll:getLL('edition')"/>
        </xsl:with-param>
      </xsl:call-template>
    </xsl:if>

    <xsl:if test="publisher:placeOfPublication">
      <xsl:call-template name="table-item">
        <xsl:with-param name="value">
          <xsl:value-of select="publisher:placeOfPublication" disable-output-escaping="yes"/>
        </xsl:with-param>
        <xsl:with-param name="title">
          <xsl:value-of select="ll:getLL('placeOfPublication')"/>
        </xsl:with-param>
      </xsl:call-template>
    </xsl:if>

    <xsl:if test="publisher:printIsbns">
      <xsl:call-template name="table-item">
        <xsl:with-param name="value">
          <xsl:for-each select="publisher:printIsbns/extensions:value">
            <xsl:value-of select="."/>
            <xsl:if test="position()!=last()">
              <br />
            </xsl:if>
          </xsl:for-each>
        </xsl:with-param>
        <xsl:with-param name="title">
          <xsl:value-of select="ll:getLL('printIsbns')"/>
        </xsl:with-param>
      </xsl:call-template>
    </xsl:if>

    <xsl:if test="publisher:electronicIsbns">
      <xsl:call-template name="table-item">
        <xsl:with-param name="value">
          <xsl:for-each select="publisher:electronicIsbns/extensions:value">
            <xsl:value-of select="."/>
            <xsl:if test="position()!=last()">
              <br />
            </xsl:if>
          </xsl:for-each>
        </xsl:with-param>
        <xsl:with-param name="title">
          <xsl:value-of select="ll:getLL('electronicIsbns')"/>
        </xsl:with-param>
      </xsl:call-template>
    </xsl:if>

    <xsl:if test="publisher:publisher/publisher:name">
      <xsl:call-template name="table-item">
        <xsl:with-param name="value">
          <xsl:value-of select="publisher:publisher/publisher:name" disable-output-escaping="yes"/>
        </xsl:with-param>
        <xsl:with-param name="title">
          <xsl:value-of select="ll:getLL('publisher_name')"/>
        </xsl:with-param>
      </xsl:call-template>
    </xsl:if>
    
  </xsl:template>

  <!--publication:hostEditors-->
  <xsl:template match="//core:result/core:content/publication:hostEditors">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:for-each select="publication:hostEditor">
          <xsl:value-of select="core:lastName"/>
          <xsl:text>, </xsl:text>
          <xsl:value-of select="core:firstName"/>
          <xsl:if test="position()!=last()">
            <br />
          </xsl:if>
        </xsl:for-each>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('editors')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="//core:result/core:content/stab:chapter">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:value-of select="." disable-output-escaping="yes"/>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('chapter')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="//core:result/core:content/publication:publicationSeries|//core:result/core:content/stab:publicationSeries">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:for-each select="extensions:publicationSerie[node()]">
          <xsl:if test="extensions:name">
            <xsl:value-of select="extensions:name" />
            <xsl:text>, </xsl:text>
          </xsl:if>
          <xsl:if test="extensions:publisherName">
            <xsl:value-of select="extensions:publisherName" />
            <xsl:text>, </xsl:text>
          </xsl:if>
          <xsl:if test="extensions:volume">
            <xsl:text>vol. </xsl:text>
            <xsl:value-of select="extensions:volume" />
            <xsl:text>, </xsl:text>
          </xsl:if>
          <xsl:if test="extensions:no">
            <xsl:value-of select="extensions:no" />
            <xsl:text>.</xsl:text>
          </xsl:if>
          <xsl:if test="position()!=last()">
            <br />
          </xsl:if>
        </xsl:for-each>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('publicationSeries')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <!-- ////////////////////////////////////////////////////////////////////  -->
  <!-- /////////////ContributionToBookAnthology Fields END ////////////////  -->
  <!-- ////////////////////////////////////////////////////////////////////  -->


  <!-- /////////////////////////////////////////////////////////  -->
  <!-- /////////////NetPublication Fields START ////////////////  -->
  <!-- /////////////////////////////////////////////////////////  -->

  <xsl:template match="//core:result/core:content/publication:netPublicationType">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:value-of select="." disable-output-escaping="yes"/>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('netPublicationType')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="//core:result/core:content[contains(core:type, 'NetPublication')]/publication:publisher">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:value-of select="." disable-output-escaping="yes"/>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('netPublication_publisher')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <!-- /////////////////////////////////////////////////////////  -->
  <!-- /////////////NetPublication Fields END   ////////////////  -->
  <!-- /////////////////////////////////////////////////////////  -->


  <!-- /////////////////////////////////////////////////////////  -->
  <!-- /////////////NonTextual Fields START ////////////////////  -->
  <!-- /////////////////////////////////////////////////////////  -->

  <xsl:template match="//core:result/core:content[contains(core:type, 'NonTextual')]/publication:publisher">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <!--TODO-->
        <xsl:value-of select="." disable-output-escaping="yes"/>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('NonTextual_publisher')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="//core:result/core:content/publication:size">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:value-of select="." disable-output-escaping="yes"/>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('size')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <!-- /////////////////////////////////////////////////////////  -->
  <!-- /////////////NonTextual Fields END   ////////////////////  -->
  <!-- /////////////////////////////////////////////////////////  -->


  <!-- /////////////////////////////////////////////////////////  -->
  <!-- /////////////Patent Fields START   //////////////////////  -->
  <!-- /////////////////////////////////////////////////////////  -->

  <!-- http://vbn.aau.dk/ws/rest/publications?rendering=xml_long&window.offset=0&window.size=10&typeClassificationUris.uri=/dk/atira/pure/publication/publicationtypes/patent/research/patent  -->
  
  <xsl:template match="//core:result/core:content/publication:ipc">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:value-of select="." disable-output-escaping="yes"/>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('ipc')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="//core:result/core:content/publication:patentNumber">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:value-of select="." disable-output-escaping="yes"/>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('patentNumber')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="//core:result/core:content/publication:date">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:value-of select="date:day-in-month(.)"/>
        <xsl:text>.</xsl:text>
        <xsl:value-of select="date:month-in-year(.)"/>
        <xsl:text>.</xsl:text>
        <xsl:value-of select="date:year(.)"/>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('date')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="//core:result/core:content[contains(core:type, 'Patent')]/publication:publisher">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:value-of select="." disable-output-escaping="yes"/>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('patent_publisher')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="//core:result/core:content/publication:country">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:apply-templates select="core:term" mode="localize" />
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('country')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>
  
  <!-- /////////////////////////////////////////////////////////  -->
  <!-- /////////////Patent Fields END   ////////////////////////  -->
  <!-- /////////////////////////////////////////////////////////  -->


  <!-- /////////////////////////////////////////////////////////  -->
  <!-- /////////////Memorandum Fields START   //////////////////////  -->
  <!-- /////////////////////////////////////////////////////////  -->


  <xsl:template match="//core:result/core:content/stab:projectNo">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:value-of select="." disable-output-escaping="yes"/>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('projectNo')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="//core:result/core:content/stab:journalNo">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:value-of select="." disable-output-escaping="yes"/>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('journalNo')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="//core:result/core:content/stab:dateFinished">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:value-of select="date:day-in-month(.)"/>
        <xsl:text>.</xsl:text>
        <xsl:value-of select="date:month-in-year(.)"/>
        <xsl:text>.</xsl:text>
        <xsl:value-of select="date:year(.)"/>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('dateFinished')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="//core:result/core:content/stab:applicant">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:value-of select="." disable-output-escaping="yes"/>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('applicant')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <!-- /////////////////////////////////////////////////////////  -->
  <!-- /////////////Memorandum Fields END   ////////////////////////  -->
  <!-- /////////////////////////////////////////////////////////  -->


  <!-- /////////////////////////////////////////////////////////  -->
  <!-- /////////////OtherContribution Fields START   //////////////////////  -->
  <!-- /////////////////////////////////////////////////////////  -->

  <xsl:template match="//core:result/core:content/stab:stringType">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value">
        <xsl:apply-templates select="." mode="localize" />
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('stringType')"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="//core:result/core:content[contains(core:type, 'OtherContribution')]/stab:publisher">
    <!--TODO-->
    
    <!--<xsl:call-template name="table-item">
      <xsl:with-param name="value">
        --><!--TODO--><!--
        <xsl:value-of select="." disable-output-escaping="yes"/>
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL('publisher')"/>
      </xsl:with-param>
    </xsl:call-template>-->
  </xsl:template>
  
  <!-- /////////////////////////////////////////////////////////  -->
  <!-- /////////////OtherContribution Fields END   ////////////////////////  -->
  <!-- /////////////////////////////////////////////////////////  -->


  <!-- All other are XML-types (HTML)--><!--
  <xsl:template match="//core:result/core:content/*">
    <xsl:call-template name="table-item">
      <xsl:with-param name="value" >
        <xsl:apply-templates />
      </xsl:with-param>
      <xsl:with-param name="title">
        <xsl:value-of select="ll:getLL(local-name())"/>
      </xsl:with-param>
    </xsl:call-template>
  </xsl:template>

  <xsl:template match="@*|node()">
    <xsl:copy>
      <xsl:apply-templates select="@*|node()"/>
    </xsl:copy>
  </xsl:template>-->

</xsl:stylesheet>