﻿<?xml version="1.0"?>
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:func="http://exslt.org/functions"
                xmlns:ll="http://typo3.org/extensions/repository/view/pure/current/"
                extension-element-prefixes="func"
                exclude-result-prefixes="ll">
  <xsl:param name="ll:pureSinglePidUrl" />

  <xsl:variable name="singlePidUrl">
    <xsl:choose>
      <xsl:when test="not(contains($pureSinglePidUrl, '?'))">
        <xsl:value-of select="concat($pureSinglePidUrl, '?')"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$pureSinglePidUrl"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:variable>
  
  <func:function name="ll:getImage">
    <xsl:param name="imageUrl" />
    <xsl:param name="width" />
    <xsl:param name="heigth" />
    <xsl:choose>
      <xsl:when test="starts-with($imageUrl, 'http://pure3a.au.dk:8080/ws/fbspretrieve/')">
        <func:result select="concat($singlePidUrl, 
                            '&amp;tx_pure_pi[imageId]=', substring-after($imageUrl, 'http://pure3a.au.dk:8080/ws/fbspretrieve/'), 
                            '&amp;tx_pure_pi[width]=', $width, 
                            '&amp;tx_pure_pi[height]=', $heigth)" />
      </xsl:when>
      <xsl:otherwise>
        <func:result select="$imageUrl" />
      </xsl:otherwise>
    </xsl:choose>
    
  </func:function>
</xsl:stylesheet>
