<?xml version="1.0"?>
<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:func="http://exslt.org/functions"
                xmlns:ll="http://typo3.org/extensions/repository/view/pure/current/"
                
                xmlns:core="http://atira.dk/schemas/pure4/model/core/stable" 
                
                extension-element-prefixes="func"
                exclude-result-prefixes="ll core">
  
  <xsl:param name="ll:localizationFile" select="'locallang.xml'" />
  <!-- The parameter below are also set from PHP. 
        ll:lang is the current language (tslib_pibase->LLkey).
        ll:prilang are set by TS using 'pure_primary_lang'.-->
  <xsl:param name="ll:lang" select="'default'" />
  <xsl:param name="ll:prilang" select="'default'" />
  <xsl:param name="ll:locale" select="'da_DK'" />

  <xsl:variable name="doc" select="document($ll:localizationFile)" />


  <!--<xsl:template match="*[core:localizedString]">
    <xsl:choose>
      <xsl:when test="core:localizedString[@locale=$ll:locale]">
        <xsl:value-of select="core:localizedString[@locale=$ll:locale]" />
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="core:localizedString[1]" />
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>-->

  <xsl:template match="*[core:localizedString]" mode="localize">
    <xsl:choose>
      <xsl:when test="core:localizedString[@locale=$locale]">
        <xsl:value-of select="core:localizedString[@locale=$locale]/text()" disable-output-escaping="yes" />
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="core:localizedString[1]/text()" disable-output-escaping="yes" />
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>


  <!-- Returns the label with the given key under the current language. 
        If it do not exist it chech the 'default' element,
        and if this do not exist it returns the second parameter, $alt.
        If $alt is not given return the $key.-->
  <func:function name="ll:getLL">
    <xsl:param name="key" />
    <xsl:param name="alt" />
    <xsl:choose>
      <xsl:when test="$doc/T3locallang/data/languageKey[@index=$lang]/label[@index=$key]">
        <func:result select="$doc/T3locallang/data/languageKey[@index=$lang]/label[@index=$key]" />
      </xsl:when>
      <xsl:when test="$doc/T3locallang/data/languageKey[@index='default']/label[@index=$key]">
        <func:result select="$doc/T3locallang/data/languageKey[@index='default']/label[@index=$key]" />
      </xsl:when>
      <xsl:when test="$alt">
        <func:result select="$alt" />
      </xsl:when>
      <xsl:otherwise>
        <func:result select="$key" />
      </xsl:otherwise>
    </xsl:choose>
  </func:function>

  <!-- Localize by returning $pri, if the current language is prilang ('dk').
        Otherwise it returns $sec if it exist, else return $pri. -->
  <func:function name="ll:localize">
    <xsl:param name="pri" />
    <xsl:param name="sec" />

    <xsl:choose>
      <xsl:when test="$pri and $lang=$prilang">
        <func:result select="$pri" />
      </xsl:when>
      <xsl:when test="$sec">
        <func:result select="$sec" />
      </xsl:when>
      <xsl:when test="$pri">
        <func:result select="$pri" />
      </xsl:when>
      <xsl:otherwise>
        <func:result select="false()" />
      </xsl:otherwise>
    </xsl:choose>
  </func:function>

  <!--<func:function name="ll:localizeTerm">
    <xsl:param name="term" />

    <xsl:choose>
      <xsl:when test="$term/core:localizedString[@locale=$locale]">
        <func:result select="$term/core:localizedString[@locale=$locale]" />
      </xsl:when>
      <xsl:otherwise>
        <func:result select="$term/core:localizedString[0]" />
      </xsl:otherwise>
    </xsl:choose>
    <func:result select="$term/core:localizedString[0]" />
  </func:function>-->
  
</xsl:stylesheet>